{$R+}
{$N+}
{$M$ff00,0,$a0000}

UNIT ctvu1;                     {30.03.2000 / shu}


INTERFACE                       {UNIT ctvu1}


{Allgemeine Deklarationen:}
{
Hinweis: die Namen der Variablen sind nicht immer ganz genau zu nehmen.
         'flen' etwa heit zwar 'Feldlnge', weil das Feld aber bei 0
          beginnt, gibt es insgesamt flen+1 Elemente. Also Obacht!
}

CONST
  clpc=                 3;      {command line param count}

TYPE
  clpt=                 ARRAY[0..clpc-1] OF string[4];
  cldt=                 ARRAY[0..clpc-1] OF string[20];

CONST
  clp:clpt=             ('/f',  {command line param}
                         '/nc',
                         '/ns');
  cld:cldt=             ('force assembly',      {command line description}
                         'no cross reference',
                         'no symbol table');

TYPE
  ht=                   ARRAY[0..15] OF char;   {hex-typ}

CONST
  vers_dat=             'Version 3.06 vom 30.03.2000';
  mail_und_http=        '   (mailto:rudolf@dose.muc.de, http://www.muc.de/~rudolf)';
  zdiva_div=            100;            {Divisor bei zdiva}
  h:ht=                 '0123456789ABCDEF';
  al=                   30;
                          {array limit: Lnge der Felder len u. zlboc}

  mgtnfb=               8;              {max_gtnf bits}
  max_gtnf=             (1 SHL mgtnfb) - 1;{maximale Gre des Teil Namensfeldes}
  max_nf_sel=           31;             {maximaler Teil-'nf'-Selektor}
  {
  Mit obigen Werten kann ein Namensfeld aus maximal 32 Teil Namens-
  feldern mit jeweils 256 Eintrgen bestehen. Ob der Heap das auch hergibt,
  ist eine andere Frage.
  }

  max_cl=               15;             {max. Character-lnge fr Namen}
  anznh=                max_cl+1;       {Anzahl Namenshaufen}
  flen=                 254;            {Feldlnge}
  islen=                20;             {IF-stack-lnge}
  cbpz=                 5;              {code bytes pro Zeile}
  zppmax=               maxlongint;     {Zeilen pro page maximum}
  zppdef=               57;             {Zeilen pro page default}
  bfrbl=                128;            {binary file read buffer len}

TYPE
  krznt=                ARRAY[0..max_cl] OF char;       {kurzer Namenstyp}
  sftyp=                ARRAY[0..flen] OF char;
  string_flenp1=        string[flen+1];
  string_255=           string[255];
  iftyp=                ARRAY[0..flen] OF longint;
  zcrrt=                ^crr;           {Zeiger auf crr typ}
  crr=  RECORD                          {cross referenz record}
          glob_zeile:   longint;        {globale Zeile(nnummer)}
          zcrr:         zcrrt;
        END;
  znr=                  ^nr;            {Zeiger auf Namens-record}
  nr=   RECORD                          {Namens-record}
    ozs:                longint;        {Operandenzahl Sollwert: -1:un-}
                                        {bestimmt, >-1: gilt die Zahl}
    nt:                 longint;        {Namenstyp: 0:Pmacro, 1:Pseudoop.}
                                        {2:Macro, 3:vordef. Var., 4:als label}
                                        {und mit EQU def. Var., 5:redefinable}
                                        {Var., 6/7:local macro label(taucht}
                                        {hier aber nicht auf), 8:vordef. Fkt.}
                                        {9:redefinable Var nach Lauf 1}
    wert:               longint;        {Wert des Namens: bei Pmacros, Pseudo-}
                                        {op's und Macros erfolgt etwa li-}
                                        {neare Numerierung, bei Variablen:}
                                        {Wert}
    name:               krznt;          {Name}
    zcrr:               zcrrt;
        END;
  tnft=                 ARRAY[0..max_gtnf] OF znr;     {Teil Namensfeld typ}
  ztnft=                ^tnft;          {Zeiger auf Teil Namensfeld typ}
  nft=                  ARRAY[0..max_nf_sel] OF ztnft;
  gnr=  RECORD                          {globaler Namens-record}
    nf:                 nft;
                          {Namensfeld}
    azn:                longint;
                          {aktuelle Zahl von Namen}
    enh:                ARRAY[0..anznh] OF longint;
                          {Ende der 'Namens-haufen'}
        END;

  tlen=                 ARRAY[0..al] OF longint;
  tzlboc=               ARRAY[0..al] OF sftyp;
  tzzlboc=              ^tzlboc;
  fbt=                  FILE OF byte;
  bfrr=RECORD                           {binary file read record}
    bfr:                FILE;           {binary file read}
    bfrb:               ARRAY[1..bfrbl] OF byte;  {binary file read buffer}
    bfrbf:              longint;        {binary file read buffer fllstand}
    bfrbp:              longint;        {binary file read buffer pointer}
        END;                            {RECORD}
  {
  Die Philosophie fr 'bfrr' sieht so aus: die Routinen 'reset', 'read' und
  'eof', welche direkt auf das Systemfile 'bfr' wirken, werden durch eigene
  Routinen, etwa 'myreset', 'myread' und 'myeof' ausgetauscht.
    Dabei fhrt 'myreset' natrlich zuallererst 'reset' aus und setzt 'bfrbf'
  und 'bfrbp' auf 0.
    'myread' liefert ein Byte zurck (,falls mglich. Ansonsten gibt es
  eine Fehlermeldung). Solange 'bfrbp' kleiner 'bfrbf' ist, liegen in 'bfrb'
  noch abzuholende Daten. Eine echte Leseaktion vom Systemfile wird erst
  durchgefhrt, wenn Gleichstand herrscht. Dies wird mit 'BlockRead' durch-
  gefhrt. Dabei wird versucht, 'bfrbl' Bytes zu lesen, d.h., 'bfrb'
  vollstndig aufzufllen. Dies wird auch meistens gelingen, bis auf den
  Fall, wenn wir uns dem Ende des Systemfiles nhern. Dann wird 'bfrbf'
  eben nicht mehr auf Maximum ('bfrbl'), sondern nur noch auf die aktuell
  gelesene Blockgre gesetzt.
  'myeof' schlielich prft zunchst, ob noch Bytes im Buffer sind. Erst
  wenn der Buffer ('bfrb') leer ist, wird ein echtes 'eof' aufgerufen.
  }

VAR
  is:                   ARRAY[0..islen] OF boolean;     {IF-stack}
  isp:                  longint;        {IF-stack-pointer}
  list_state:           longint;        {0:NOLIST, 1:LIST, 2:EXPAND}
  ier:                  longint;        {include-expand-read(macro)-flag:}
                                        {0:keine Aktion, 1:include_file,}
                                        {2:expand_macro, 3:lies/skip_macro:}
                                        {MACRO,4:expand_pmacro, 5:lies/skip_}
                                        {macro: PMACRO}
  fil:                  longint;        {file include level}
  zb:                   char;           {Zeile bearbeiten}
  zl:                   char;           {Zeile listen}
  lst:                  text;
  obj:                  fbt;
  tmpw:                 text;
  tmpr:                 bfrr;
  tmpw_open, tmpr_open: boolean;
  lst_open, obj_open:   boolean;
  fname_usp:            string_255;     {Filename fr Ursprungsfile}
  fname_tmp:            string_255;     {Filename fr Temporrfile}
  fname_lst:            string_255;     {Filename fr Listfile}
  fname_obj:            string_255;     {Filename fr Objectfile}
  zeile:                longint;
  seite:                longint;        {Seiten-nummer}
  titel:                sftyp;
  len_titel:            longint;
  zpp:                  longint;        {Zeilen pro page}
  pzc:                  longint;        {page Zeilen count}
  ozi:                  longint;        {Operanden-zahl-istwert}
  info:                 string_flenp1;
  len:                  tlen;
                          {Lnge Zeile, Labels, Befehle, Operanden,}
                          {Kommentare: 0: Zeile, 1: Label, 2: Befehl,}
                          {3..(al-1): Operanden, al: Kommentar}

  zlboc:                tzlboc;
                          {Feld fr Zeile, Label, Befehl, Operanden,}
                          {Kommentar}
  nfb:                  gnr;            {Namensfeld (Befehle)}
  nfl:                  gnr;            {Namensfeld (Labels)}

  pc:                   longint;
                          {Program counter}
  pcs:                  longint;
                          {Program counter 'step' (fr $)}
  aa:                   krznt;          {Adre-anzeige}
  aa_leer:              krznt;          {Adre-anzeige (leer)}
  pm_len:               longint;
  pm_zeile:             sftyp;
  warn_cnt:             longint;
  will_quervw:          boolean;        {Querverweistabelle?}
  will_symtab:          boolean;        {Symboltabelle?}

{Deklarationen im Zusammenhang mit Macros:}

CONST
  mgtmab=               14;             {max_gtma bits}
  max_gtma=             (1 SHL mgtmab) - 1;{maximale Gre des Teil Macro array}
  max_maca_sel=         11;             {maximaler 'ma'-Selektor}
  {
  Mit obigen Werten kann der gesamte Macrotext maximal 12 Teil Macro
  arrays mit jeweils 16K umfassen. Ob der Heap das auch hergibt, ist
  eine andere Frage.
  }

  mzlma=                5000;           {Zeilen-Lnge Macro array: maximale
                                          Gesamtzeilenzahl aller Macros}
  mzlema=               230;            {Zeilen-Lnge von ema: maximale
                                          Zeilenzahl von ema}
  mclema=               10000;          {Character-Lnge von ema: maximale
                                          Zeichenzahl in ema}
  mzm=                  500;            {Maximalzahl Macros}
  max_mel=              30;             {maximales macro-expand-level}

TYPE
  tmac_art=             ARRAY[0..max_gtma] OF char;     {Teil Macro array typ}
  ztmat=                ^tmac_art;      {Zeiger auf Teil Macro array typ}
  mat=                  ARRAY[0..max_maca_sel] OF ztmat;
  mac_zlent=            ARRAY[0..mzlma] OF longint; {Macro-zeilen-lnge-typ}
  zmac_zlent=           ^mac_zlent;     {Zeiger auf Macro-zeilen-lnge-typ}
  ema_type=             ARRAY[0..mclema] OF char;
  zema_type=            ^ema_type;      {Zeiger auf ema_type}
  zlltr=                ^lltr;          {Zeiger auf lltr}
  lltr= RECORD                          {local label table record}
          name_ml:      ARRAY[0..mzlema] OF krznt;
          name_len_ml:  ARRAY[0..mzlema] OF longint;
          gueltig_ml:   ARRAY[0..mzlema] OF boolean;     {true bei .SET}
          oft_ml:       ARRAY[0..mzlema] OF boolean;
            {true, wenn mehr als einmal im Macro vorhanden}
          wert_ml:      ARRAY[0..mzlema] OF longint;
          zeil_nr_ml:   ARRAY[0..mzlema] OF longint;
          ze:           ARRAY[0..mzlema] OF longint;
            {Zeilenende (zeigt eigentlich schon auf den nchsten Start)}
          anz_ml:       longint;        {ml fr 'macro label'}
          me:           longint;
            {Macroende (zeigt eigentlich schon auf den nchsten Start)}
        END;

VAR
  mcr:                  longint;        {macro count bei read}
  mce:                  longint;        {macro count bei expand}
  mel:                  longint;        {macro expand level}
  spitze_mel:           longint;        {grtes aufgetretenes mel}
  mend_da:              boolean;
  ma:                   mat;            {Macro array}
  ima:                  longint;        {(aktueller) Index des Macro array}
  mzs:                  zmac_zlent;     {Macro-Zeilen-start}
  mif:                  ARRAY[0..mzm] OF longint;
                        {Macro-index-feld}
  zzmr:                 longint;        {Zeilen-zhler bei Macro read}
  ema:                  zema_type;      {End-Macro-Array}
  llt:                  ARRAY[1..max_mel] OF zlltr;     {local label table}

{Deklarationen und Konstanten fr Funktionen:}

CONST
  ftblen=               1;      {Funktionen-tabellen-lnge}

TYPE
  fclat=                ARRAY[0..ftblen] OF longint;
                          {function-char-len-array-type}
  fkn=                  ARRAY[0..7] OF char;
  farat=                ARRAY[0..ftblen] OF fkn;


{Konstanten fr vordefinierte Funktionen:}

CONST
  fcla:fclat=           (  {Funktion-char-len-array der vordef. Fkt.}
     4,3                                        );

  fara:farat=           (  {Funtion-array fr vordefinierte Fkt.}
    'HIGH    ',
    'LOW     '                                  );


IMPLEMENTATION                  {UNIT ctvu1}


END.                            {UNIT ctvu1}
