{$R+}
{$N+}
{$M$ff00,0,$a0000}

PROGRAM look1;                  {01.01.2000 / shu}

{
Zur Compilierung mit TP:
Falls $R+, $N+ und $M$ff00,0,$a0000 im Quelltext drinstehen, braucht
beim expliziten Aufruf von tpc[x] ggf. nur noch /B eingegeben werden.
Ein Aufruf sieht also so aus:

tpc[x] look1 /B

Fuer fpc gilt:

Compilerschalter aus dem Quelltext wegnehmen und einfach compilieren mit:
ppc386 look1 -B -So

}

USES
  DOS, CRT;

TYPE 
  zftyp1=                       ARRAY[0..15] OF char;

CONST
  hexa:zftyp1=                  '0123456789abcdef';
  feld_laenge=                  255;
  kopf_len=                     28;

TYPE
  string_255=                   string[255];
  CARDINAL=                     0..MaxLongint;
  daten_typ=                    ARRAY[0..feld_laenge] OF byte;

VAR
  fname_in:                     string_255;
  fname_out:                    string_255;
  f_in:                         FILE OF byte;
  f_out:                        text;
  file_ist_da:                  boolean;
  rec_len:                      CARDINAL;
  dat_len:                      CARDINAL;
  start_adr:                    CARDINAL;
  daten:                        daten_typ;
  i:                            CARDINAL;
  chw:                          CARDINAL;

PROCEDURE beep;
  BEGIN                         {PROCEDURE beep}
    Sound(880);
    Delay(160);
    NoSound;
  END;                          {PROCEDURE beep}

PROCEDURE blank(VAR str1: string_255; count: longint);
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE blank}
    str1:='';
    FOR i:=1 TO count DO str1:=str1+' ';
  END;                          {PROCEDURE blank}
  
PROCEDURE int_nach_hex_fld(zahl,stellen:longint;VAR chf:string_255);
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE int_nach_hex_fld}
    blank(chf,stellen);
    FOR i:=stellen DOWNTO 1  DO
      BEGIN
        chf[i]:=hexa[zahl MOD 16];
        zahl:=zahl DIV 16;
      END;
  END;                          {PROCEDURE int_nach_hex_fld}

PROCEDURE hex_ausgabe(VAR wohin:text; number,digits:longint);
  VAR
    i:                          longint;
    chf:                        string_255;     {char.-field}
    noch_null:                  boolean;
  BEGIN                         {PROCEDURE hex_ausgabe}
    int_nach_hex_fld(number,digits,chf);
    noch_null:=true;
    FOR i:=1 TO digits-1 DO
      BEGIN
        noch_null:=noch_null AND (chf[i]='0');
        IF noch_null THEN write(wohin, ' ') ELSE write(wohin, chf[i]);
      END;                      {FOR i}
    write(wohin, chf[digits]);
  END;                          {PROCEDURE hex_ausgabe}

FUNCTION file_existiert(VAR fname: string_255):boolean;
  VAR
    fb:                         FILE OF byte;
  BEGIN                         {FUNCTION file_existiert}
    assign(fb,fname);
    {$I-} reset(fb); {$I+}
    IF ioresult<>0 THEN
      BEGIN
        file_existiert:=false;
      END                       {IF ioresult}
    ELSE
      BEGIN
        file_existiert:=true;
        close(fb);
      END;                      {ELSE ioresult}
  END;                          {FUNCTION file_existiert}

PROCEDURE lies_record(VAR daten: daten_typ; anz: CARDINAL);
  VAR
    i:                          CARDINAL;
    wert:                       byte;

  BEGIN                         {PROCEDURE lies_record}
    FOR i:=0 TO anz-1 DO
      BEGIN
        {$I-} Read(f_in, wert); {$I+}
        IF ioresult<>0 THEN
          BEGIN
            writeln('AUS');
            writeln;
            close(f_out);
            close(f_in);
            halt;
          END;                  {IF ioresult}
      daten[i]:=wert;
    END;                        {FOR i}
  END;                          {PROCEDURE lies_record}

BEGIN                           {PROGRAM look1}
  REPEAT
    writeln('Lesen von welchem Objectfile? (<RET> --> Programmende)');
    readln(fname_in);
    IF fname_in='' THEN halt;
    IF (NOT file_existiert(fname_in)) THEN
      BEGIN
        file_ist_da:=false;
        beep;
        writeln('File kann nicht geffnet werden');
        writeln;
      END                       {If (NOT...}
    ELSE file_ist_da:=true;
  UNTIL file_ist_da;

  REPEAT
    writeln('Schreiben auf welches Textfile? (<RET> --> Programmende)');
    readln(fname_out);
    IF fname_out='' THEN halt;
    IF file_existiert(fname_out) THEN
      BEGIN
        file_ist_da:=true;
        beep;
        writeln('File existiert bereits!');
        writeln;
      END                       {If (NOT...}
    ELSE file_ist_da:=false;
  UNTIL NOT file_ist_da;

  assign(f_in, fname_in);
  reset(f_in);
  assign(f_out,fname_out);
  rewrite(f_out);

  lies_record(daten, kopf_len); {Kopf berlesen}

  WHILE (NOT eof(f_in)) DO
    BEGIN

      write('.');

      lies_record(daten, 2);    {Recordlnge}
      chw:=daten[0];
      chw:=chw*256;
      chw:=chw+daten[1];
      rec_len:=chw;

      lies_record(daten, 2);    {Datenlnge}
      chw:=daten[0];
      chw:=chw*256;
      chw:=chw+daten[1];
      dat_len:=chw;

      lies_record(daten, 4);    {Startadresse}
      chw:=daten[2];
      chw:=chw*256;
      chw:=chw+daten[3];
      chw:=chw*256;
      chw:=chw+daten[0];
      chw:=chw*256;
      chw:=chw+daten[1];
      start_adr:=chw;

      lies_record(daten, rec_len-5);    {Daten}

      write(f_out, 'start_adr:  ');
      hex_ausgabe(f_out, start_adr, 8);
      writeln(f_out);

      write(f_out, 'dat_len:    ');
      hex_ausgabe(f_out, dat_len, 8);
      writeln(f_out);

      write(f_out, 'Daten:      ');
      IF (start_adr MOD 16)>0 THEN
        BEGIN
          writeln(f_out);
          hex_ausgabe(f_out, start_adr, 8);
          write(f_out, '  ');
          FOR i:=1 TO (start_adr MOD 16) DO
            BEGIN
              write(f_out, '    ');
            END;                {FOR i}
        END;                    {IF (start_adr...}

      FOR i:=0 TO dat_len-1 DO
        BEGIN
          IF ((start_adr+i) MOD 16)=0 THEN
            BEGIN
              writeln(f_out);
              hex_ausgabe(f_out, start_adr+i, 8);
              write(f_out, '  ');
            END;                {IF ((start_adr+i...}
          hex_ausgabe(f_out, daten[i], 4);
        END;                    {FOR i}
      writeln(f_out);
      writeln(f_out);

    END;                        {WHILE (NOT eof(f_in))}
  writeln;
  close(f_out);
  close(f_in);
END.                            {PROGRAM look1}

{
look1/08.06.96: Portierung GPM --> TP.

look1/07.07.96: Name des Outputfiles nicht einfach durch Addieren
        weiterer Buchstaben an den Originalnamen erzeugen. Namen, die
        bereits 8 Buchstaben haben, fhren dann ganz zwanglos zur
        Lschung des Originalfiles!
}
