{$R+}
{$N+}
{$M$ff00,0,$a0000}

PROGRAM zss3;                   {30.03.2000 / shu}

{
(Zss fr Zusammensetzer)

Zur Compilierung mit TP:
Falls $R+, $N+ und $M$ff00,0,$a0000 im Quelltext drinstehen, braucht
beim expliziten Aufruf von tpc[x] ggf. nur noch /B eingegeben werden
(Wegen Speicherplatzmangels lief mit tpc frueher mal nichts mehr).
Ein Aufruf sieht also so aus:

tpc[x] zss3 /B

Fuer fpc gilt:

Compilerschalter aus dem Quelltext wegnehmen und einfach compilieren mit:
ppc386 zss3 -B -So

}

USES
  CTVU1, ZSS3U1, ZSS3U2;


BEGIN                           {PROGRAM zss3}
  ganz;
END.                            {PROGRAM zss3}

{
 Kommentar zum Programm:        8.9.89/shu

 Wie man der Procedure 'ganz' entnehmen kann, handelt es sich hier um einen
 2-pass Assembler. Damit der Hhenflug (geistig gesehen) nicht zu hoch
 ausfllt wurde ein absoluter und nicht ein relocatable Assembler ange-
 strebt. Dieses Ziel scheint auch einigermaen erreicht worden zu sein.
 (Nebenbei bemerkt war auch nur ein 8085- und nicht ein Multi-prozessor-
 assembler geplant, wie er bei HP offensichtlich vorliegt. Zusatz: durch
 Einfhrung der Pmacros soll nicht nur ein 8085-Assembler mglich werden)
 Als 'groes Vorbild' diente der in der Firma unter TUNIX laufende
 HP64000-Cross-assembler. Es wurde versucht, die Syntax und Arbeitsweise
 weitgehend nachzuempfinden. Dort wo es angebracht schien, wurden dann
 aber gewisse Modifikationen implementiert. Die wesentlichen dieser Modi-
 fikationen sind:
   1.   File-INCLUDE-s sind beliebig tief erlaubt.
   2.   Geschachtelte Macro-aufrufe sind bis zu einer Tiefe von max_mel
        erlaubt.
   3.   File-INCLUDE-s und Macro-aufrufe knnen unter Beachtung von 1.
        und 2. auch beliebig gegenseitig geschachtelt werden. Allerdings
        ergeben sich dabei gewisse Einschrnkungen, was etwa die Ver-
        wendung von .SET, .NOP, .GOTO, .IF und lokalen Macro-variablen
        betrifft.
   4.   Einige der Pseudo-ops (etwa DATA, NAME u. dgl.) waren wegen
        des absoluten Assemblers nicht mehr ntig, andere (etwa REPT,
        ASC u. dgl.) wurden aus Faulheit einfach weggelassen.


 Bevor wir uns aber in ungeordnete Einzelheiten auflsen, versuchen wir
 mal, den ganzen Kram ein wenig zu gliedern:

   1.  Verwaltung der Namen:
     Es stellt sich heraus, da das Schreiben eines Assemblers vor allem
     auch damit zu tun hat, viele verschiedene Namen, Labels, Symbole etc.
     zu verwalten. Konkret beginnt dies mal mit den 1000 verschiedenen
     Assembler-befehlen. Weiter geht's dann mit den Namen fr Register
     (A, PSW etc.) und es endet nicht unbedingt bei dem Namen fr ein
     definiertes Macro. Als eine Lsungsmglichkeit wurde dabei die fol-
     gende Methode gewhlt:
     Alle vorkommenden Namen (auer den lokalen Macro-variablen, diese
     werden gesondert behandelt (siehe weiter unten)) werden, ihrer Character-
     lnge nach in einzelne "Namens-haufen" unterteilt, in einen groen
     Topf geworfen. Genauer: Es besteht ein Feld von Pointern (dies ist
     das ARRAY nf OF znr), dessen einzelne Elemente jeweils auf einen
     Namensrecord zeigen knnen. Man entnimmt der Definition von ganz oben,
     wie dieser Record im Detail aufgebaut ist. Das wesentliche ist, da
     alle vorkommenden Namen in dieses Feld aufgenommen werden (Ausnahme
     siehe oben). Die verschiedenen Namenstypen (0:PMACRO, 1:Pseudo-op etc.)
     werden zu unterschiedlichen Zeitpunkten generiert. Die Typen 1,
     8 etwa werden bei der 'initialisierung' festgelegt, andere Typen
     (4) werden beim ersten, (5) beim ersten und zweiten  Lauf eingetragen.

   2.  Erster Lauf:
     Jede Zeile des Quell-files wird in der Procedure 'include_file'
     gelesen und nach Label (l), Befehl (b), Operanden (o) und Kommen-
     tar (c) aufgeteilt (in 'include_file' bernimmt dies die Procedure
     'zeile_abgrasen' (in 'expand_(p)macro' bernimmt 'zeile_expandieren'
     diese Aufgabe, wie wir spter sehen werden)). Auerdem wird die
     gesamte gelesene Zeile (z) ebenfalls mit notiert. Diese gesamte
     Information wird im array 'zlboc' abgelegt. Anschlieend wird ver-
     sucht, die eben gelesene Zeile zu bearbeiten. Dabei treten im wesent-
     lichen 6 verschiedene Flle auf:

       1.       Es liegt ein sofort bearbeitbarer Befehl vor. Dies trifft
                auf die meisten der Pseudo-befehle zu. Im ersten Lauf
                bedeutet dies im Klartext, da die Anzahl der bentigten
                Bytes ermittelt werden mu, um den Program-counter entspre-
                chend weiterzuzhlen. Dies wiederum ist ntig, um auftre-
                tenden Labels einen entsprechenden Wert zuordnen zu knnen.

       2.       Der Pseudo-op INCLUDE wurde entdeckt. Im momentanen Quell-
                file wird erst weitergelesen, wenn alle Zeilen des bei
                INCLUDE spezifizierten Files gelesen wurden. Das Lesen
                eines Files wird wieder mit der Procedure 'include_file'
                erledigt (es liegt also Rekursion vor!).

       3.       Der Name eines (vorher definierten) Macros liegt vor.
                Im momentanen Quell-file wird erst weitergelesen, wenn
                der Macro expandiert worden ist. Die Procedure 'expand_macro'
                erledigt fr uns diese Aufgabe. Sie arbeitet hnlich der
                Procedure 'include_file' nur mit dem Unterschied, da sie
                Zeilen nicht aus einem File sondern im wesentlichen aus
                dem Macro-array 'ma' liest. Tatschlich werden in 'expand_
                macro' zunchst mit 'ersetze_parameter' bestimmte Para-
                meter-ersetzungen der aus 'ma' gelesenen Zeilen durchge-
                fhrt. Auerdem wird (ebenfalls in 'ersetze_parameter')
                eine lokale Label-tabelle (llt) fr alle im Macro auf-
                tauchenden Labels angelegt. Konkret heit dies:
                  Jede Zeichenfolge &&&& wird durch eine entsprechende
                Zeichenfolge abcd ersetzt. (Bsp.: beim ersten Aufruf eines
                Macros ist abcd=0001, beim zweiten ist abcd=0002 etc.).
                Im Programm werden diese Parameter als qap's (=quad ampersand
                paramter) bezeichnet.
                  Alle Index-paramter (das sind solche, die mit && anfangen
                und bei uns auch als dap's (double ampersand parameter)
                bezeichnet werden) mit einer Konstante als Wert (solche
                sind, glaube ich, bei HP nicht erlaubt (z.B. &&01)) werden
                durch den entsprechenden beim Macro-aufruf bergebenen
                Parameter ersetzt.
                  Die solchermaen ersetzten Zeilen werden in einem
                "endgltigen" Macro-array (ema), welches lokal in 'expand_
                (p)macro' deklariert ist, abgelegt. In die oben erwhnte
                'llt' werden dabei u.a. folgende Sachen eingtragen:
                  1.    (name_ml):
                        Name jedes auftretenden Macro-labels, welches keine
                        Zeichenfolge && mehr enthlt. (&& kann noch da sein,
                        weil in 'ersetze_paramter' noch nicht die dap's
                        mit einer Variablen (als Wert) durch den entsprechen-
                        den bergebenen Parameter ersetzt wurden (bei
                        uns ist dabei jede beliebige Variable zugelassen,
                        d.h. es sind nicht nur lokale Macro-variablen
                        erlaubt)).
                  2.    (zeil_nr_ml):
                        Relative Zeilennummer in 'ema', unter der der Name
                        zu finden ist.
                  3.    (oft_ml):
                        Ein boolscher Wert, welcher angibt, ob das Label
                        mehrfach da ist oder nicht. Bei mehrfachem Erschei-
                        nen kann das Label nicht als Sprungziel fr .GOTO
                        oder .IF dienen.
                  4.    (wert_ml):
                        Falls eine Zuweisung mit .SET erfolgte, steht hier
                        der zugewiesene Wert zu lesen.
                  5.    (gueltig_ml):
                        Falls eine Zuweisung mit .SET erfolgte, wird diese
                        Variable auf true gesetzt.

                Erst jetzt tritt die zu 'zeile_abgrasen' analoge Procedure
                'zeile_expandieren' in Aktion. Sie scanned die aus 'ema'
                stammenden Zeilen ab, ersetzt nun auch die dap's mit
                Variablen durch die entsprechenden beim Aufruf berge-
                benen Parameter und zerlegt diese Zeile anschlieend  wie-
                der in ihre Teile: Label, Befehl, Operanden, Kommentar
                nach 'zlboc'. Wie bei 'include_file' wird anschlieend
                versucht, die eben gelesene Zeile zu bearbeiten. Dabei treten
                nun im wesentlichen nur noch 4 der bei 'include_file' be-
                schriebenen Flle auf:
                  1.    Sofort ausfhrbarer Befehl
                  2.    INCLUDE
                  3.    Macro-expansion
                  5.    Pmacro-expansion
                Der 4. bzw. 6. Fall (Macro/Pmacro-definition) ist per
                definitionem whrend der Expansion eines Macros nicht erlaubt.

       4.       Der Pseudo-op MACRO liegt vor. Es werden alle
                folgenden Zeilen des Quell-files gelesen, bis der Pseudo-op
                MEND erkannt wurde. Je nachdem, ob wir uns dabei gerade im
                IF-true- oder IF-false-Zustand befinden (damit ist das IF der
                bedingten Assemblierung gemeint), wird der gelesene Text im
                Macro-array 'ma' angehngt (IF-true) oder nicht (IF-false).
                Diesen Vorgang kann man Definition eines Macros nennen.
                Dabei werden die Macro-Parameter mit nur einem & (wir
                nennen sie sap's (=single ampersand parameter) in dap's mit
                einer Konstante umgewandelt.

       5.       Der Name eines (vorher definierten) Pmacros liegt vor.
                Der Vorgang ist hier hnlich zu Punkt 3. Es gibt aber
                einige 'Erleichterungen'. Z.B. knnen im Pmacro per defi-
                nitionem keine INCLUDE's mehr auftreten.

       6.       Der Pseudo-op PMACRO liegt vor. Es werden alle
                folgenden Zeilen des Quell-files gelesen, bis der Pseudo-op
                MEND erkannt wurde. Je nachdem, ob wir uns dabei gerade im
                IF-true- oder IF-false-Zustand befinden (damit ist das IF der
                bedingten Assemblierung gemeint), wird der gelesene Text im
                Macro-array 'ma' angehngt (IF-true) oder nicht (IF-false).
                Diesen Vorgang kann man Definition eines Macros nennen.
                Dabei werden die Macro-Parameter mit nur einem & (wir
                nennen sie sap's (=single ampersand parameter) in dap's mit
                einer Konstante umgewandelt. Der Unterschied zu 4. liegt
                in der Behandlung von ozs bzw. ozi: der erste bei der Defi-
                nition des Pmacros erscheinende Parameter ist die Soll-
                zahl der Operanden des Pmacros.

     Unabhngig davon, ob wir uns gerade in 'include_file', 'expand_macro',
     'expand_pmacro', 'lies_macro' oder 'skip_macro' befinden, wird die
     (jeweils von 'zeile_abgrasen') gelesene (und ggf. von 'zeile_expandieren'
     entsprechend bearbeitete) Zeile (sofern sie im zweiten Lauf bentigt
     wird) mit gewissen Zusatzinformationen auf ein Zwischenfile 'ZWL' (fr
     zweiter Lauf) geschrieben. Die Zusatzinformationen geben dabei etwa an,
     ob die Zeile im Listing erscheinen soll (welches im 2. Lauf angefertigt
     wird), ob die Zeile Op-code erzeugen soll bzw. ob Pseudo-ops ausge-
     fhrt werden sollen oder nicht. Weiter wird eine jeweilige Adre-
     anzeige bergeben und die Zeilennummer bzw. ein dummy (    +), wenn
     gerade expandiert oder includiert wird, damit wir auch hier konform
     zu HP gehen. Ein weiteres Problem stellten die lokalen Macro-variablen
     dar, die, wenn man sie wrtlich nach 'ZWL' hinschreibt, zu verstnd-
     nislosem Kopfschtteln im 2. Lauf fhrten, da die Werte dieser
     Variablen ja nur whrend der Macro-expansion (in der llt verwahrt)
     vorhanden waren. Inzwischen wurde dafr gesorgt, da immer dann,
     wenn eine nach 'ZWL' zu schreibende Zeile, die im 2. Lauf auch bear-
     beitet werden soll (also bei zb='j'), eine lokale Macro-variable ent-
     hlt, der zum Zeitpunkt der Expansion gltige Wert sozusagen
     "immediate", d.h. als Konstante nach 'ZWL' geschrieben wird.

       Als wichtige Zusatzinformation wre fr den ersten Lauf das
     Bercksichtigen der bedingten Assemblierung zu nennen. Im Detail
     will der Autor nicht auf dieses Phnomen eingehen, nur soviel:
       Die oben geschilderte Abarbeitung einer von 'zeile_abgrasen' bzw.
     'zeile_expandieren' erzeugten Zeile in 'include_file' bzw. in
     'expand_macro' ist einfach an den IF-state gebunden. Bei IF-state
     true wird bearbeitet, bei IF-state false wird bersprungen.
     Einzig die Befehle IF, ELSE, ENDIF und IFEND unterliegen natrlich
     nicht dieser Bedingung, da ja sie gerade dazu dienen, den auf eine
     Tiefe von islen angelegten IF-stack zu verwalten. Im 2. Lauf gibt's
     dann keine IF's mehr, weil nach 'ZWL' alles so hingeschrieben wird,
     wie es dann zu bearbeiten ist.

     Damit wre eigentlich das wesentliche zum ersten Lauf gesagt.

   3.  Zweiter Lauf:
     Mit Kenntnis der aus dem 1. Lauf gewonnenen Variablen-werte in 'nf'
     wird nun 'ZWL' bearbeitet. Jetzt ist das Leben leicht geworden:
     Es gibt keine IF's, ELSE's und dgl. mehr, Macro-expansionen treten
     nicht mehr auf ebensowenig wie INCLUDE's. Fr das sthetische
     outfit des Listings wird vllig zwanglos ein code-buffer 'cb' ein-
     gerichtet, der bei mehr als cbpz Bytes nach dem Pseudo-op EXPAND
     ein wunderbares Listfile erzeugt. Ein hnliches Vorgehen beim
     Object-file mit dem Object-buffer 'ob' lt bequem ein im HP64000-
     assembler-format gestyltes Object-file erzeugen.


9.10.89:
        Beginn mit Einfhrung der Prozessormacros.

18.10.89:
        Pmacros sind installiert. Es gibt sogar extra Routinen zum Bear-
        beiten derselben (etwa 'suche_pm_befehl', 'bestimme_pm_daten', ...).

2.11.89:
        Nachdem nun die Pmacros installiert sind, wurden im Kommentar-
        text weiter oben  an geeigneter Stelle Ergnzungen bzw. Modifi-
        kationen  angebracht.

30.11.89:
        Fehler in 'suche_befehl' beseitigt: nur Pmacro, Macro und Pseudo-
        befehle sind erlaubt.

11.12.89:
        'welches_file' leicht modifiziert. Listfile und Objectfile erhalten
        im wesentlichen den Namen des Quellfiles plus ein Prefix 'L_', bzw.
        'O_'.

12.12.89:
        'welches_file' nochmals leicht modifiziert. Auch 'ZWL' verschwindet,
        heit nun 'Z_' + Quellfile.

08.01.90:
        Quellen werden mit Attribut 'SHARED' geffnet. Prefices 'L_',
        'O_' und 'Z_' werden zu Suffices: '_L', '_O' und '_Z'.

11.01.90:
        _Z-file wird nach dem zweiten Lauf gelscht.

12.01.90:
        'welches_file' erneut leicht modifiziert: Suffices .TEXT bzw.
        .ASC werden weggestrichen.

12.02.90:
        Fehler bei DS beseitigt: es wurde zwar pcn hochgezhlt, nicht je-
        doch pcs und, was wesentlich schlimmer war, es wurde der code buffer
        vergessen, d.h. ein DS im ROM hat tatschlich keinen Platz im ROM
        reserviert (obwohl die Adressen natrlich alle korrekt berechnet
        worden waren). Nun wird also bei DS regelmig auch 'schreibe_obj'
        aufgerufen. Dadurch wird eventuell vorhandener Code (im Codebuffer)
        ausgegeben und stad wird akualisiert.

06.03.90:
        Schnheitskorrektur mit zdiva. Datum und Zeit in 'neue_seite' ein-
        gebaut. Fehler bei TITLE beseitigt: nicht mehr pzc rcksetzen.
        'zl_IF_true/false_skip_title' hinzufgen. 'N': nicht listen und
        nicht 'neue_seite', 'L': listen aber nicht 'neue_seite', 'F':
        nicht listen aber 'neue_seite' (F fr form feed).

14.03.90:
        Umlaute werden, soweit mglich als ', , , , , ' und scharfes
         auch als solches geschrieben (ist aber nur im Kommentar mglich,
        weil die deutschen Umlaute vom Compiler i.a. nicht als normale
        Zeichen akzeptiert werden).

03.05.90:
        Die Anzahl der Operanden bei 'TITLE' ist unbestimmt, es wird jedoch
        immer der erste Operand als Titel herangezogen. Damit ist es mglich,
        den Titel abzuschalten, indem einfach nur 'TITLE' ohne Operand als
        neuer Titel angegeben wird.

08.05.90:
        Schlubemerkung um Filenamen ergnzt: Assemblierung von File
        Sowieso ... beendet.

30.05.90:
        Im Rahmen der Erweiterung auf Z80 bemerkt man z.B.: die Operanden-
        sollzahl ist nicht mehr fr jeden Befehl eindeutig bestimmt, so da
        ozs bei der Definition der Pmacros mit angegeben werden mu und nicht
        mehr aus ozi abgeleitet werden kann. ozs wird dabei als erster
        Parameter hingeschrieben.

01.08.90:
        Der Typ:  psftyp(=PACKED ARRAY[0..flen] OF char) macht mit dem
        Pascalcompiler unter TUNIX Probleme. Daher wird lower bound auf 1
        gesetzt.

22.08.90:
        Fehler in 'suche_loc_var' beseitigt: beim Notieren der Konstanten
        wird immer eine fhrende Null ausgegeben, damit die Hex-konstanten
        auch in Ordnung sind. Nach letztem Operanden wird kein Komma mehr
        auf das Zwischenfile ausgegeben. Ankndigungen ber in Expansion
        befindliche Macros werden aus Zeitgrnden gestrichen. Bei ier=1,
        d.h. wenn der Pseudobefehl INCLUDE vorliegt, wird 'fixiere_loc_var'
        nicht aufgerufen, um nicht mit sonderbaren Filenamen
        (z.B. #11:/users/.....) in Konflikt zu geraten.
        Bei 'expand_pmacro' wird auf eine diesbezgliche Prfung verzichtet,
        da im Pmacro kein INCLUDE vorkommen darf!

06.03.92:
        mzm auf 500, mzlma auf 2500, mzn auf 2000 erhht.
        zss1: Im Rahmen eines Projektes zur Sourcecode-konvertierung
        8085 -> Z180 berdenken wir unsere PMACROs ein wenig. Neben b, B,
        w und W werden nun noch eingefhrt: n, N, i, I, g, G, s und S
        fr .NOP, .IF, .GOTO und .SET.
        Auch 'skip_macro' bekommt 'mpd'. Im PMACRO gibts nur noch lokale
        Labels. Dies spart bei Sprngen Zeit. Insbesondere werden also
        vor b, B, w und W Variablen als lokale Macrolabels behandelt.
        Desweiteren werden die neuen Pseudobefehle PMEND und PINCLUDE
        definiert. Letzteres geschieht vor allem im Hinblick auf den
        geplanten Sourcecodekonverter 8085 -> Z180.

zss1/08.06.92:  Vielleicht machen wir demnchst eine Portierung auf PC.

zss1/20.09.92:  Portierung auf PC wird ein bichen weiter verfolgt.
        Dazu werden wegen 'structure too large' erst mal einige Kon-
        stanten wieder verkleinert: mzlma=500, mzlema=100, mzm=200,
        mzn=1000. psftyp fliegt gegen string_flenp1 raus.

zss1/30.09.92:  Weil MOD am PC anders funktioniert als am HP, haben
        wir MOD bei Bedarf gegen AND ersetzt. Auerdem haben wir DIV
        gelegentlich gegen ein binlsr ausgetauscht.

zss2/03.10.92:  Weil wir auf dem PC (natrlich) Speicherplatzprobleme
        haben, mssen wir das Sparen anfangen. Aktuelle Manahme:
        die Verwaltung des Macro-arrays 'ma^' mu gendert werden, weil hier
        tatschlich eine Platzverschwendung vorliegt. Die Macros werden
        nicht mehr Zeile fr Zeile nach 'ma^' abgelegt mit flen Bytes
        Platz pro Zeile, sondern wir legen ein 'kompaktes' Feld an, in
        dem die bisher in 'ma^' vorliegende Information einfach zusammen-
        gepret ist. Allerdings mssen wir dann ein neues Index-array
        einfhren, damit wir einen schnelln Zugriff auf die Macro-zeilen
        haben. Zu diesem Zweck fhren wir analog dem Feld 'mzl' (Macro-
        zeilen-lnge) ein weiteres Feld 'mzs' (Macro-zeilen-start) ein.
          Bug bei Fehlermeldungen beseitigt: es lagen gewisse Ungenauigkeiten
        mit len und llen bzw zlboc und lzlboc vor.
         Obacht! Wenn wir Zeit haben, mssen wir 'ema' auch noch kompri-
       mieren, wie wir das mit 'ma^' schon getan haben.

zss2/05.10.92:  Fehlermeldung, wenn File nicht gefunden.

zss2/07.10.92:  Weiteres Debugging bei Fehlermeldungen. Weiterhin wandeln
        wir 'ema' in einen Zeiger um, wie das bei 'ma' schon der Fall ist.
        Dadurch kann zunchst mal auf die Schnelle ein Stackberlauf
        vermieden werden (tritt schon auf bei gar nicht allzu groem
        Macro-expansion-level), weil 'ema' mit 'mzlema'=100 schon wieder
        gut 10K Byte verbraucht. Die am 03.10.92 gemachte Absichtserklrung
        haben wir hiermit zwar nicht vergessen, momentan haben wir aber
        noch keinen Drive fr die Umstellung von 'ema' auf 'ema^'.

zss2/2.01/10.10.92:  Geringfgige nderung des Outfits. Ausgabe von Version
        und Datum.

zss2/2.02/14.10.92:  Auf dem PC wollen wir auch die Filenamen etwas
        modifizieren. Die Suffices heien nun: .OO, .ZZ und .LL fr
        Objekt-, Zwischen- und Listfile. Auerdem bauen wir noch eine
        Abfrage bei bereits bestehenden Filenamen ein.
        zdiva bekommt einen schneren Divisor (100) und zudem wird dieser
        Divisor als globale Konstante eingefhrt.

zss2/2.02/15.10.92:  Wir berdenken die Filenamen nochmal. Das Zwischen-
        file bekommt nun .T (fr temporr), Object- und Listfile erhalten
        .O bzw. .L angehngt. Die Source heit ab sofort Ursprung und mu
        somit das Anhngsel .U tragen. Beim Aufruf von zss kann man
        das Anhngsel aber auch weglassen. Das bedeutet aber, da nur
        noch Files mit dem Suffix .U zusammengesetzt (assembliert)
        werden knnen.

zss2/2.02/13.12.92:  Der Name des zusammenzusetzenden Files kann wahl-
        weise auch als Parameter unmittelbar nach den Aufruf des
        Zusammensetzers hingeschrieben werden. Durch Eingabe von '/f'
        oder '/F' (wie 'force') als zweiten Parameter kann die Abfrage
        nach Programmabbruch unterbunden werden, die auftritt, wenn
        Files schon existieren, die im Laufe der Zusammensetzung
        berschrieben werden. Bei Vorhandensein des 'force'-Schalters
        werden in jedem Fall neue Files erzeugt.

zss2/2.03/15.02.93:  Kleine Schnheitskorrekturen und minimales Debugging
        in 'welches_file'.  'try_good_file_name' wird dabei umbenannt in
        'ist_file_name_gut'. Dabei schauen wir ein wenig bei 'HEXDUMP.PAS'
        ab, welches wir um Weihnachten fr Manne geschrieben hatten.

zss2/2.03/20.03.93:  Kommentar leicht modifizieren.

zss2b/2.04/01.11.95:  Es ist wieder mal an der Zeit, ber eine Z180-Er-
        weiterung nachzudenken. Neben vielen anderen Dingen werden wir
        alle Pseudobefehle bis auf 'PINCLUDE' und 'PEQUATE' nun auch von
        auen, d.h. ber den Programmtext eingeben, so wie das mit den
        Pmacros auch der Fall ist. Dadurch knnen wir bequem zwischen den
        unterschiedlichen Syntaxen fr einige der Pseudobefehle umschalten.

zss2b/2.04/03.11.95: .NOP, .IF, .GOTO, .SET fhren in 'include_file'
        nicht nur bei vorhandenem Label zu einer Fehlermeldung, sondern
        immer!

zss2b/2.04/05.11.95: Cont. Z180.

zss3/2.05/06.11.95: Cont. Z180. Umstellen auf Units, da wieder mal Speicher
        knapp wird.

zss3/2.06/18.11.95: Cont. Z180.

zss3/2.07/26.11.95: Damit wir speziell bei Z180 'LD' eine bessere Perfor-
        mance bekommen, mssen wir die Mglichkeit haben, innerhalb eines
        Pmacros weitere Pmacros aufrufen zu knnen.

zss3/3.00/03.12.95: Cont. Z180: ORG.

zss3/3.00 beta/04.12.95: Kleiner Bug: Falls Pmacro, Pseudoop. oder Macro
        in Ausdrcken auftauchen, gibt es nun eine Fehlermeldung. Bis jetzt
        wurde das unbemerkt hingenommen. Das konnte dazu fhren, da etwa
        der Name eines Pmacro, Pseudoop. oder Macro z.B. Sprungziel sein
        konnte und infolgedessen unbemerkt vllig falscher Code generiert
        wurde. Bei 8085 kann dies zwar fr die vordef. Variablen immer noch
        passieren aber das ist uns momentan wurscht.

zss3/3.00 beta/17.03.96: In einigen Pmacros gibt es Probleme, weil wir
        bereits im ersten Lauf mit den Operanden rechnen wollen, obwohl
        wir natrlich erst im zweiten Lauf den Wert wissen. Z.B. bei 'JR'
        war dies der Fall. Wir wollten nmlich sicher gehen, da etwa das
        Sprungziel nicht zu weit weg ist. Eigentlich ist uns der Wert
        dieser Operanden im ersten Lauf vllig egal. Wir mssen nur wissen,
        wieviele Bytes Opcode der Befehl/das Pmacro beanspruchen wird.
        Wir werden versuchen, die Sache ber die Pmacros abzuwickeln.
        Dazu mssen wir zum einen die fraglichen Pmacros u.a. dahingehend
        modifizieren, da kein Pmacro-if (i) oder Pmacro-set (s) mehr
        verwendet wird, sondern der fragliche Text direkt in das
        Zwischenfile geschrieben wird um dann im zweiten Lauf getestet
        zu werden. Wir knnen im zweiten Lauf zwar keine bedingten
        Sprnge mehr machen aber eine ganz einfache Form einer Prf-
        anweisung sollte denoch mglich sein: prfe, ob wahr und wenn
        ja, dann Meldung ausgeben und Programm abbrrechen. Etwa so

        p        WERT.GT.127     'Sprungziel zu weit weg'.

        Wir mssen uns nur noch mal anstrengen, diesen neuen Befehl
        auch korrekt zu implementieren. Langsam wird die Sache mit den
        ganzen speziellen Pmacro- und sonstigen Spezialbefehlen nmlich
        etwas unbersichtlich, so da wir ganz allmhlich den berblick
        verlieren. Diesmal werden wir es aber nochmal schaffen.
        Zum einen geht es also darum, die fraglichen Pmacros korrekt
        abzundern. Das sollte noch ganz einfach sein. An geeigneter
        Stelle im Pmacro etwa obige Beispielzeile hinschreiben, fertig.
        Dann mu die Bearbeitung der Pmacros auf diesen neuen Pmacro-
        Befehl 'p' eingerichtet werden. In 'suche_pm_befehl' mssen fr
        'zb' und 'zl' geeignete Werte angegeben werden. 'zb' mu ein
        'j' bekommen, weil die Zeile im zweiten Lauf bearbeitet werden
        soll. Fr 'zl' sollte 'n' o.k. sein, da die Zeile nicht
        im Listing erscheinen soll. Schlielich mu noch im zweiten
        Lauf in 'bestimme_pm_daten' ein Handling fr den neuen 'p'-
        Befehl definiert werden.
        Bemerkung: wir haben letzthin gertselt, was die Werte 'd' und
        'e' fr 'zl' wohl bedeuten knnten. Wenn man 'bestimme_pm_daten'
        ansieht fllt auf, da bei zl='e' die Routine beendet wird.
        'e' steht also fr 'Ende', das 'd' dann wahrscheinlich fr
        'Definiere'. Die Wahl zl='n', die wir oben vorgeschlagen
        haben ist also in Ordnung, solange diese Zeile nicht als
        letzte dasteht, denn nur 'e' kann das Pmacro beenden. Mssen
        wir eben ein bichen aufpassen.

        Ein neues Problem taucht auf: Es gibt doch tatschlich Menschen,
        die die Syntax EX AF,AF' verwenden. Wir knnen also nicht mehr
        AFs anstatt AF' bentzen. Vielleicht gelingt es uns doch, den
        Apostroph als Teil eines Namens zu definieren.

zss3/3.00 beta/22.03.96: Zuerst mal 'check_len' aufpeppen: Jetzt wird
        gesagt, welcher Operand fehlt und nicht nur, da irgendeiner fehlt.
        In 'zeile_expandieren' wird 'von_wo' eingefhrt. Sagt aus,
        von wo aus der Aufruf statt gefunden hat (siehe auch bei 'zeile_
        expandieren'). Damit kriegen wir nun wahrscheinlich das Problem
        mit "EX AF,AF'" hin.

zss3/3.00 beta/23.03.96: Wir wollen 'zeile_abgrasen' etwas erweitern.
        Es sollen sowohl DOS-Quellen (also dort wo das Zeilenende mit
        CR und LF markiert ist) als auch UNIX-Quellen (nur LF) gelesen
        werden knnen.

zss3/3.00 beta/24.03.96: Es gibt kleinere Schwierigkeiten mit dem
        Zwischenfile 'tmp'. Beim Schreiben hatten wir es als Textfile
        angelegt und nun wollten wir im zweiten Lauf aber die modi-
        fizierte Routine 'zeile_abgrasen' dort verwenden. Geht natrlich
        nicht, weil 'zeile_abgrasen' ein File vom Typ 'fct' erwartet.
        Trick: Zwischenfile schreiben als Textfile aber lesen als
        File vom Typ 'fct'. Scheint auch ohne Probleme zu funktionieren.
        Aber: alles geht pltzlich total langsam. Anscheinend geht
        Lesen von einem Textfile viel schneller als zeichenweises Lesen
        von einem File vom Typ 'fct'. Wahrscheinlich mssen wir uns
        selbst um eine Bufferung kmmern (schei DOS).
        Also: anstatt 'fct' (FILE OF char - Typ) nehmen wir 'fbt'
        (FILE OF byte - Typ). Oder besser untypsiert: FILE.
        Wir mssen also zwischen unsere Byteleseanforderungen und die
        eigentlichen Systemgeschichten eine Zwischenschicht ein-
        schieben. Das Programm fordert nach wie vor zu irgendwelchen
        Zeiten einzelne oder mehrere Bytes von einem File an. Tatsch-
        lich findet ein Lesen vom File aber immer nur in Blcken statt,
        wenn der Block leer ist. Solange er nicht leer ist, bekommt
        das Programm die Daten dann aus dem Block. Ganz einfach, oder?
        Um dies zu erreichen, legen wir am besten berall da, wo bisher
        ein FILE definiert war einen Record an, in dem auer dem FILE
        noch der Buffer und ein Fllstandsanzeiger enthalten ist.
        berall dort, wo bisher ein normaler File-Reset stattfindet,
        wird in unserem Fall dann auch der Fllstandszeiger rckzusetzen
        sein.

zss3/3.00 beta/30.03.96: Natrlich gibt es Menschen, die groe Mengen an
        Macrotexten brauchen. Fhrt dann ganz zwanglos zu irgendwelchen
        TP-Errormeldungen der Form ...error xy at z weil das Macro array
        'ma' bergelaufen ist. Diesen berlauf hatten wir als eine der
        wenigen Sachen nicht selbst berprft, weil wir keine Gefahr
        gesehen hatten. Weil 'max_gma' aber mit 60000 schon recht gro
        definiert ist, mssen wir wohl selbst ein Riesenfeld konstru-
        ieren. Probieren wir's so: Ein 'ma' allein reicht nicht, also
        richten wir mehr als eines ein. 'ma' selbst ist ja lediglich ein
        Zeiger auf das eigentliche Macro array. Wir legen also ein
        Feld von Zeigern auf Teil Macro arrays an. Die Lnge der Teil Macro
        arrays wird dabei eine Zweierpotenz sein, damit wir eine schnelle
        Adressierung bekommen: nehmen wir etwa die 14 niederwertigsten
        Bits von 'ima' zur Adressierung innerhalb eines Teil Macro array
        (bedeutet dann eine Lnge von 16K fr das Teil Macro array), knnen
        die um 14 Bit nach rechts geschobenen hchstwertigen Bits von
        'ima' zur Auswahl des betreffenden Teil Macro array verwendet
        werden. Die Teil Macro arrays werden dynamisch whrend des
        Programmlaufs je nach Bedarf angelegt.
        Zur Bezeichnung: wir werden mit 'ma' in Zukunft das Feld der
        Pointer auf die Teil-Macro-arrays nennen.
        Wir bemerken weiter: offenbar ist in HEX-Konstanten neben
        'A'..'F' auch 'a'..'f' blich und 'h' kann die HEX-Konstante
        ebenso abschlieen wie 'H'. Mssen wir also 'scan' ndern
        und nehmen gleich 'b', 'q' und 'o' mit.

zss3/3.00 beta/31.03.96: Cont. soweit 'ois o.k.'. Nun aber mssen wir
        wahrscheinlich doch mal ernsthaft ber unser riesiges Namens-
        feld 'nf' nachdenken. Bisher erlauben wir es nicht, da zwei
        Objekte in 'nf' den gleichen Namen haben drfen, auch wenn
        sie unterschiedlichen Typ haben. War bisher auch o.k., weil wir
        eben ausschlieen wollten, da etwa ein Macroname gleich einem
        Label ist. Es kommt aber immer wieder vor, da geschickte
        Hacker solche Sachen dennoch tun. Man kann ihnen dann sagen,
        da dies eigentlich nicht optimal ist aber nachdem der
        HP-TUNIX-Assembler solche Konstrukte klaglos bearbeitet,
        mssen wir das wohl auch tun :-(.
        Wie immer gibt es verschiedene Mglichkeiten fr eine Reali-
        sierung. Wir probieren folgendes: das eine 'nf' bleibt
        bestehen aber wir verwalten ggf. auftretende Namensgleichheiten
        in einer verketteten Liste, die wir an den 'nr' anhngen.
        Also: 'nr' bekommt einen weiteren RECORD-Eintrag, welcher
        NIL ist, solange es nur ein Objekt gibt. Bei weiteren (gleich-
        namigen) Objekten verweist dieser Pointer auf einen weiteren
        RECORD, der eben dieses weitere Objekt enthlt. Auf diese Weise
        lassen sich durch Verlngerung der Kette alle gleichnamigen
        Objekte unterbringen. Gegenber der bisherigen Objektverwaltung
        mssen wir also ggf. noch die in der Kette angehngten Objekte
        bercksichtigen.
        Eine andere Mglichkeit wre etwa, fr jeden Namenstyp ein
        eigenes 'nf' einzurichten. Dann knnte man sich die Kette
        sparen und knnte ganz gezielt bestimmte Namenstypen an-
        sprechen, ohne sie erst in der Kette suchen zu mssen. Aller-
        dings mten wir dann eben den ganzen Kram mit den Namenshaufen
        ('enh') mehrfach einrichten und auch alle 'nf' durchsuchen,
        falls wir alle gleichnamigen Objekte suchen wollten, die aber
        unterschiedlichen Typ haben. Zu all dem haben wir keine Lust.
        Auerdem mten wir uns bei (wahrscheinlich wie bisher auch) statisch
        angelegten Feldern fr die verschiedenen Namensfelder fr jedes
        einzelne fr eine vernnftige Gre entscheiden. Bei nur einem
        'nf' fr alle Namen mssen wir diese Entscheidung nur einmal
        treffen.
        Hinweis: Es wird nach wie vor nicht erlaubt sein, namensgleiche
        Objekte gleichen Typs zu haben, logisch. Auch Namensgleicheit
        zwischen hnlichen Typen wird nicht erlaubt sein (etwa in der
        Gruppe (Pmacro, Pseudoop, Macro (Typen 0, 1 und 2) darf ein
        Name nur einmal auftauchen.

zss3/3.00 beta/02.04.96: Wir haben noch ein wenig nachdedacht und sind
        nun doch zu folgender Erkenntnis gekommen: Es gibt zwei Gruppen
        von Objekten, die Befehle (Namenstypen 0, 1 und 2) und die
        Labels (Namenstypen 3, 4, 5 und 8). Innerhalb einer Gruppe darf
        ein Name nur einmal vorkommen (Ausnahme Typ 5), ein Name inner-
        halb der ersten Gruppe darf aber auch in der zweiten vorkommen.
        Damit wird es durchaus sinnvoll, fr jede der beiden Gruppen
        ein eigenes Namensfeld anzulegen. Ggf. kann man ja spter auch
        ber eine dynamische Lngenverwaltung der Namensfelder nach-
        denken, wie das fr das Macro array schon geschehen ist.

zss3/3.00 beta/03.04.96: Cont.
        Notiz am Rande: bei SET-Variablen kann es im Moment noch
        passieren, da die erste Referenz bereits vor der ersten
        Zuweisung erfolgt und dies aber nicht auffllt. Grund: wie
        bei den EQU-Konstanten auch, werden erst im zweiten Lauf kon-
        krete Werte bentigt. Das bedeutet, da der erste Wert einer
        SET-Variablen dann dem im ersten Lauf zuletzt zugewiesenen
        Wert entspricht. Dies ist natrlich nicht optimal. Eigentlich
        mten also alle SET-Variablen nach dem ersten Lauf fr un-
        gltig erklrt oder gelscht werden. Mal sehen, ob, bzw. wie
        wir das machen werden.

zss3/3.00 beta/05.04.96: Cont.
        Ein bichen Kosmetik: 'report_status'. Das Namensfeld fr
        Befehle 'nfb' wurde eingefhrt. Bevor wir fr die Labels
        'nfl' (Namensfeld fr Labels) einfhren, wollen wir die
        Verwaltung 'dynamisieren', hnlich dem Macro array 'ma'.
        'Dynamisierung' ist erfolgt, 'nfl' ist ebenfalls eingerichtet.
        Kommen wir zu den SET-Variablen. Da haben wir einen neuen
        Trick: anstatt nach dem ersten Lauf alle SET-Variablen zu
        lschen, fhren wir einen neuen Variablentyp 9 ein. Alle
        SET-Variablen werden nach dem ersten Lauf von Typ 5 auf
        Typ 9 umbenannt. Sollte ein Lesezugriff auf Variablen vom
        Typ 9 erfolgen, gibt es eine Fehlermeldung. Ansonsten
        verwandelt eine SET-Anweisung den Typ wieder von 9 nach 5
        und alles ist o.k..
        Scheint soweit alles in Ordnung aber: bei greren Programmen
        haben wir schon wieder Speicherplatzprobleme.
        Vielleicht knnen wir beim end-macro-array 'ema' noch ein
        bichen sparen. Dieses ist momentan mit mzlema=230 und sflen=127
        schon mindestens beinahe 30K gro. Wir haben Spitzenwerte
        des macro-expand-level 'mel' von 6 beobachtet, d.h. wir
        brauchen dafr schon knapp 200K. Ganz ordentlich. Wenn man
        bedenkt, da der gesamte Macrotext aller gelesenen Macros
        bei etwa maximal 70K oder 80K liegt, besteht hier eindeutig
        Handlungsbedarf (Aussagen beziehen sich auf die grten bei
        uns vorkommenden Programme).

zss3/3.00 beta/08.04.96: Cont.
        Anstatt fr jede Macroexpansion ein eigenes 'ema' anzulegen,
        machen wir es hier hnlich wie beim Lesen der Macros: Es wird
        ein Feld angelegt, in welches ohne Lcken der gesamte 'end-
        gltige' Macrotext eingetragen wird. Die Variablen vom Typ
        'zzlema_type' (Zeiger auf Zeilenlnge im End Macro array)
        lassen wir wegfallen und integrieren diese Information mit in
        die llt's, d.h. in der llt haben wir jetzt auch noch die Infor-
        mation ber die Lnge der 'endgltigen' Macrozeilen. Tatschlich
        sind wir hier etwas schlauer als beim Lesen der Macros: Uns
        gengt ein Feld, in dem jeweils auf das Ende, d.h. ein Zeichen
        nach das Ende der Zeile gezeigt wird. Wird ein neues Macro
        'endgltig' gemacht, mssen wir uns lediglich ber das nchst-
        kleinere 'mel' das Ende der letzten Macrozeile besorgen und knnen
        dort einfach weiterschreiben. Dazu erscheint es zweckmig,
        in die llt eine weitere Variable aufzunehmen: entweder merken
        wir uns, wieviele Zeilen da sind oder wir notieren direkt
        das Ende des Macrotextes.
        Scheint inzwischen wieder mal 'ois ok'.
        Wir verzichten auch auf die 'Macro-Zeilen-lnge' mzl, da diese
        Information bereits in 'mzs' enthalten ist und wir somit bei
        mzlma=5000 nochmal 20K sparen.

zss3/3.00 beta/20.04.96: Cont.
        Der Programcounter $, bzw. 'pc' scheint Probleme beim Z180 zu
        machen. Wenn wir etwas genauer hinsehen, bemerken wir auch, da
        wir 'pc', bzw. 'pcn' oder 'pcs' im ersten und zweiten Lauf unter-
        schiedlich behandeln. Das ist natrlich nicht gut. Im ersten Lauf
        wird 'pcn' direkt so bernommen, wie es im Quellcode dortsteht.
        Nennen wir diesen im Quellcode angegebenen Programcounter 'vir-
        tuellen pc' (vpc) im Gegensatz zum 'physikalischen pc' (ppc),
        der angibt, an welchen Adressen im Objectfile die Codebytes
        liegen. Etwa beim ORG wird pcn (bis auf eine Verundung mit $ffffff)
        direkt gleich dem vpc gesetzt. Im zweiten Lauf wird dann erst die
        komische Rechnung mit Ausmaskieren und Verschieben um 4 Bit nach
        rechts gemacht, um den ppc zu bekommen, d.h., eine physikalische
        Adresse zu erhalten. Genau dieses hat nun aber Probleme verursacht.
        Offenbar erreichen wir auf diese Weise, da Ausdrcke, die '$'
        enthalten im ersten Lauf andere Resultate liefern als im zweiten
        Lauf, da im ersten Lauf der vpc, im zweiten Lauf jedoch bereits
        der ppc verwendet wird. Wir mssen also auch im zweiten Lauf noch
        den vpc verwenden und erst beim Generieren des Codes die Umwandlung
        auf den ppc vornehmen. Ist das klar? Also: einzig beim Generieren
        des Codes mssen wir die angegebenen Adressen (vpc) in physikalische
        Adressen (ppc) umwandeln, um die Codebytes an die physikalisch
        richtige Adresse hinzusetzen. Alle anderen Bezge auf den Program-
        counter nehmen den angegebenen Wert (vpc).

zss3/3.00 beta/28.04.96: Wir werden uns anhand einiger weiterer gezielt
        ausgesuchter Tests ueber das detaillierte Verhalten des Z180-HP-
        Assemblers informieren mssen.

        Frage 1:
          Welche Labels werden generiert und wie sieht das Objectfile aus,
          wenn etwa nach einem ORG bei 0FFFFH mehr als 250 Bytes in Folge
          generiert werden (250 ist die maximale Gre eines Datenblocks
          im Objectfile)?
        Ergebnis:
          Ausgehend von 0FFFFH werden die Labels, d.h. der vpc einfach
          Byte fr Byte inkrementiert. Die Labels lauten also 0FFFFH,
          10000H, 10001H, usw.. Die Startadresse im Objectfile lautet
          ebenfalls 0FFFFH und es folgt zunchst ein Datenblock mit 250
          Bytes, die also physikalisch bei den Adressen 0FFFFH, 10000H,
          10001H usw. liegen. Eine ganz klare Inkonsistenz, denn zum vpc
          10000H gehrt der ppc 1000H, zum vpc 10001H der ppc 1001H usw.
          Beim 251-sten Byte dann steht im Objectfile als Startadresse
          10F9H. Dies ist der ppc zum vpc 100F9H, wie er beim 251-sten
          Byte auch tatschlich lautet.
        Konsequenz:
          Wollten wir kompatibel zu HP bleiben, drften wir also nicht
          einfach vor der Ausgabe eines Objectbytes den vpc in einen
          ppc umwandeln und dann das Byte dorthin setzen, sondern wir
          mten eigentlich dafr sorgen, da die auszugebenden Bytes
          in der gleichen Blockgre ausgegeben werden, wie das bei HP
          geschieht. Dies ist aber schwierig. Wir machen was anderes:
          wir kennen die tatschliche physikalische Adresse des letzten
          in das Objectfile auszugebenden Bytes (dies ist einfach die
          Summe aus dem ppc des ersten auszugebenden Bytes und der Anzahl
          der Bytes, die auszugeben sind minus 1). Nimmt man den vpc des
          letzten auszugebenden Bytes, so sollte der daraus bestimmbare
          ppc gleich der tatschlichen physikalischen Adresse des letzten
          Bytes sein. Ist dies nicht der Fall, geben wir eine Fehlermeldung
          aus. Ist das nicht geil?

zss3/3.00 beta/05.05.96: Noch ein bichen feilen im Zusammenhang mit
        'schreibe_obj'. Wir wollen den Bufferflush nur dann machen, wenn
        dies wirklich ntig ist, HP macht das auch so. Wir werden dabei
        folgendermaen vorgehen: es gibt nach wie vor den Objectbuffer
        'ob'. Dieser wird in 'neues_byte' bzw. 'neues_pbyte' zunchst
        mit Bytes gefllt und in 'schreibe_obj' dann in das Objectfile
        entleert. Bisher wird 'schreibe_obj' immer dann von 'neues_byte'
        bzw. 'neues_pbyte' aus aufgerufen, wenn die maximale Fllung
        erreicht ist. Auerdem wird bei 'ORG' und 'DS' ein Aufruf von
        'schreibe_obj' durchgefhrt, damit die neuen Codebytes, welche
        nach dem 'ORG' bzw. dem 'DS' generiert werden, auch garantiert
        die richtige Startadresse im Objectfile erhalten. Dies hat
        ggf. zur Folge, da eine neue Startadresse ausgegeben wird,
        obwohl dies nicht ntig wre, nmlich genau dann, wenn der
        neue 'ORG' sowieso genau bei der nchsten Adresse weitermacht
        oder wenn ein 'ORG' bearbeitet wird, nach dem gar keine neuen
        Codebytes generiert werden. Der neue Trick wird nun einfach
        darin bestehen, auer der bereits bestehenden Startadresse 'stad'
        eine weitere Adresse die 'neue Endadresse' (nead (wie 'stad'
        ebenfalls virtuell)) anzulegen. Immer beim Transfer eines Bytes
        in den Objectbuffer 'ob' wird 'nead' auf den Wert des fr dieses
        Byte gltigen aktuellen virtuellen Programmzhlers gesetzt.
        Bei leerem Buffer wird das neue Byte in jedem Fall in den
        Buffer geschrieben und 'nead' wird aktualisiert. Bei nicht leerem
        Buffer wird zunchst geprft, ob nead+1 gleich dem aktuellen
        virtuellen Programmcounter ist. Falls ja, wird (ggf. vor Leeren
        des Buffers wegen 'Buffer voll') das neue Byte einfach in den
        Buffer geschrieben und 'nead' aktualisiert, falls nein, wird
        vorher noch ein Bufferflush ausgefhrt mittels 'schreibe_obj'.

zss3/3.00 beta/07.05.96: Minimales Debugging. Vor Aufruf von 'new'
        prfen, ob noch gengend Speicher da ist.

zss3/3.00 beta/08.05.96: Ein Kollege wnscht sich, da wir prfen, ob in
        'lies_macro' und 'skip_macro', vor 'MEND' eine neue Macro-
        definition (d.h. der Befehl 'MACRO') auftaucht. Bei der Expansion
        von (P)Macros prfen wir selbstverstndlich, ob der Befehl
        '(P)MACRO' im Macro auftaucht und geben eine entsprechende
        Fehlermeldung, falls eine geschachtelte Macrodefinition
        vorliegt. Beim Lesen von (P)Macros haben wir bisher darauf ver-
        zichtet, da ja erst durch den Macroaufruf der endgltige Macro-
        text bekannt ist, eine Prfung auf bestimmte Macroinhalte zu
        diesem Zeitpunkt also keinen allgemeingltigen Charakter haben
        kann. In genanntem Fall wurde einfach das nchste 'MEND'
        als Macroende genommen, was zu Folge hatte, da bestimmte
        Labels natrlich nicht bekannt waren, weil sie einfach nur
        Macrotext darstellten. Es hat dann also eine Fehlermeldung
        gegeben, da irgendwelche Labels nicht bekannt seien aber
        keinen direkten Hinweis, da etwa ein 'MEND' fehlte oder
        etwa eine nun scheinbare Schachtelung von Macros vorlag.
        Wir werden prfen, ob es ohne groen Rechenaufwand mchlich
        ist, diese Prfung einzubauen, damit es in Zukunft fr diesen
        speziellen Fall eines vergessenen 'MEND' eine etwas klarere
        bzw. direktere Fehlermeldung gibt.

zss3/3.00 beta/21.05.96: In 'report_status' nur noch 'MaxAvail' aus-
        geben. Neue FUNCTION 'ob_weitermachen', weil wir an mehreren
        Stellen fragen wollen, ob weiter oder Abbruch.

zss3/3.00 beta/22.05.96: Lange Schleifen in Macros detektieren. Wir
        sagen: in Pmacros kann uns das nie passieren aber in normalen
        Macros (die der Orthonormalverbraucher erstellt) sind wir uns
        da schon nicht mehr ganz so sicher. Wir berprfen nach jedem
        Aufruf von 'suche_befehl' (in 'expand_macro'), was mit 'lzz'
        geschehen ist. Jedesmal, wenn 'lzz' gleichbleibt oder kleiner
        wird, erhhen wir einen Zhler 'jump_back_cnt', der uns angibt,
        wieviele Stillstnde bzw. Rckspnge erfolgt sind. Erreicht
        'jump_back_cnt' einen bestimmten Wert fragen wir mal nach, ob
        tatschlich weitergemacht werden soll oder nicht.

zss3/3.00 beta/26.05.96: Leiche 'lzz' aus zweitem Lauf und teilweise
        auch aus erstem Lauf entfernen.

zss3/3.00 beta/27.05.96: Zeilen der Form 'VAR:    DS      VAR' machen
        bei uns Probleme, weil wir zuerst versuchen, den Pseudoop 'DS'
        abzuarbeiten und erst danach 'VAR' in das Namensfeld der
        Labels (nfl) eintragen. Ein workaround fr den Bentzer wre,
        aus der einen Zeile zwei zu machen:

        VAR:
                DS      VAR

        Dadurch wre 'VAR' fr den 'DS' in der zweiten Zeile dann bekannt.
        Diese Lsung ist aber nicht sehr elegant.
        Andererseits knnen wir aber auch nicht ganz generell zuerst
        ein ggf. vorhandenes Label in das Namensfeld eintragen und dann
        erst den Befehl bearbeiten. Insbesondere bei 'EQU' htten wir
        dann neue Probleme. Bei 'LAB      EQU     <EXPRESSION>' kann
        ja eine Wertzuweisung an 'LAB' erst durch die Bearbeitung des
        Befehls 'EQU' erfolgen. Eine generelle Zuweisung vor Bearbeitung
        des Befehls und ggf. eine (korrigierende) zweite Zuweisung
        speziell bei 'EQU' nach Bearbeitung des Befehls ist auch nicht
        paktikabel, da wir dann Probleme mit Mehrfachzuweisungen bekommen
        wrden. Auerdem wrde eine Zeile der Form 'LAB      EQU     LAB'
        ohne Felermeldung durchgehen. Und das wollen wir natrlich nicht.
        Es scheint also so zu sein, da wir den Zeitpunkt der Wertzuweisung
        an ein Label vom Befehl abhngig machen mssen. Dadurch wird sich
        aber die bisherige Programmstruktur vor allem in der Umgebung
        der Routine 'suche_befehl' deutlich ndern mssen. Mal sehen,
        ob wir dies vernnftig ber die Bhne kriegen.

zss3/3.00 beta/13.06.96: Das mit 'DS' hat prima geklappt. Neue Probleme
        tauchen auf: schon bei sehr kleinem 'mel' gibt es Stackberlauf.
        Offenbar verbrauchen die lokalen Variablen in 'expand_macro', ins-
        besondere 'lzlboc' viel Speicher. Komisch ist nur, da eine
        Verkleinerung von 'al' Abhilfe schafft, eine Verkleinerung von
        'flen' aber keine. Sollten wir mal verfolgen. Jetzt erzeugen wir
        mit 'new' den Platz fr das lokale 'zlboc' und pltzlich geht
        wieder alles. Am Ende von 'expand_macro' geben wir mit 'dispose'
        den Speicher wieder frei. Wir wissen aber nicht so ganz genau,
        ob das den Stack auch wirklich wieder aufrumt. Sollte also eben-
        falls nochmal genauer angeschaut werden. Oder noch anders: evtl.
        mu die 'llt' herhalten. Dann mssen wir nicht jedesmal mit 'new'
        und 'dispose' arbeiten, sondern haben den Platz in der 'llt'
        bereits reserviert. Allerdings wre die 'llt' damit etwas zweckent-
        fremdet. Auerdem mten wir das gleiche Spielchen dann nicht nur
        in 'expand_macro' sondern auch in 'expand_pmacro' machen. Mal
        sehen, wie wir uns entscheiden werden.
        Hatten wir vergessen: beim Inkrementieren von 'mel' gegen 'max_mel'
        prfen. Jetzt gibt es eine schne Fehlermeldung anstatt TP-Error.
        Kosmetik: Im Fehlerfall llt nur ausgeben, falls anz_ml>=1.

zss3/3.01 beta/15.06.96: Cont.
        Eigentlich mten wir den Variablentyp 'tzlboc' mal grndlich
        berdenken. Warum speichern wir die komplette Zeile (in ihre
        Einzelbestandteile zerlegt) in den 'lboc'-Teil von 'zlboc' ab,
        wenn wir sowieso die komplette Zeile schon im 'z'-Teil von
        'zlboc' ablegen? Es mte doch reichen, lediglich die 'len' ggf.
        etwas zu erweitern, bzw. geschickter zu verwalten und wir
        knnten uns viel Zeit, Speicher und Arbeit sparen?
        Die Anregung fr diese berlegungen kommt vom letzten Stack-
        berlauf, den wir momentan in 'expand_macro' mit 'new' und
        'dispose' fr 'zlboc' vermieden haben.

zss3/3.01 beta/16.06.96: In den Prozessormacros hat es einen groben
        Fehler gegeben: an geeigneter Stelle wurde um die &-Parameter
        keine umschlieende runde Klammer gesetzt. Dies hatte natrlich
        fatale Folgen fr die Prioritt bei der Auswertung von Aus-
        drcken.

zss3/3.02 beta/07.07.96: Erste Freigabe im Netz.

zss3/3.03 01.01.2000: Bereinigung diverser Fehler, siehe 'changes'.

zss3/3.03a 16.03.2000: zppmax auf 200, dafr zppdef zustzlich einfhren.
        Man war mit der maximalen Zeilenzahl unzufrieden.

zss3/3.04 18.03.2000: zppmax auf maxlongint. Entgegen anderslautender
        Meinungen werden wir doch hier in 'zss3.pas' wieder ein paar
        Kommentare herschreiben, ist einfach bequemer so. Im readme
        knnen wir ja immer noch was hinschreiben und wenn's nur eine
        1 zu 1 Kopie von hier ist.
        Also irgenwie gibt's Probleme mit dem Seitenvorschub, vor allem
        in Verbindung mit 'SKIP'. Der HP-TUNIX-Assembler macht nach
        maximal 57 Zeilen Programmtext einen Seitenvorschub, bei uns
        kann das auch schon mal nach 56 Zeilen passieren, aber nur
        nach einem 'SKIP', wie's aussieht. Also mssen wir da ein
        wenig nachbessern. Im brigen scheint's geringe Unterschiede
        bei IF ELSE ENDIF zu geben. Wir schreiben im LIST-Modus
        nichts hin, wenn IF-state true ist, HP tut's aber. Solcherlei
        Kleinigkeiten lassen wir aber im Moment auen vor.
        Dafr ersetzen wir 'delay' durch 'mein_delay' weil die PCs
        inzwischen ja viel zu schnell geworden sind.

zss3/3.04 20.03.2000: Der Seitenvorschub ist soweit ok. Wir haben
        auch gleich eine Symboltabelle mit an's Listing gehngt,
        weil's so schn ist. Wenn dann spter noch mehr Energie
        brig sein sollte, knnen wir ja wirklich auch noch eine
        Crossreferenz probieren?

zss3/3.05 25.03.2000: Symboltabelle um ein Zeichen breiter machen,
        damit noch mehr Gleichheit zu HP besteht. Ja, wir beginnen
        nun tatschlich mit berlegungen zur Crossreferenz. In einem
        ersten Anlauf werden wir aber nur die Namenstypen 4 und 5 und
        wahrscheinlich 2 (Macros) behandeln. Bei HP scheinen auch
        lokale Macrovariable zum Zuge zu kommen. Das ist aber
        irgendwie bld, weil wir die gar nicht global verwalten. HP
        hat da, wenn ich mich recht erinnere, sowieso nicht ganz
        konsequent gearbeitet. Bei uns werden lokale Macrovariablen
        in den llts verwaltet. Dabei bercksichtigen wir ggf. eine
        Verschachtelung beim Macroaufruf. Einfach nur anzugeben,
        in welcher (globalen) Zeile ein ganz bestimmter (macro-
        lokaler) Name auftaucht, ist nicht sehr elegant. Wir lassen
        das Thema zunchst einfach auen vor. Es gibt nmlich auch
        so schon gengend Fragen: sollen wir auch nur die (globale)
        Zeile der Definition bzw. der Referenz notieren, wie das HP
        tut oder sollen wir die exakte Stelle mit der vollen Verschach-
        telung angeben, also alle Zeilennummern aller includierten Files
        und expandierten Macros? Wollen wir bei den (redefinablen)
        Variablen nur eine oder alle 'Definitionsstellen' angeben?
        Wir probieren zunchst einfach folgendes: der Namens-record
        (nr) bekommt ein weiteres Element, nmlich einen Pointer
        auf eine einfach verkettete Liste von Zeilennummern. Jeder
        Bezug auf den Namen, egal ob Definition oder Referenz wird
        hier protokolliert mit der (globalen) Zeilennummer, falls
        sie nicht schon irgendwo in der Kette auftaucht. Mal sehen,
        wie weit wir damit kommen.

zss3/3.06 29.03.2000: Scheint wieder mal soweit alles o.k. zu sein.
        Vielleicht fgen wir noch ein oder zwei Kommandozeilen-
        parameter ein, um die Generierung von Symbol- und Querver-
        weistabelle auch abschalten zu knnen.

zss3/3.06 29.03.2000: Noch etwas Kosmetik bei den Kommandozeilen-
        parametern.
}
