{$R+}
{$N+}
{$M$ff00,0,$a0000}

UNIT zss3u1;                    {30.03.2000 / shu}


INTERFACE                       {UNIT zss3u1}


USES
  CTVU1;


FUNCTION sysclock:longint;
PROCEDURE mein_delay(dauer_in_ms: longint);
PROCEDURE beep;
PROCEDURE page;
FUNCTION bincmp(x:longint):longint;
FUNCTION binlsr(x,y:longint):longint;
FUNCTION binlsl(x,y:longint):longint;
FUNCTION binand(x,y:longint):longint;
FUNCTION binior(x,y:longint):longint;
FUNCTION file_existiert(VAR fname: string_255):boolean;
PROCEDURE str_zu_sftyp(str_loc: string_255;
                       VAR sft_loc: sftyp; VAR sft_len_loc: longint);
PROCEDURE sftyp_zu_str(VAR sft_loc: sftyp; VAR sft_len_loc: longint;
                       VAR str_loc: string_255);
PROCEDURE myreset(VAR myfile: bfrr);
PROCEDURE myread(VAR myfile: bfrr; VAR wert: byte);
FUNCTION myeof(VAR myfile: bfrr):boolean;
PROCEDURE schreibe_llt(lmel:longint; lmces:krznt);
PROCEDURE schreibe_alle_llt;
PROCEDURE write_in_hex(VAR nam:text; wert,dig:longint; fill:char);
PROCEDURE schreibe_tnf(VAR nam:text; VAR nfloc: gnr);
PROCEDURE schreibe_alle_nam;
PROCEDURE schreibe_macros;
PROCEDURE schreibe_zlboc(VAR fn:text;von,bis:longint);
PROCEDURE zeige_zlboc(von,bis:longint);
PROCEDURE str_od_expr(VAR sfeld:sftyp;VAR llen:longint;
                      VAR anz:longint;VAR delim:char);
PROCEDURE check_len(i:longint);
PROCEDURE update_crr(zcrr_loc: zcrrt; zeile: longint);
PROCEDURE suche_name(VAR nfloc: gnr; VAR sfeld:sftyp;
                     VAR cl:longint;VAR findex,iindex:longint);
PROCEDURE suche_label(VAR llt_nr:longint; VAR sfeld:sftyp; VAR laeng:longint;
                      VAR nr:longint; VAR mlf:boolean);
FUNCTION ausdr_typ(VAR roman:sftyp; VAR rlen:longint):longint;
FUNCTION wandle(VAR fterm:sftyp; ftlen:longint):longint;
PROCEDURE suche_loc_var(VAR ifeld:sftyp; VAR iflen:longint; VAR ofeld:sftyp;
                        VAR oflen:longint; VAR loc_var_gef:boolean);
PROCEDURE zeile_abgrasen(VAR di:bfrr; VAR ozi:longint; VAR len:tlen;
                         VAR zlboc:tzlboc);
PROCEDURE zeile_expandieren(VAR ozi:longint; VAR len:tlen; VAR zlboc:tzlboc;
                            VAR llen:tlen; VAR lzlboc:tzlboc;
                            lzz,von_wo: longint);
PROCEDURE insert_name(VAR nfloc:gnr; VAR sfeld:sftyp;
                      VAR cl,uoz,unt,uw:longint);
PROCEDURE insert_vmp(typ,wert,oz:longint);
PROCEDURE initialisierung;
PROCEDURE ist_file_name_gut(VAR fname_usp,fname_bas: string_255;
                            VAR gut: boolean );
PROCEDURE welches_file(VAR file_name_gueltig:boolean);
PROCEDURE zl_IF_true;
PROCEDURE zl_IF_false;
PROCEDURE zl_IF_true_skip_title;
PROCEDURE zl_IF_false_skip_title;
PROCEDURE zl_IF_true_pmacro;
PROCEDURE setze_anzeige(wert,dig:longint);
PROCEDURE suche_befehl(VAR gwert,pcn,lzz:longint; von_wo: longint);
PROCEDURE suche_pm_befehl(VAR gwert,pcn,typlbl,wertlbl,lzz:longint);
PROCEDURE erster_lauf;


IMPLEMENTATION                  {UNIT zss3u1}


USES
  DOS, CRT, ZSS3U2;


FUNCTION sysclock:longint;
  VAR
    h, m, s, s100:              word;
    hl, ml, sl, s100l:          longint;

  BEGIN                         {FUNCTION sysclock}
    GetTime(h,m,s,s100);
    hl:=h;
    ml:=m;
    sl:=s;
    s100l:=s100;
    sysclock:=s100l+100*sl+6000*ml+360000*hl;
  END;                          {FUNCTION sysclock}

PROCEDURE mein_delay(dauer_in_ms: longint);
  CONST
    ein_tag=                    24*60*60*100;
  VAR
    zeit1, zeit2:               longint;
    dauer_in_cs:                longint;

  BEGIN                         {PROCEDURE mein_delay}
    {
    'mein_delay' soll arbeiten wie 'delay', d.h. der bergebene
    Parameter stellt die Wartezeit in milli-s dar. 'sysclock' zeigt
    allerdings die Tageszeit in centi-s an. Daher mu die gewnschte
    Wartezeit erst mal umgerechnet werden. Dabei runden wir ein bichen
    nach oben, weil uns zu kurze Wartezeiten eher stren als zu lange.
    }
    dauer_in_cs:=(dauer_in_ms+9) DIV 10;

    zeit1:=sysclock;
    REPEAT
      zeit2:=sysclock;
      IF (zeit2<zeit1) THEN zeit2:=zeit2+ein_tag;
    UNTIL (zeit2-zeit1) >= dauer_in_cs;
    {
    writeln;
    write('zeit1: ', zeit1);
    write('zeit2: ', zeit2);
    }
  END;                          {PROCEDURE mein_delay}

PROCEDURE beep;
  BEGIN                         {PROCEDURE beep}
    Sound(880);
    mein_delay(160);
    NoSound;
  END;                          {PROCEDURE beep}

PROCEDURE page;
  BEGIN                         {PROCEDURE page}
    clrscr;
  END;                          {PROCEDURE page}

FUNCTION bincmp(x:longint):longint;
  BEGIN                         {FUNCTION bincmp}
    bincmp:=NOT x;
  END;                          {FUNCTION bincmp}

FUNCTION binlsr(x,y:longint):longint;
  BEGIN                         {FUNCTION binlsr}
    binlsr:=x SHR y;
  END;                          {FUNCTION binlsr}

FUNCTION binlsl(x,y:longint):longint;
  BEGIN                         {FUNCTION binlsl}
    binlsl:=x SHL y;
  END;                          {FUNCTION binlsl}

FUNCTION binand(x,y:longint):longint;
  BEGIN                         {FUNCTION binand}
    binand:=x AND y;
  END;                          {FUNCTION binand}

FUNCTION binior(x,y:longint):longint;
  BEGIN                         {FUNCTION binior}
    binior:=x OR y;
  END;                          {FUNCTION binior}

FUNCTION file_existiert(VAR fname: string_255):boolean;
  VAR
    fb:                         FILE OF byte;
  BEGIN                         {FUNCTION file_existiert}
    assign(fb,fname);
    {$I-} reset(fb); {$I+}
    IF ioresult<>0 THEN
      BEGIN
        file_existiert:=false;
      END                       {IF ioresult}
    ELSE
      BEGIN
        file_existiert:=true;
        close(fb);
      END;                      {ELSE ioresult}
  END;                          {FUNCTION file_existiert}

PROCEDURE str_zu_sftyp(str_loc: string_255;
                       VAR sft_loc: sftyp; VAR sft_len_loc: longint);
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE str_zu_sftyp}
    sft_len_loc:=length(str_loc);
    FOR i:=0 TO sft_len_loc-1 DO
      BEGIN
        sft_loc[i]:=str_loc[i+1];
      END;                      {FOR i}
  END;                          {PROCEDURE str_zu_sftyp}

PROCEDURE sftyp_zu_str(VAR sft_loc: sftyp; VAR sft_len_loc: longint;
                       VAR str_loc: string_255);
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE sftyp_zu_str}
    str_loc:='';
    FOR i:=0 TO sft_len_loc-1 DO
      BEGIN
        str_loc:=str_loc+sft_loc[i];
      END;                      {FOR i}
  END;                          {PROCEDURE sftyp_zu_str}

PROCEDURE myreset(VAR myfile: bfrr);
  BEGIN                         {PROCEDURE myreset}
    WITH myfile DO
      BEGIN
        reset(bfr,1);           {Recordgre ist 1}
        bfrbf:=0;               {Fllstand und Lesepointer}
        bfrbp:=0;               {rcksetzten}
      END;                      {WITH myfile}
  END;                          {PROCEDURE myresets}

PROCEDURE myread(VAR myfile: bfrr; VAR wert: byte);
  VAR
    result:                     word;

  BEGIN                         {PROCEDURE myread}
    WITH myfile DO
      BEGIN
        IF bfrbp < bfrbf THEN
          {Falls ein Byte da ist, nehmen wir das:}
          BEGIN
            bfrbp:=bfrbp+1;
            wert:=bfrb[bfrbp];
          END                   {IF bfrbp < bfrbf}
        ELSE
          {Falls nichts mehr da ist, fhren wir einen 'BlockRead'
          durch. Auf eof wollen wir vor Aufruf von 'myread' prfen, so
          da wir das hier nicht tun mssen}
          BEGIN
            BlockRead(bfr, bfrb, bfrbl, result);
            bfrbf:=result;
            bfrbp:=0;
            IF bfrbf=0 THEN
              BEGIN
                fm('Unerwartetes Fileende im Quelltext',
                   zlboc[0],len[0]);
              END               {IF bfrbf=0}
            ELSE
              BEGIN
                bfrbp:=bfrbp+1;
                wert:=bfrb[bfrbp];
              END;              {ELSE bfrbf=0}
          END;                  {ELSE bfrbp < bfrbf}
      END;                      {WITH myfile}
  END;                          {PROCEDURE myread}

FUNCTION myeof(VAR myfile: bfrr):boolean;
  BEGIN                         {FUNCTION myeof}
    WITH myfile DO
      BEGIN
        IF bfrbp < bfrbf THEN
          {Falls noch mindestens ein Byte da ist, gilt noch nicht eof:}
          BEGIN
            myeof:=false;
          END                   {IF bfrbp < bfrbf}
        ELSE
          {Falls nichts mehr da ist, prfen wir eof direkt:}
          BEGIN
            myeof:=eof(bfr);
          END;                  {ELSE bfrbp < bfrbf}
      END;                      {WITH myfile}
  END;                          {FUNCTION myeof}

PROCEDURE schreibe_llt(lmel:longint; lmces:krznt);
  VAR
    llto:                       text;
    i,k:                        longint;
    fnam:                       string[7];
  BEGIN                         {PROCEDURE schreibe_llt}
    fnam:='       ';
    IF llt[lmel]<>NIL THEN
      BEGIN
        WITH llt[lmel]^ DO
          BEGIN
            IF anz_ml>=1 THEN
              BEGIN
                fnam[1]:='l';
                fnam[2]:='l';
                fnam[3]:='t';
                fnam[4]:=lmces[3];
                fnam[5]:=lmces[2];
                fnam[6]:=lmces[1];
                fnam[7]:=lmces[0];
                assign(llto,fnam);
                rewrite(llto);
                FOR i:=0 TO anz_ml-1 DO
                  BEGIN
                    write(llto,i:4,' ');
                    FOR k:=0 TO max_cl DO
                      BEGIN
                        IF k<name_len_ml[i] THEN write(llto,name_ml[i,k])
                        ELSE write(llto,' ');
                      END;
                    write(llto,' g: ',gueltig_ml[i]:8);
                    IF gueltig_ml[i] THEN write(llto,' w: ',wert_ml[i]:12)
                    ELSE write(llto,' w: ','  ----------');
                    write(llto,' zlnr: ',zeil_nr_ml[i]:4);
                    write(llto,' o: ',oft_ml[i]:8);
                    writeln(llto);
                  END;          {FOR i:=0 ..}
                close(llto);
              END;              {IF anz_ml>=1}
          END;                  {WITH llt[lmel]^}
      END;                      {IF llt[lmel]<>NIL}
  END;                          {PROCEDURE schreibe_llt}

PROCEDURE schreibe_alle_llt;
  VAR
    i:                          longint;
    lmel:                       longint;        {local mel}
    lmelc:                      longint;
    mels:                       krznt;          {mel-string}

  BEGIN                         {PROCEDURE schreibe_alle_llt}
    FOR lmel:=1 TO mel DO
      BEGIN
        lmelc:=lmel;
        FOR i:=0 TO 3 DO
          BEGIN
            mels[i]:=h[lmelc MOD 10];
            lmelc:=lmelc DIV 10;
          END;
        schreibe_llt(lmel,mels);
      END;
  END;                          {PROCEDURE schreibe_alle_llt}

PROCEDURE write_in_hex(VAR nam:text; wert,dig:longint; fill:char);
  VAR
    i:                          longint;
    wa:                         krznt;  {Wertanzeige}
    noch_null:                  boolean;
  BEGIN                         {PROCEDURE write_in_hex}
    FOR i:=0 TO dig-1 DO
      BEGIN
        wa[i]:=h[wert AND $F];
        wert:=binlsr(wert,4);
      END;                      {FOR i}
    noch_null:=true;
    FOR i:=dig-1 DOWNTO 0 DO    {Wert in hex ausgeben}
      BEGIN                     {fhrende Nullen weg}
        IF (noch_null AND (i>0)) THEN
          BEGIN
            IF wa[i]='0' THEN
              write(nam, fill)
            ELSE
              BEGIN
                write(nam,wa[i]);
                noch_null:=false;
              END;
          END
        ELSE write(nam,wa[i]);
      END;                      {FOR i}
  END;                          {PROCEDURE write_in_hex}

PROCEDURE schreibe_tnf(VAR nam:text; VAR nfloc: gnr);
  VAR
    j,k,l:                      longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}

  BEGIN                         {PROCEDURE schreibe_tnf}
    writeln(nam,'        ********        NEUES NAMENSFELD        ********');
    writeln(nam);
    writeln(nam,' Nr.    Name            ;      Wert(Dez/Hex)      Typ(Dez/Hex)   Sel   Ind');
    writeln(nam);
    WITH nfloc DO
      BEGIN
        FOR l:=1 TO anznh DO
          BEGIN
            FOR k:=enh[l-1] TO enh[l]-1 DO
              BEGIN
                nf_sel:=(k AND (NOT max_gtnf)) SHR mgtnfb;
                nf_ind:=k AND max_gtnf;
                IF nf[nf_sel]^[nf_ind]<>NIL THEN
                  BEGIN
                    WITH nf[nf_sel]^[nf_ind]^ DO
                      BEGIN
                        IF nt=nt THEN {hier Typauswahl mglich}
                          BEGIN
                            write(nam,k:4,'  ');
                            FOR j:=0 TO max_cl DO
                              BEGIN
                                IF j<l THEN write(nam,name[j])
                                ELSE write(nam,' ');
                              END;
                            write(nam,'  ; ');

                            write(nam,wert:8,'  ');
                            write_in_hex(nam, wert, 8, ' ');

                            write(nam,nt:8,'  ');
                            write_in_hex(nam, nt, 8, ' ');

                            write(nam,'  ',nf_sel:4);
                            write(nam,'  ',nf_ind:4);
                            writeln(nam);
                          END;{IF nt=nt}
                      END;      {WITH nf[nf_sel]^[nf_ind]^}
                  END;          {IF nf[nf_sel]^[nf_ind]<>NIL}
              END;              {FOR k}
          END;                  {FOR l}
      END;                      {WITH nfloc}
    writeln(nam);
  END;                          {PROCEDURE schreibe_tnf}

PROCEDURE schreibe_alle_nam;
  VAR
    nam:                        text;

  BEGIN                         {PROCEDURE schreibe_alle_nam}
    assign(nam,'namen');
    rewrite(nam);
    schreibe_tnf(nam, nfb);
    schreibe_tnf(nam, nfl);
    close(nam);
  END;                          {PROCEDURE schreibe_alle_nam}

PROCEDURE schreibe_macros;
  VAR
    i,k:                        longint;
    ind1:                       longint;
    maca_sel, maca_ind:         word;   {Macro array selector, -index}
    mac:                        text;
  BEGIN                         {PROCEDURE schreibe_macros}
    assign(mac,'macros');
    rewrite(mac);
    FOR i:=0 TO zzmr-1 DO
      BEGIN
        write(mac,i:4,'  ');
        ind1:=mzs^[i];
        FOR k:=0 TO mzs^[i+1]-mzs^[i]-1 DO
          BEGIN
            maca_sel:=((ind1+k) AND (NOT max_gtma)) SHR mgtmab;
            maca_ind:= (ind1+k) AND max_gtma;
            write(mac,ma[maca_sel]^[maca_ind]);
          END;
        writeln(mac);
      END;
    close(mac);
  END;                         {PROCEDURE schreibe_macros}

PROCEDURE schreibe_zlboc(VAR fn:text;von,bis:longint);
  VAR
    i,k:                        longint;
  BEGIN                         {PROCEDURE schreibe_zlboc}
    FOR k:=von TO bis DO
      BEGIN
        IF len[k]>0 THEN
          BEGIN
            FOR i:=0 TO len[k]-1 DO
              BEGIN
                write(fn,zlboc[k,i]);
              END;
            IF k<bis THEN writeln(fn);
          END;                  {IF len[k]}
      END;                      {FOR k}
  END;                          {PROCEDURE schreibe_zlboc}

PROCEDURE zeige_zlboc(von,bis:longint);
  VAR
    i,k:                        longint;
  BEGIN                         {PROCEDURE zeige_zlboc}
    writeln;
    FOR k:=von TO bis DO
      BEGIN
        IF len[k]>0 THEN
          BEGIN
            write(k:4,len[k]:4,':');
            FOR i:=0 TO len[k]-1 DO
              BEGIN
                write(zlboc[k,i]);
              END;
            IF k<bis THEN writeln;
          END;                  {IF len[k]}
      END;                      {FOR k}
    readln;
  END;                          {PROCEDURE zeige_zlboc}

PROCEDURE str_od_expr(VAR sfeld:sftyp;VAR llen:longint;
                      VAR anz:longint;VAR delim:char);
  VAR
    ez:                         char;   {erstes Zeichen}
    i:                          longint;
    weiter:                     boolean;
  BEGIN                         {PROCEDURE str_od_expr}
    ez:=sfeld[0];
    IF ez IN [chr(39),chr(34),chr(94)] THEN
      BEGIN
        i:=0;
        weiter:=true;
        REPEAT
          i:=i+1;
          IF i=llen THEN fm('Fehlender Begrenzer am String-ende',
                             sfeld,llen);
          IF ez=sfeld[i] THEN weiter:=false;
        UNTIL NOT weiter;
        IF i<llen-1 THEN
          BEGIN
            anz:=1;
            delim:=' ';         {blank fr expression}
          END
        ELSE
          BEGIN                 {jetzt ist also i=llen-1}
            anz:=llen-2;
            delim:=ez;
          END;
      END
    ELSE
      BEGIN                     {hier sowieso kein String}
        anz:=1;
        delim:=' ';
      END;
  END;                          {PROCEDURE str_od_expr}

PROCEDURE check_len(i:longint);
  CONST
    alm1=                       al-1;
  VAR
    op_nr:                      string_255;

  BEGIN                         {PROCEDURE check_len}
    IF len[i]=0 THEN
      BEGIN
        CASE i OF
          1:            fm('Label erwartet, es ist aber keines da',
                           zlboc[0],len[0]);
          3..alm1:
            BEGIN
              Str(i - 2, op_nr);
              fm('Operand ' + op_nr + ' erwartet, er ist aber nicht da',
                 zlboc[0],len[0]);
            END;                {CASE 3..alm1 OF i}
        END;                    {CASE i}
      END;                      {IF len[i]=0}
  END;                          {PROCEDURE check_len}

PROCEDURE update_crr(zcrr_loc: zcrrt; zeile: longint);
  VAR
    zcrr_tmp:                   zcrrt;
    ende_erreicht:              boolean;
    zeile_schon_da:             boolean;
  BEGIN                         {PROCEDURE update_crr}
    IF zcrr_loc=NIL THEN
      BEGIN
        fm('NULL-Pointer in ''update_crr''',
           zlboc[0],len[0]);
      END;                      {IF zcrr_loc=NIL}
    zcrr_tmp:=zcrr_loc;

    ende_erreicht:=false;
    zeile_schon_da:=false;
    REPEAT
      IF zcrr_loc<>NIL THEN
        BEGIN
          zcrr_tmp:=zcrr_loc;
          zcrr_loc:=zcrr_loc^.zcrr;
          IF zcrr_tmp^.glob_zeile=zeile THEN zeile_schon_da:=true;
        END                     {IF zcrr_loc<>NIL}
      ELSE
        BEGIN
          ende_erreicht:=true;
        END;                    {ELSE zcrr_loc<>NIL}
    UNTIL ende_erreicht OR zeile_schon_da;

    IF ende_erreicht THEN
      BEGIN
        IF MaxAvail<(SizeOf(crr)) THEN
          BEGIN
            fm('Zu wenig Speicher (11)', zlboc[0],len[0]);
          END;
        new(zcrr_tmp^.zcrr);
        WITH zcrr_tmp^.zcrr^ DO
          BEGIN
            glob_zeile:=zeile;
            zcrr:=NIL;
          END;                  {WITH zcrr_loc^.zcrr^}
      END;                      {IF ende_erreicht}
  END;                          {PROCEDURE update_crr}

PROCEDURE suche_name(VAR nfloc: gnr; VAR sfeld:sftyp;
                     VAR cl:longint;VAR findex,iindex:longint);
  VAR
    max,min:                    longint;
  FUNCTION ist_nzusu_kleiner(i:longint):boolean;
    VAR
      k:                        longint;
      erfuellt:                 boolean;
      c1,c2:                    char;
      nf_sel, nf_ind:           word;   {Namensfeld selector, -index}

    BEGIN                       {FUNCTION ist_nzusu_kleiner}
      erfuellt:=false;
      k:=0;
      nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
      nf_ind:=i AND max_gtnf;
      WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
        BEGIN
          REPEAT
            c1:=sfeld[k];
            c2:=name[k];
            IF c1<c2 THEN erfuellt:=true;
            k:=k+1;
          UNTIL (erfuellt OR (c1>c2) OR (k=cl));
        END;                    {WITH nfloc.nf[nf_sel]^[nf_ind]^}
      IF erfuellt THEN ist_nzusu_kleiner:=true
      ELSE ist_nzusu_kleiner:=false;
    END;                        {FUNCTION ist_nzusu_kleiner}

  FUNCTION ist_nzusu_gleich(i:longint):boolean;
    VAR
      k:                        longint;
      erfuellt:                 boolean;
      c1,c2:                    char;
      nf_sel, nf_ind:           word;   {Namensfeld selector, -index}

    BEGIN                       {FUNCTION ist_nzusu_gleich}
      erfuellt:=true;
      k:=0;
      nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
      nf_ind:=i AND max_gtnf;
      WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
        BEGIN
          REPEAT
            c1:=sfeld[k];
            c2:=name[k];
            IF c1<>c2 THEN erfuellt:=false;
            k:=k+1;
          UNTIL ((NOT erfuellt) OR (k=cl));
        END;
      IF erfuellt THEN ist_nzusu_gleich:=true
      ELSE ist_nzusu_gleich:=false;
    END;                        {FUNCTION ist_nzusu_gleich}

  FUNCTION ist_nzusu_groesser(i:longint):boolean;
    VAR
      k:                        longint;
      erfuellt:                 boolean;
      c1,c2:                    char;
      nf_sel, nf_ind:           word;   {Namensfeld selector, -index}

    BEGIN                       {FUNCTION ist_nzusu_groesser}
      erfuellt:=false;
      k:=0;
      nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
      nf_ind:=i AND max_gtnf;
      WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
        BEGIN
          REPEAT
            c1:=sfeld[k];
            c2:=name[k];
            IF c1>c2 THEN erfuellt:=true;
            k:=k+1;
          UNTIL (erfuellt OR (c1<c2) OR (k=cl));
        END;
      IF erfuellt THEN ist_nzusu_groesser:=true
      ELSE ist_nzusu_groesser:=false;
    END;                        {FUNCTION ist_nzusu_groesser}

  PROCEDURE suche_nzusu(links,rechts:longint);
    VAR
      d,mitte:                  longint;
    BEGIN                       {PROCEDURE suche_nzusu}
      d:=rechts-links;
      IF ((d=1) OR (d=0)) THEN
        BEGIN
          IF ist_nzusu_gleich(links) THEN
            BEGIN
              findex:=links;
            END
          ELSE
            BEGIN
              IF ist_nzusu_gleich(rechts) THEN
                BEGIN
                  findex:=rechts;
                END
              ELSE
                BEGIN
                  iindex:=rechts;
                END;
            END;
        END
      ELSE                      {IF (d=1) OR (d=0)}
        BEGIN
          mitte:=links+d DIV 2;
          IF ist_nzusu_kleiner(mitte) THEN
            BEGIN
              suche_nzusu(links,mitte);
            END
          ELSE
            BEGIN
              suche_nzusu(mitte,rechts);
            END;
        END;
    END;                        {PROCEDURE suche_nzusu}

  BEGIN                         {PROCEDURE suche_name}
    findex:=-1;                 {default: name nicht gefunden}
    iindex:=-1;                 {default: nichts einfgen}
    IF cl>0 THEN
      BEGIN
        IF cl>max_cl+1 THEN fm('max_cl zu klein (Name zu lang)',
                            sfeld,cl);
        WITH nfloc DO
          BEGIN
            min:=enh[cl-1];
            max:=enh[cl]-1;
          END;                  {WITH nfloc}
        IF ((max-min)=-1) THEN
          BEGIN
            iindex:=min;
          END
        ELSE
          BEGIN
            IF ist_nzusu_kleiner(min) THEN
              BEGIN
                iindex:=min;
              END
            ELSE
              BEGIN
                IF ist_nzusu_groesser(max) THEN
                  BEGIN
                    iindex:=max+1;
                  END
                ELSE
                  BEGIN
                    suche_nzusu(min,max);
                  END;
              END;
          END;
      END;                      {IF cl>0}
  END;                          {PROCEDURE suche_name}

PROCEDURE suche_label(VAR llt_nr:longint; VAR sfeld:sftyp; VAR laeng:longint;
                      VAR nr:longint; VAR mlf:boolean);
  VAR
    i:                          longint;
    nr_gefunden:                boolean;
  BEGIN
    WITH llt[llt_nr]^ DO
      BEGIN
        IF anz_ml=0 THEN mlf:=false
        ELSE
          BEGIN
            nr:=0;
            nr_gefunden:=false;
            WHILE ((nr<anz_ml) AND (NOT nr_gefunden)) DO
              BEGIN
                IF name_len_ml[nr]<>laeng THEN nr:=nr+1
                ELSE
                  BEGIN
                    nr_gefunden:=true;
                    i:=0;
                    REPEAT
                      IF name_ml[nr,i]<>sfeld[i] THEN
                        BEGIN
                          nr_gefunden:=false;
                          nr:=nr+1;
                        END
                      ELSE i:=i+1;
                    UNTIL ((NOT nr_gefunden) OR (i=laeng));
                  END;
              END;              {WHILE}
            IF nr_gefunden THEN mlf:=true
            ELSE mlf:=false;
          END;                  {ELSE anz_ml=0}
      END;                      {WITH llt[llt_nr]^}
  END;                          {PROCEDURE suche_label}

FUNCTION ausdr_typ(VAR roman:sftyp; VAR rlen:longint):longint;
  BEGIN                         {FUNCTION ausdr_typ}
    {
    Wir wollen 4 verschiedene Ausdruckstypen unterscheiden:
    Typ0: m, mn
    Typ1: [m], [mn]
    Heute (31.03.96) bemerken wir, da die Typen 2 und 3 ggf. auch
    ohne '+d' dastehen knnen, was soviel heien soll wie '+0'. Also:
    Typ2: [IX+d], [IX]
    Typ3: [IY+d], [IY]
    Unten wird zwischen roman[3]='+' und roman[3]=']' unterschieden und
    dann doch kein Unterschied gemacht. Dies ist historisch bedingt, als
    noch nicht klar war, da wir beide Flle gleichzeitig in
    'ein_Ausdruck' erschlagen knnen.

    Ist das erste Zeichen nicht '[', liegt Typ0 vor, usw.
    }
    IF (roman[0]<>'[') THEN
      BEGIN
        ausdr_typ:=0;
      END                       {IF (roman[0]<>'['}
    ELSE
      BEGIN
        IF (roman[rlen-1]<>']') THEN
          BEGIN
            fm('Schlieende Klammer "]" fehlt am Ende des Ausdrucks',
               roman,rlen);
          END                   {IF (roman[rlen]...}
        ELSE
          BEGIN
            IF roman[1]='I' THEN
              BEGIN
                CASE roman[3] OF
                  '+':
                    BEGIN
                      CASE roman[2] OF
                        'X':
                          BEGIN
                            ausdr_typ:=2;
                          END;  {CASE 'X' OF roman[2]}

                        'Y':
                          BEGIN
                            ausdr_typ:=3;
                          END;  {CASE 'Y' OF roman[2]}

                        ELSE
                          BEGIN
                            ausdr_typ:=1;
                          END;  {CASE ELSE OF roman[2]}
                      END;      {CASE roman[2]}
                    END;        {CASE '+' OF roman[3]}

                  ']':
                    BEGIN
                      CASE roman[2] OF
                        'X':
                          BEGIN
                            ausdr_typ:=2;
                          END;  {CASE 'X' OF roman[2]}

                        'Y':
                          BEGIN
                            ausdr_typ:=3;
                          END;  {CASE 'Y' OF roman[2]}

                        ELSE
                          BEGIN
                            ausdr_typ:=1;
                          END;  {CASE ELSE OF roman[2]}
                      END;      {CASE roman[2]}
                    END;        {CASE ']' OF roman[3]}

                  ELSE
                    BEGIN
                      ausdr_typ:=1;
                    END;        {CASE ELSE OF roman[3]}
                END;            {CASE roman[3]}
              END               {IF roman[1]='I'}
            ELSE
              BEGIN
                ausdr_typ:=1;
              END;              {ELSE roman[1]='I'}
          END;                  {ELSE (roman[rlen]<>']'}
      END;                      {ELSE (roman[0]<>'['}
  END;                          {FUNCTION ausdr_typ}

FUNCTION wandle(VAR fterm:sftyp; ftlen:longint):longint;

  VAR
    typf:                       sftyp;          {typ des items}
    wertf:                      iftyp;          {Wert gltig bei typf[i]='w'}
                                                {bzw. typf[i]='f'}
    iaf:                        longint;        {Index fr Auswertefeld}

  FUNCTION ausdruck:longint;
    VAR
      h1,h2:                    longint;        {Hilfswrte}
      atyp:                     char;           {aktueller item-typ}
    FUNCTION groesse:longint;
      VAR
        atyp:                   char;           {aktueller item-typ}
      BEGIN                     {FUNCTION groesse}
        atyp:=typf[iaf];
        iaf:=iaf+1;
        CASE atyp OF
          'w':
            BEGIN
              groesse:=wertf[iaf-1];
            END;

          '(':
            BEGIN
              groesse:=ausdruck;
              IF typf[iaf]<>')' THEN
                BEGIN
                  fm('")" fehlt in "groesse/ausdruck" (Syntaxerror)',
                     fterm,ftlen);
                END;
              iaf:=iaf+1;
            END;

          'n':
            BEGIN
              groesse:=bincmp(groesse);
            END;

          'f':
            BEGIN
              IF typf[iaf]<>'(' THEN
                BEGIN
                  fm('"(" fehlt in "groesse/f(ausdruck)" (Syntaxerror)',
                     fterm,ftlen);
                END;
              iaf:=iaf+1;
              CASE wertf[iaf-2] OF
                0:              {HIGH}
                  BEGIN
                    groesse:=binlsr(binand(ausdruck,$ff00),8);
                  END;
                1:              {LOW}
                  BEGIN
                    groesse:=binand(ausdruck,$ff);
                  END;
              END;
              IF typf[iaf]<>')' THEN
                BEGIN
                  fm('")" fehlt in "groesse/f(ausdruck)" (Syntaxerror)',
                     fterm,ftlen);
                END;
              iaf:=iaf+1;
            END;

          ELSE
            BEGIN
              fm('Fehler in "groesse/ELSE" (Syntaxerror)',fterm,ftlen);
            END;
        END;                    {CASE atyp}
      END;                      {FUNCTION groesse}

    FUNCTION und_oderand:longint;
      VAR
        h1,h2:                  longint;        {Hilfswerte}
        atyp:                   char;           {aktueller item-typ}
      BEGIN                     {FUNCTION und_oderand}
        h1:=groesse;
        atyp:=typf[iaf];
        WHILE atyp IN ['l','r'] DO
          BEGIN
            iaf:=iaf+1;
            h2:=groesse;
            IF atyp='l' THEN h1:=binlsl(h1,h2)
            ELSE h1:=binlsr(h1,h2);
            atyp:=typf[iaf];
          END;
        und_oderand:=h1;
      END;                      {FUNCTION und_oderand}

    FUNCTION faktor:longint;
      VAR
        h1,h2:                  longint;        {Hilfswerte}
        atyp:                   char;           {aktueller item-typ}
      BEGIN                     {FUNCTION faktor}
        h1:=und_oderand;
        atyp:=typf[iaf];
        WHILE atyp IN ['a','o'] DO
          BEGIN
            iaf:=iaf+1;
            h2:=und_oderand;
            IF atyp='a' THEN h1:=binand(h1,h2)
            ELSE h1:=binior(h1,h2);
            atyp:=typf[iaf];
          END;
        faktor:=h1;
      END;                      {FUNCTION faktor}

    FUNCTION summand:longint;
      VAR
        h1,h2:                  longint;        {Hilfswerte}
        atyp:                   char;           {aktueller item-typ}
      BEGIN                     {FUNCTION summand}
        h1:=faktor;
        atyp:=typf[iaf];
        WHILE atyp IN ['*','/'] DO
          BEGIN
            iaf:=iaf+1;
            h2:=faktor;
            IF atyp='*' THEN h1:=h1*h2
            ELSE
              BEGIN
                IF h2=0 THEN
                  BEGIN
                    fm('Division durch 0',fterm,ftlen);
                  END;
                h1:=h1 DIV h2;
              END;
            atyp:=typf[iaf];
          END;
        summand:=h1;
      END;                      {FUNCTION summand}

    FUNCTION einfacher_Ausdruck:longint;
      VAR
        h1,h2:                  longint;        {Hilfswerte}
        atyp:                   char;           {aktueller item-typ}
      BEGIN                     {FUNCTION einfacher_Ausdruck}
        atyp:=typf[iaf];
        CASE atyp OF
          '+':
            BEGIN
              iaf:=iaf+1;
              h1:=summand;
            END;

          '-':
            BEGIN
              iaf:=iaf+1;
              h1:=-summand;
            END;

          ELSE
            BEGIN
              h1:=summand;
            END;
        END;                    {CASE atyp}
        atyp:=typf[iaf];
        WHILE atyp IN ['+','-'] DO
          BEGIN
            iaf:=iaf+1;
            h2:=summand;
            IF atyp='+' THEN h1:=h1+h2
            ELSE h1:=h1-h2;
            atyp:=typf[iaf];
          END;
        einfacher_Ausdruck:=h1;
      END;                      {FUNCTION einfacher_Ausdruck}

    BEGIN                       {FUNCTION ausdruck}
      h1:=einfacher_Ausdruck;
      atyp:=typf[iaf];
      IF atyp IN ['=','u','<','>','K','G'] THEN
        BEGIN
          iaf:=iaf+1;
          h2:=einfacher_Ausdruck;
          CASE atyp OF
            '=':
              BEGIN
                IF h1=h2 THEN h1:=maxint
                ELSE h1:=0;
              END;

            'u':
              BEGIN
                IF h1<>h2 THEN h1:=maxint
                ELSE h1:=0;
              END;

            '<':
              BEGIN
                IF h1<h2 THEN h1:=maxint
                ELSE h1:=0;
              END;

            '>':
              BEGIN
                IF h1>h2 THEN h1:=maxint
                ELSE h1:=0;
              END;

            'K':
              BEGIN
                IF h1<=h2 THEN h1:=maxint
                ELSE h1:=0;
              END;

            'G':
              BEGIN
                IF h1>=h2 THEN h1:=maxint
                ELSE h1:=0;
              END;
          END;                  {CASE atyp}
        END;                    {IF}
      ausdruck:=h1;
    END;                        {FUNCTION ausdruck}

  FUNCTION ein_Ausdruck:longint;
    BEGIN                       {FUNCTION ein_Ausdruck}
      iaf:=0;
      {
      Beim Z180 mssen wir ein wenig tricksen mit verschiedenen
      Ausdruckstypen (m, n, [m], [mn], [IX+d] usw.). Je nach erkanntem
      Ausdruckstyp manipulieren wir ein wenig 'ir' und 'rlen' in
      'scan'. Dabei ergeben sich dann speziell bei [IX] und [IY]
      leere Auswertefelder, d.h. der gesamte Ausdruck ist bereits
      bei iaf=0 mit typf[0]=' ' zuende und wir wollen dem gesamten
      Ausdruck in diesem Fall den Wert 0 zuweisen.
      }
      IF typf[iaf]=' ' THEN
        BEGIN
          ein_Ausdruck:=0;
        END                     {IF typf[iaf]<>' '}
      ELSE
        BEGIN
          ein_Ausdruck:=ausdruck;
          IF typf[iaf]<>' ' THEN
            BEGIN
              fm('Fehler in "ein_Ausdruck" (Syntaxerror)',fterm,ftlen);
            END;
        END;                    {ELSE typf[iaf]<>' '}
    END;                        {FUNCTION ein_Ausdruck}

  PROCEDURE scan(VAR roman:sftyp; rlen:longint);
    VAR
      rch:                      char;           {Roman-character}
      sf:                       sftyp;          {string-feld}
      sfi:                      longint;        {string-feld-index}
      ir:                       longint;        {Index fr roman}

    PROCEDURE erhoehe_ir;
      BEGIN                     {PROCEDURE erhoehe_ir}
        ir:=ir+1;
        IF ir=rlen THEN
          BEGIN
            fm('Unvollstndiges item (Syntaxerror)',roman,rlen);
          END;
        rch:=roman[ir];
      END;                      {PROCEDURE erhoehe_ir}

    PROCEDURE trag_ein_typf(VAR buchst:char);
      BEGIN                     {PROCEDURE trag_ein_typf}
        typf[iaf]:=buchst;
        iaf:=iaf+1;
      END;                      {PROCEDURE trag_ein_typf}

    PROCEDURE prog_count;
      VAR
        b:                      char;
      BEGIN                     {PROCEDURE prog_count}
        ir:=ir+1;               {ir auf Anfang nchstes item setzen}
        wertf[iaf]:=pcs;
        b:='w';
        trag_ein_typf(b);
      END;                      {PROCEDURE prog_count}

    PROCEDURE punkt_op;
      VAR
        b:                      char;
      BEGIN                     {PROCEDURE punkt_op}
        erhoehe_ir;
        CASE rch OF
          'A':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'N':
                  BEGIN
                    b:='a';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .AN. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'A'}

          'E':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'Q':
                  BEGIN
                    b:='=';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .EQ. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'E'}

          'G':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'E':
                  BEGIN
                    b:='G';
                    trag_ein_typf(b);
                  END;

                'T':
                  BEGIN
                    b:='>';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .GE. oder .GT. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'G'}

          'L':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'E':
                  BEGIN
                    b:='K';
                    trag_ein_typf(b);
                  END;

                'T':
                  BEGIN
                    b:='<';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .LE. oder .LT. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'L'}

          'N':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'E':
                  BEGIN
                    b:='u';
                    trag_ein_typf(b);
                  END;

                'T':
                  BEGIN
                    b:='n';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .NE. oder .NT. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'N'}

          'O':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'R':
                  BEGIN
                    b:='o';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .OR. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'O'}

          'S':
            BEGIN
              erhoehe_ir;
              CASE rch OF
                'L':
                  BEGIN
                    b:='l';
                    trag_ein_typf(b);
                  END;

                'R':
                  BEGIN
                    b:='r';
                    trag_ein_typf(b);
                  END;

                ELSE
                  BEGIN
                    fm('Fehler bei .SL. oder .SR. (Syntaxerror)',roman,rlen);
                  END;
              END;              {CASE rch}
            END;                {'S'}

          ELSE
            BEGIN
              fm('Falscher Anfangsbuchstabe fr Punkt-operator',
                 roman,rlen);
            END;
        END;                    {CASE rch (von oben)}
        erhoehe_ir;
        IF rch<>'.' THEN
          BEGIN
            fm('Fehlender Punkt am Ende des Punkt-operators',
               roman,rlen);
          END;
        ir:=ir+1;               {ir auf Anfang nchstes item setzen}
      END;                      {PROCEDURE punkt_op}

    PROCEDURE kurzes_item;
      BEGIN                     {PROCEDURE kurzes_item}
        ir:=ir+1;               {ir auf Anfang nchstes item setzen}
        trag_ein_typf(rch);
      END;                      {PROCEDURE kurzes_item}

    PROCEDURE varfkt;
      VAR
        weiter:                 boolean;
        vfzeichen:              boolean;
        findex,iindex:          longint;
        elev:                   longint;        {expand level}
        nr:                     longint;        {Nummer}
        mlf:                    boolean;        {macro label found}
        mlg:                    boolean;        {macro label gltig}
        b:                      char;
        nf_sel, nf_ind:         word;   {Namensfeld selector, -index}

      BEGIN                     {PROCEDURE varfkt}
        sf[sfi]:=rch;
        sfi:=sfi+1;
        weiter:=true;
        REPEAT
          ir:=ir+1;
          IF ir=rlen THEN weiter:=false
          ELSE
            BEGIN
              rch:=roman[ir];
              vfzeichen:=rch IN ['A'..'Z','a'..'z','_','0'..'9'];
              IF vfzeichen THEN
                BEGIN
                  sf[sfi]:=rch;
                  sfi:=sfi+1;
                END;
            END;
        UNTIL ((NOT weiter) OR (NOT vfzeichen));
        {jetzt ist name vollstndig gelesen}
        {als nchstes wird geschaut, ob es sich um eine lokale}
        {Macro-variable handelt}
        mlg:=false;
        IF mel>0 THEN
          BEGIN
            elev:=mel;
            IF sfi>max_cl+1 THEN fm('Macro-Label zu lang',sf,sfi);
            REPEAT
              suche_label(elev,sf,sfi,nr,mlf);
              elev:=elev-1;
              IF mlf THEN mlg:=llt[elev+1]^.gueltig_ml[nr]
            UNTIL (mlg OR (elev=0));
          END;
        {Bei mlg=true wurde eine gltige Macrovariable gefunden,}
        {andernfalls wird in nf weitergesucht}
        IF mlg THEN
          BEGIN
            wertf[iaf]:=llt[elev+1]^.wert_ml[nr];
            b:='w';
            trag_ein_typf(b);
          END
        ELSE
          BEGIN
            suche_name(nfl,sf,sfi,findex,iindex);
            IF findex=-1 THEN {name nicht gefunden bei findex=-1}
              BEGIN
                fm('Variable/Funktion nicht gefunden',sf,sfi);
              END;
            nf_sel:=(findex AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind:=findex AND max_gtnf;
            WITH nfl.nf[nf_sel]^[nf_ind]^ DO
              BEGIN
                wertf[iaf]:=wert;
                CASE nt OF
                  8:  b:='f';   {Vordef. Fkt}
                  9:            {Verbotene SET-Variable}
                    BEGIN
                      fm('Es ist noch keine Wertzuweisung an Variable erfolgt',
                         sf,sfi);
                    END;        {CASE 9 OF nt}
                  ELSE b:='w';
                END;            {CASE nt}
                {
                Am Ende wollen wir noch die Querverweistabelle pflegen:
                }
                CASE nt OF
                  4,5:
                    BEGIN
                      update_crr(zcrr, zeile);
                    END;        {CASE 4,5 nt}
                  ELSE {nichts}
                END;            {CASE nt}

              END;              {WITH nfl.nf[nf_sel]^[nf_ind]^}
            trag_ein_typf(b);
          END;                  {ELSE mlg}
      END;                      {PROCEDURE varfkt}

    PROCEDURE num_const;
      VAR
        weiter:                 boolean;
        nczeichen:              boolean;        {num_const-zeichen}
        basis:                  longint;
      PROCEDURE zahl(VAR ordnung:longint);
        VAR
          ziffer,hw,i:          longint;
          b:                    char;
        BEGIN                   {PROCEDURE zahl}
          hw:=0;
          FOR i:=0 TO sfi-1 DO
            BEGIN
              ziffer:=ord(sf[i]);
              CASE ziffer OF
                48..57:  ziffer:=ziffer-48;
                65..70:  ziffer:=ziffer-55;
                97..102: ziffer:=ziffer-87;
                ELSE
                  BEGIN
                    fm('Als Ziffern sind nur erlaubt: 0..9, A..F, a..f',roman,rlen);
                  END;
              END;              {CASE ziffer}
              IF ziffer<ordnung THEN hw:=hw*ordnung+ziffer
              ELSE
                BEGIN
                  fm('Ziffer zu gro fr bentztes Zahlensystem',
                     roman,rlen);
                END;
            END;
          wertf[iaf]:=hw;
          b:='w';
          trag_ein_typf(b);
        END;                    {PROCEDURE zahl}

      BEGIN                     {PROCEDURE num_const}
        sf[sfi]:=rch;
        sfi:=sfi+1;
        weiter:=true;
        REPEAT
          ir:=ir+1;
          IF ir=rlen THEN weiter:=false
          ELSE
            BEGIN
              rch:=roman[ir];
              nczeichen:=rch IN ['0'..'9','A'..'F','Q','O','H',
                                          'a'..'f','q','o','h'];
              IF nczeichen THEN
                BEGIN
                  sf[sfi]:=rch;
                  sfi:=sfi+1;
                END;
            END;
        UNTIL ((NOT weiter) OR (NOT nczeichen));
        {jetzt ist num_const vollstndig gelesen}
        CASE sf[sfi-1] OF
          'Q','O','q','o':      {oktaler Wert}
            BEGIN
              sfi:=sfi-1;
              basis:=8;
              zahl(basis);
            END;

          'B','b':              {binrer Wert}
            BEGIN
              sfi:=sfi-1;
              basis:=2;
              zahl(basis);
            END;

          'D','d':              {dezimaler Wert}
            BEGIN
              sfi:=sfi-1;
              basis:=10;
              zahl(basis);
            END;

          'H','h':              {hexadezimaler Wert}
            BEGIN
              sfi:=sfi-1;
              basis:=16;
              zahl(basis);
            END;

          '0'..'9':             {dezimaler Wert (ohne 'D' bzw. 'd')}
            BEGIN
              basis:=10;
              zahl(basis);
            END;

          ELSE
            BEGIN
              fm('Ungltiges Zeichen am Ende der Konstante',roman,rlen);
            END;

        END;                    {CASE sf[sfi-1]}
      END;                      {PROCEDURE num_const}

    PROCEDURE werte_sf_aus;
      VAR
        hw,k,i:                 longint;
        b:                      char;
      BEGIN                     {PROCEDURE werte_sf_aus}
        hw:=0;
        k:=0;
        IF sfi>0 THEN
          BEGIN
            IF sfi>4 THEN
              BEGIN
                k:=sfi-4;
              END;
            FOR i:=k TO sfi-1 DO
              BEGIN
                hw:=hw*256+ord(sf[i]);
              END;
          END;                  {IF sfi}
        wertf[iaf]:=hw;
        b:='w';
        trag_ein_typf(b);
      END;                      {PROCEDURE werte_sf_aus}

    PROCEDURE strhk;
      BEGIN                     {PROCEDURE strhk}
        REPEAT
          erhoehe_ir;
          CASE rch OF
            chr(39):            {string zuende}
              BEGIN
                ir:=ir+1;       {ir auf Anfang nchstes item setzen}
                werte_sf_aus;
              END;

            ELSE
              BEGIN
                sf[sfi]:=rch;
                sfi:=sfi+1;
              END;
          END;                  {CASE rch}
        UNTIL rch=chr(39);
      END;                      {PROCEDURE strhk}

    PROCEDURE strap;
      BEGIN                     {PROCEDURE strap}
        REPEAT
          erhoehe_ir;
          CASE rch OF
            chr(34):            {string zuende}
              BEGIN
                ir:=ir+1;       {ir auf Anfang nchstes item setzen}
                werte_sf_aus;
              END;

            ELSE
              BEGIN
                sf[sfi]:=rch;
                sfi:=sfi+1;
              END;
          END;                  {CASE rch}
        UNTIL rch=chr(34);
      END;                      {PROCEDURE strap}

    PROCEDURE strca;
      BEGIN                     {PROCEDURE strca}
        REPEAT
          erhoehe_ir;
          CASE rch OF
            chr(94):            {string zuende}
              BEGIN
                ir:=ir+1;       {ir auf Anfang nchstes item setzen}
                werte_sf_aus;
              END;

            ELSE
              BEGIN
                sf[sfi]:=rch;
                sfi:=sfi+1;
              END;
          END;                  {CASE rch}
        UNTIL rch=chr(94);
      END;                      {PROCEDURE strca}

    PROCEDURE hole_item;
      BEGIN                     {PROCEDURE hole_item}
        rch:=roman[ir];
        CASE rch OF
          chr(39):              {Hochkomma (')}
            BEGIN
              strhk;            {string mit Hochkomma}
            END;

          chr(34):              {Apostroph (")}
            BEGIN
              strap;            {string mit Apostroph}
            END;

          chr(94):              {caret (^)}
            BEGIN
              strca;            {string mit caret}
            END;

          '0'..'9':             {Ziffer}
            BEGIN
              num_const;        {numerische Konstante}
            END;

          'A'..'Z','_':         {upper case letter und '_'}
            BEGIN
              varfkt;           {Name, d.h. Variable oder Funktion}
            END;

          '+','-','*','/','(',')','[',']':      {kurzes item}
            BEGIN
              kurzes_item;
            END;

          '.':                  {Punkt-operator}
            BEGIN
              punkt_op;
            END;

          '$':                  {Program counter}
            BEGIN
              prog_count;
            END;

          ELSE
            BEGIN
              fm('Fehler bei ''scan'': falscher item-beginn',
                 roman,rlen);
            END;
        END;                    {CASE rch}
      END;                      {PROCEDURE hole_item}

    BEGIN                       {PROCEDURE scan}
      CASE ausdr_typ(roman,rlen) OF
        0:                      {m, mn}
          BEGIN
            ir:=0;
          END;                  {CASE 0}

        1:                      {[m], [mn]}
          BEGIN
            ir:=1;
            rlen:=rlen-1;
          END;                  {CASE 1}

        2:                      {[IX+d]}
          BEGIN
            ir:=4;
            rlen:=rlen-1;
          END;                  {CASE 2}

        3:                      {[IY+d]}
          BEGIN
            ir:=4;
            rlen:=rlen-1;
          END;                  {CASE 3}

      END;                      {CASE ausdr_typ}
      iaf:=0;
      WHILE ir<rlen DO
        BEGIN
          sfi:=0;
          hole_item;
        END;                    {WHILE ir<rlen}
      typf[iaf]:=' ';           {' ' beendet Ausdruck}
    END;                        {PROCEDURE scan}

  BEGIN                         {FUNCTION wandle}
    scan(fterm,ftlen);
    wandle:=ein_Ausdruck;
  END;                          {FUNCTION wandle}

PROCEDURE suche_loc_var(VAR ifeld:sftyp; VAR iflen:longint; VAR ofeld:sftyp;
                        VAR oflen:longint; VAR loc_var_gef:boolean);
  VAR
    icnt:                       longint;        {in-count}
    sf:                         sftyp;          {string-feld}
    sfi:                        longint;        {string-feld-index}
    ich:                        char;           {in-character}

  PROCEDURE transfer_char;
    BEGIN                       {PROCEDURE transfer_char}
      icnt:=icnt+1;
      IF icnt=iflen THEN
        BEGIN
          fm('Unvollstndiges item',ifeld,iflen);
        END;
      ich:=ifeld[icnt];
      oflen:=oflen+1;
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
    END;                        {PROCEDURE transfer_char}

  PROCEDURE punkt_op;
    BEGIN                       {PROCEDURE punkt_op}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      transfer_char;
      transfer_char;
      transfer_char;
      IF ich<>'.' THEN
        BEGIN
          fm('Problem bei Punktoperator',ofeld,oflen);
        END;
      icnt:=icnt+1;
      oflen:=oflen+1;
    END;                        {PROCEDURE punkt_op}

  PROCEDURE kurzes_item;
    BEGIN                       {PROCEDURE kurzes_item}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      oflen:=oflen+1;
      icnt:=icnt+1;
    END;                        {PROCEDURE kurzes_item}

  PROCEDURE varfkt;
    VAR
      weiter:                   boolean;
      vfzeichen:                boolean;
      elev:                     longint;        {expand level}
      nr:                       longint;        {Nummer}
      mlf:                      boolean;        {macro label found}
      mlg:                      boolean;        {macro label gltig}
      hw:                       longint;        {Hilfswert}
      lla:                      krznt;          {local-label-anzeige}
      i:                        longint;
      glnull:                   boolean;        {Digit gleich null?}
    BEGIN                       {PROCEDURE varfkt}
      sfi:=0;
      sf[sfi]:=ich;
      sfi:=sfi+1;
      weiter:=true;
      REPEAT
        icnt:=icnt+1;
        IF icnt=iflen THEN weiter:=false
        ELSE
          BEGIN
            ich:=ifeld[icnt];
            vfzeichen:=ich IN ['A'..'Z','a'..'z','_','0'..'9'];
            IF vfzeichen THEN
              BEGIN
                sf[sfi]:=ich;
                sfi:=sfi+1;
              END;
          END;
      UNTIL ((NOT weiter) OR (NOT vfzeichen));
      {jetzt ist name vollstndig gelesen}
      {als nchstes wird geschaut, ob es sich um eine lokale}
      {Macro-variable handelt}
      mlg:=false;
      IF mel>0 THEN
        BEGIN
          elev:=mel;
          IF sfi>max_cl+1 THEN fm('Macro-Label zu lang',sf,sfi);
          REPEAT
            suche_label(elev,sf,sfi,nr,mlf);
            elev:=elev-1;
            IF mlf THEN mlg:=llt[elev+1]^.gueltig_ml[nr]
          UNTIL (mlg OR (elev=0));
        END;
      {Bei mlg=true wurde eine gltige Macrovariable gefunden}
      IF mlg THEN
        BEGIN                   {bei mlg=true wird der aktuelle Wert der}
          loc_var_gef:=true;    {lokalen Macro-variablen notiert}
          glnull:=true;         {vorb.: Nullen da}
          hw:=llt[elev+1]^.wert_ml[nr];
          lla[12]:='(';
          lla[1]:='H';
          lla[0]:=')';

          IF hw<0 THEN          {Vorzeichen bestimmen}
            BEGIN
              lla[11]:='-';
              hw:=-hw;
            END
          ELSE lla[11]:='+';

          lla[10]:='0';         {mindestens eine 0, damit Hexzahl ok ist}

          FOR i:=2 TO 9 DO      {alle 8 hex-digits ermitteln}
            BEGIN
              lla[i]:=h[hw AND $F];
              hw:=binlsr(hw,4);
            END;

          FOR i:=12 DOWNTO 10 DO        {'(', VZ und '0' schreiben}
            BEGIN
              IF oflen>flen THEN
                BEGIN
                  fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
                END;
              ofeld[oflen]:=lla[i];
              oflen:=oflen+1;
            END;

          FOR i:=9 DOWNTO 3 DO  {hherwertige 7 Stellen schreiben,}
            BEGIN               {fhrende Nullen weglassen}
              IF glnull THEN
                BEGIN
                  IF lla[i]<>'0' THEN
                    BEGIN
                      glnull:=false;
                      IF oflen>flen THEN
                        BEGIN
                          fm('Zeile bei suche_loc_var zu lang geworden',
                              ofeld,flen);
                        END;
                      ofeld[oflen]:=lla[i];
                      oflen:=oflen+1;
                    END;
                END             {IF glnull}
              ELSE
                BEGIN
                  IF oflen>flen THEN
                    BEGIN
                      fm('Zeile bei suche_loc_var zu lang geworden',
                         ofeld,flen);
                    END;
                  ofeld[oflen]:=lla[i];
                  oflen:=oflen+1;
                END;            {ELSE glnull}
            END;                {FOR i}

          FOR i:=2 DOWNTO 0 DO          {LSZ, 'H', ')' schreiben}
            BEGIN
              IF oflen>flen THEN
                BEGIN
                  fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
                END;
              ofeld[oflen]:=lla[i];
              oflen:=oflen+1;
            END;

        END                     {IF mlg}
      ELSE
        BEGIN                   {bei mlg=false war's keine lokale Macro-}
          FOR i:=0 TO sfi-1 DO  {variable, daher wird der gelesene Name}
            BEGIN               {direkt bernommen}
              IF oflen>flen THEN
                BEGIN
                  fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
                END;
              ofeld[oflen]:=sf[i];
              oflen:=oflen+1;
            END;
        END;                    {ELSE mlg}
    END;                        {PROCEDURE varfkt}

  PROCEDURE num_const;
    VAR
      weiter:                   boolean;
      nczeichen:                boolean;        {num_const-zeichen}
    BEGIN                       {PROCEDURE num_const}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      weiter:=true;
      REPEAT
        icnt:=icnt+1;
        IF icnt=iflen THEN weiter:=false
        ELSE
          BEGIN
            ich:=ifeld[icnt];
            nczeichen:=ich IN ['0'..'9','A'..'F','Q','O','H'];
            IF nczeichen THEN
              BEGIN
                oflen:=oflen+1;
                IF oflen>flen THEN
                  BEGIN
                    fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
                  END;
                ofeld[oflen]:=ich;
              END;
          END;
      UNTIL ((NOT weiter) OR (NOT nczeichen));
      oflen:=oflen+1;
      {jetzt ist num_const vollstndig uebertragen}
    END;                        {PROCEDURE num_const}

  PROCEDURE strhk;
    BEGIN                       {PROCEDURE strhk}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      REPEAT
        transfer_char;
      UNTIL ich=chr(39);
      icnt:=icnt+1;
      oflen:=oflen+1;
    END;                        {PROCEDURE strhk}

  PROCEDURE strap;
    BEGIN                       {PROCEDURE strap}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      REPEAT
        transfer_char;
      UNTIL ich=chr(34);
      icnt:=icnt+1;
      oflen:=oflen+1;
    END;                        {PROCEDURE strap}

  PROCEDURE strca;
    BEGIN                       {PROCEDURE strca}
      IF oflen>flen THEN
        BEGIN
          fm('Zeile bei suche_loc_var zu lang geworden',ofeld,flen);
        END;
      ofeld[oflen]:=ich;
      REPEAT
        transfer_char;
      UNTIL ich=chr(94);
      icnt:=icnt+1;
      oflen:=oflen+1;
    END;                        {PROCEDURE strca}

  PROCEDURE transfer_item;
    BEGIN                       {PROCEDURE transfer_item}
      ich:=ifeld[icnt];
      CASE ich OF
        chr(39):                {Hochkomma (')}
          BEGIN
            strhk;              {string mit Hochkomma}
          END;

        chr(34):                {Apostroph (")}
          BEGIN
            strap;              {string mit Apostroph}
          END;

        chr(94):                {caret (^)}
          BEGIN
            strca;              {string mit caret}
          END;

        '0'..'9':               {Ziffer}
          BEGIN
            num_const;          {numerische Konstante}
          END;

        'A'..'Z','_':           {upper case letter u. '_'}
          BEGIN
            varfkt;             {Name, d.h. Variable oder Funktion}
          END;

        '+','-','*','/','(',')','$','[',']':    {kurzes item}
          BEGIN
            kurzes_item;
          END;

        '.':                    {Punkt-operator}
          BEGIN
            punkt_op;
          END;

        ELSE
          BEGIN
            fm('Fehler bei ''suche_loc_var'': falscher item-beginn',
               ifeld,iflen);
          END;
      END;                      {CASE ich}
    END;                        {PROCEDURE transfer_item}

  BEGIN                         {PROCEDURE suche_loc_var}
    icnt:=0;
    WHILE icnt<iflen DO transfer_item;
  END;                          {PROCEDURE suche_loc_var}

PROCEDURE zeile_abgrasen(VAR di:bfrr; VAR ozi:longint; VAR len:tlen;
                         VAR zlboc:tzlboc);
  VAR
    ord_ch:                     byte;
    ch:                         char;
    i:                          longint;
    aktiv:                      longint;
                                  {-1: vor, 1: whrend Label}
                                  {-2: vor, 2: whrend Befehl}
                                  {-3..-(al-1): vor Operand 1..(al-3)}
                                  {3..(al-1): whrend Operand 1..(al-3)}
                                  {-al: vor verbotenem Operanden}
                                  {al: whrend Kommentar}
    hka:                        boolean;        {Hochkomma (')  aktiv}
    apa:                        boolean;        {Apostroph (")  aktiv}
    caa:                        boolean;        {caret (^) aktiv}
    zeile_zuende:               boolean;

  PROCEDURE ordne_ein;
    BEGIN                       {PROCEDURE ordne_ein}
      zlboc[aktiv,len[aktiv]]:=ch;
      len[aktiv]:=len[aktiv]+1;
    END;                        {PROCEDURE ordne_ein}

  PROCEDURE neues_zeichen;
    CONST
      alm1=                     al-1;
      malm1=                    -(al-1);
      md=                       -3;
    BEGIN                       {PROCEDURE neues_zeichen}
      zlboc[0,len[0]]:=ch;
      len[0]:=len[0]+1;
      CASE aktiv OF
        -1:                     {vor Label}
          BEGIN
            CASE ch OF
              ';','*',chr(39),  {bei Strichpunkt, Stern, Hochkomma,}
              chr(34),chr(94):  {Apostroph, caret: Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {bei space, tab gibt's kein Label}
                BEGIN
                  aktiv:=-2;    {deshalb wird auf Befehl gewartet}
                END;

              'A'..'Z','&','.','_': {bei 'A'..'Z','&','.','_' ist Label da}
                BEGIN           {'.' fr Definition der Pseudoops}
                  aktiv:=1;
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  fm('Falsches Zeichen am Label-anfang',zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        1:                      {Label aktiv}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ':',' ',chr(9):   {Doppelpunkt, space, tab beenden Label}
                BEGIN
                  aktiv:=-2;    {deshalb wird auf Befehl gewartet}
                END;

              'A'..'Z','a'..'z','_','0'..'9','&','[',']': {gltige Zeichen}
                BEGIN
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  fm('Falsches Zeichen im Label',zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        -2:                     {vor Befehl}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              ELSE
                BEGIN
                  aktiv:=2;     {jetzt ist Befehl aktiv}
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        2:                      {Befehl aktiv}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab beenden Befehl}
                BEGIN
                  aktiv:=-3;    {deshalb wird auf Operand 1 gewartet}
                END;

              ELSE
                BEGIN
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        malm1..md:              {vor Operand (al-3)..1}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ',':              {bei Komma wird gleich nchster Operand}
                BEGIN           {erwartet}
                  aktiv:=aktiv-1;
                  ozi:=ozi+1;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              chr(39):          {Hochkomma auf}
                BEGIN
                  hka:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1; {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              chr(34):          {Apostroph auf}
                BEGIN
                  apa:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1;   {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              chr(94):          {caret auf}
                BEGIN
                  caa:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1;   {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1;   {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        3..alm1:                {Operand 1..(al-3) aktiv}
          BEGIN
            IF hka THEN
              BEGIN
                CASE ch OF
                  chr(39):      {Hochkomma zu}
                    BEGIN
                      hka:=false;
                      ordne_ein;
                    END;
                  ELSE
                    BEGIN
                      ordne_ein;
                    END;
                END;            {CASE ch}
              END
            ELSE
              BEGIN
                IF apa THEN
                  BEGIN
                    CASE ch OF
                      chr(34):  {Apostroph zu}
                        BEGIN
                          apa:=false;
                          ordne_ein;
                        END;
                      ELSE
                        BEGIN
                          ordne_ein;
                        END;
                    END;        {CASE ch}
                  END
                ELSE
                  BEGIN
                    IF caa THEN
                      BEGIN
                        CASE ch OF
                          chr(94):      {caret zu}
                            BEGIN
                              caa:=false;
                              ordne_ein;
                            END;
                          ELSE
                            BEGIN
                              ordne_ein;
                            END;
                        END;    {CASE ch}
                      END
                    ELSE
                      BEGIN
                        CASE ch OF
                          ';':          {bei Strichpunkt folgt Kommentar}
                            BEGIN
                              aktiv:=al;{jetzt ist Kommentar aktiv}
                              ordne_ein;
                            END;

                          ',':          {bei Komma wird neuer Operand vermutet}
                            BEGIN
                              aktiv:=-aktiv-1;
                            END;

                          ' ',chr(9):   {bei space, tab neuer Operand verm.}
                            BEGIN
                              aktiv:=-aktiv-1;
                            END;

                          {
                          Kein Mensch wei, warum hier der Anfang eines
                          Strings erkannt wurde. Haben wir neuerdings
                          wieder abgeschaltet, weil wir Probleme mit
                          "EX AF,AF'" bekommen hatten (Mrz 96).

                          chr(39):      Hochkomma auf
                            BEGIN
                              hka:=true;
                              ordne_ein;
                            END;

                          chr(34):      Apostroph auf
                            BEGIN
                              apa:=true;
                              ordne_ein;
                            END;

                          chr(94):      caret auf
                            BEGIN
                              caa:=true;
                              ordne_ein;
                            END;
                          }

                          ELSE
                            BEGIN
                              ordne_ein;
                            END;
                        END;    {CASE ch}
                      END;      {ELSE caa}
                  END;          {ELSE apa}
              END;              {ELSE hka}
          END;                  {Operand 1..(al-3) aktiv}

        -al:                    {vor nicht mehr zulssigem Operanden (al-2)}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              ELSE
                BEGIN
                  fm('al zu klein (maximale Operandenzahl berschritten)',
                     zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        al:                     {Kommentar aktiv}
          BEGIN
            ordne_ein;
          END;

      END;                      {CASE aktiv}
    END;                        {PROCEDURE neues_zeichen}

  BEGIN                         {PROCEDURE zeile_abgrasen}
    ozi:=0;                     {Operandenzahl rcksetzen}
    aktiv:=-1;                  {vor Label}
    hka:=false;
    apa:=false;
    caa:=false;
    FOR i:=0 TO al DO           {Lngen rcksetzen}
      BEGIN
        len[i]:=0;
      END;

    zeile_zuende:=false;
    REPEAT
      myread(di,ord_ch);
      ch:=Chr(ord_ch);

      CASE ch OF
        chr(13):
          BEGIN
            {In DOS-Texten gibt es CRs. Diese ignorieren wir einfach.}

          END;                {CASE chr(13) OF ch}
        chr(10):
          BEGIN
            {Bei DOS und UNIX-Texten bedeutet LF das Zeilenende.}

            zeile_zuende:=true;
          END;                {CASE chr(10) OF ch}
        ELSE
          BEGIN
            {Wenn nicht CR oder LF, dann wird verarbeitet}
            IF len[0]>flen THEN
              BEGIN
                fm('Source-zeile zu lang',zlboc[0],flen);
              END;
            neues_zeichen;
          END;                {CASE ELSE OF ch}
      END;                    {CASE ch}
    UNTIL zeile_zuende OR myeof(di);

  END;                          {PROCEDURE zeile_abgrasen}

PROCEDURE zeile_expandieren(VAR ozi:longint; VAR len:tlen; VAR zlboc:tzlboc;
                            VAR llen:tlen; VAR lzlboc:tzlboc;
                            lzz,von_wo: longint);

  {
  i_loc_zeil (u. i_loc_zeil_len) werden mit Hilfe des Macroaufrufs aus
  llen (u. lzlboc) in die aktuelle Zeile nach len (u. zlboc) expandiert.

  'von_wo' gibt an, von wo aus 'zeile_expandieren' aufgerufen wurde.
  Aufruf von 'expand_pmacro': von_wo=0, von 'expand_macro': von_wo=1.
  Wegen der etwas verzwickten String- und "EX AF,AF'"-Behandlung mssen
  wir diese Unterscheidung machen. Im Normalfall sollte nur dann ein String
  erkannt werden, wenn zu Beginn eines Operanden ein Hochkomma, ein Caret
  oder ein Apostroph vorliegt und nicht mitten im Operanden. In 'zeile_
  abgrasen' wurde das jetzt mal so eingestellt. Es ist im Moment (22.03.96)
  nicht mehr klar, warum das bisher anders gehandhabt wurde. Bei 'expand_
  macro' kann natrlich ein "EX AF,AF'" auftauchen, so da auch dort das
  gleiche Argument gilt wie fr 'zeile_abgrasen'. Einzig in 'expand_
  pmacro' kann es nun Operanden geben, die nicht mit "'" beginnen aber
  einen echten String beinhalten. Z.B. ein "LD A,' '" erzeugt solche
  Sachen innerhalb des Pmacros. Damit fr den "EX"-Befehl nicht wieder
  ein Problem auftaucht, kann bei "EX AF,AF'" nicht mit 'g' gearbeitet
  werden, sondern wir machen das mit 'i'. Sollte dann eigentlich
  funktionieren.
  }

  VAR
    ch:                         char;
    i:                          longint;
    aktiv:                      longint;
                                  {bei 'neues_zeichen':}
                                  {-1: vor, 1: whrend Label}
                                  {-2: vor, 2: whrend Befehl}
                                  {-3..-(al-1): vor Operand 1..(al-3)}
                                  {3..(al-1): whrend Operand 1..(al-3)}
                                  {-al: vor verbotenem Operanden}
                                  {al: whrend Kommentar}

                                  {bei 'neues_zeichen_a':}
                                  {0: Grundmodus, 1/2: nach 1./2. &,}
                                  {3: Variable lesen}
    hka:                        boolean;        {Hochkomma (')  aktiv}
    apa:                        boolean;        {Apostroph (")  aktiv}
    caa:                        boolean;        {caret (^) aktiv}
    i_loc_zeil, o_loc_zeil:     sftyp;
    i_loc_zeil_len:             longint;
    o_loc_zeil_len:             longint;
    icc:                        longint;        {input character count}
    parf:                       sftyp;          {Parameter-feld}
    par_ind:                    longint;        {Parameter_index}
    zstart:                     longint;        {Zeilenstart}

  PROCEDURE ordne_ein;
    BEGIN                       {PROCEDURE ordne_ein}
      zlboc[aktiv,len[aktiv]]:=ch;
      len[aktiv]:=len[aktiv]+1;
    END;                        {PROCEDURE ordne_ein}

  PROCEDURE neues_zeichen;
    CONST
      alm1=                     al-1;
      malm1=                    -(al-1);
      md=                       -3;
    BEGIN                       {PROCEDURE neues_zeichen}
      zlboc[0,i]:=ch;
      len[0]:=i+1;
      CASE aktiv OF
        -1:                     {vor Label}
          BEGIN
            CASE ch OF
              ';','*',chr(39),  {bei Strichpunkt, Stern, Hochkomma,}
              chr(34),chr(94):  {Apostroph, caret: Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {bei space, tab gibt's kein Label}
                BEGIN
                  aktiv:=-2;    {deshalb wird auf Befehl gewartet}
                END;

              'A'..'Z','&','_': {bei 'A'..'Z','&','_' ist Label da}
                BEGIN
                  aktiv:=1;
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  fm('Falsches Zeichen am Label-anfang',zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        1:                      {Label aktiv}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ':',' ',chr(9):   {Doppelpunkt, space, tab beenden Label}
                BEGIN
                  aktiv:=-2;    {deshalb wird auf Befehl gewartet}
                END;

              'A'..'Z','a'..'z','_','0'..'9','&','[',']': {gltige Zeichen}
                BEGIN
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  fm('Falsches Zeichen im Label',zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        -2:                     {vor Befehl}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              ELSE
                BEGIN
                  aktiv:=2;     {jetzt ist Befehl aktiv}
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        2:                      {Befehl aktiv}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab beenden Befehl}
                BEGIN
                  aktiv:=-3;    {deshalb wird auf Operand 1 gewartet}
                END;

              ELSE
                BEGIN
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        malm1..md:              {vor Operand (al-3)..1}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ',':              {bei Komma wird gleich nchster Operand}
                BEGIN           {erwartet}
                  aktiv:=aktiv-1;
                  ozi:=ozi+1;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              chr(39):          {Hochkomma auf}
                BEGIN
                  hka:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1; {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              chr(34):          {Apostroph auf}
                BEGIN
                  apa:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1;   {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              chr(94):          {caret auf}
                BEGIN
                  caa:=true;
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1; {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;

              ELSE
                BEGIN
                  aktiv:=-aktiv;{Operand 1..(al-3) aktiv}
                  ozi:=ozi+1; {inkrement Operanden-zahl-istwert}
                  ordne_ein;
                END;
            END;                {CASE ch}
          END;

        3..alm1:                {Operand 1..(al-3) aktiv}
          BEGIN
            IF hka THEN
              BEGIN
                CASE ch OF
                  chr(39):      {Hochkomma zu}
                    BEGIN
                      hka:=false;
                      ordne_ein;
                    END;
                  ELSE
                    BEGIN
                      ordne_ein;
                    END;
                END;            {CASE ch}
              END
            ELSE
              BEGIN
                IF apa THEN
                  BEGIN
                    CASE ch OF
                      chr(34):  {Apostroph zu}
                        BEGIN
                          apa:=false;
                          ordne_ein;
                        END;
                      ELSE
                        BEGIN
                          ordne_ein;
                        END;
                    END;        {CASE ch}
                  END
                ELSE
                  BEGIN
                    IF caa THEN
                      BEGIN
                        CASE ch OF
                          chr(94):      {caret zu}
                            BEGIN
                              caa:=false;
                              ordne_ein;
                            END;
                          ELSE
                            BEGIN
                              ordne_ein;
                            END;
                        END;    {CASE ch}
                      END
                    ELSE
                      BEGIN
                        CASE ch OF
                          ';':          {bei Strichpunkt folgt Kommentar}
                            BEGIN
                              aktiv:=al;{jetzt ist Kommentar aktiv}
                              ordne_ein;
                            END;

                          ',':          {bei Komma wird neuer Operand vermutet}
                            BEGIN
                              aktiv:=-aktiv-1;
                            END;

                          ' ',chr(9):   {bei space, tab neuer Operand verm.}
                            BEGIN
                              aktiv:=-aktiv-1;
                            END;

                          chr(39):      {Hochkomma auf}
                            BEGIN
                              {
                              bei von_wo=0, also wenn Aufruf von 'expand_
                              pmacro' aus erfolgt, wird auf String er-
                              kannt, sonst nicht.
                              }
                              IF von_wo=0 THEN hka:=true;
                              ordne_ein;
                            END;

                          chr(34):      {Apostroph auf}
                            BEGIN
                              {
                              bei von_wo=0, also wenn Aufruf von 'expand_
                              pmacro' aus erfolgt, wird auf String er-
                              kannt, sonst nicht.
                              }
                              IF von_wo=0 THEN apa:=true;
                              ordne_ein;
                            END;

                          chr(94):      {caret auf}
                            BEGIN
                              {
                              bei von_wo=0, also wenn Aufruf von 'expand_
                              pmacro' aus erfolgt, wird auf String er-
                              kannt, sonst nicht.
                              }
                              IF von_wo=0 THEN caa:=true;
                              ordne_ein;
                            END;

                          ELSE
                            BEGIN
                              ordne_ein;
                            END;
                        END;    {CASE ch}
                      END;      {ELSE caa}
                  END;          {ELSE apa}
              END;              {ELSE hka}
          END;                  {Operand 1..(al-3) aktiv}

        -al:                    {vor nicht mehr zulssigem Operanden (al-2)}
          BEGIN
            CASE ch OF
              ';':              {bei Strichpunkt folgt Kommentar}
                BEGIN
                  aktiv:=al;    {jetzt ist Kommentar aktiv}
                  ordne_ein;
                END;

              ' ',chr(9):       {space, tab berlesen}
                BEGIN
                  {nichts}
                END;

              ELSE
                BEGIN
                  fm('al zu klein (maximale Operandenzahl berschritten)',
                     zlboc[0],len[0]);
                END;
            END;                {CASE ch}
          END;

        al:                     {Kommentar aktiv}
          BEGIN
            ordne_ein;
          END;

      END;                      {CASE aktiv}
    END;                        {PROCEDURE neues_zeichen}

  PROCEDURE neues_zeichen_a;
    PROCEDURE trag_ein_param;
      VAR
        par_nr,i:               longint;
      BEGIN                     {PROCEDURE trag_ein_param}
        par_nr:=wandle(parf,par_ind);
        IF ((par_nr<1) OR (par_nr>(al-3))) THEN
          BEGIN
            fm('Parameter-nummer out of range',i_loc_zeil,i_loc_zeil_len);
          END;
        IF llen[par_nr+2]=0 THEN
          BEGIN
            IF o_loc_zeil_len>flen THEN
              BEGIN
                fm('Zeile bei zeile_expandieren zu lang geworden',
                    o_loc_zeil,flen);
              END;
            o_loc_zeil[o_loc_zeil_len]:=chr(39);      {2 mal Hochkomma,}
            o_loc_zeil_len:=o_loc_zeil_len+1;         {wenn bergebener}
            IF o_loc_zeil_len>flen THEN
              BEGIN
                fm('Zeile bei zeile_expandieren zu lang geworden',
                    o_loc_zeil,flen);
              END;
            o_loc_zeil[o_loc_zeil_len]:=chr(39);      {Parameter Lnge}
            o_loc_zeil_len:=o_loc_zeil_len+1;         {0 hat}
          END
        ELSE
          BEGIN
            FOR i:=0 TO llen[par_nr+2]-1 DO
              BEGIN
                IF o_loc_zeil_len>flen THEN
                  BEGIN
                    fm('Zeile bei zeile_expandieren zu lang geworden',
                        o_loc_zeil,flen);
                  END;
                o_loc_zeil[o_loc_zeil_len]:=lzlboc[par_nr+2,i];
                o_loc_zeil_len:=o_loc_zeil_len+1;
              END;
          END;
      END;                      {PROCEDURE trag_ein_param}

    BEGIN                       {PROCEDURE neues_zeichen_a}
      CASE aktiv OF
        0:                      {Grundmodus}
          BEGIN
            CASE ch OF
              '&':
                BEGIN
                  aktiv:=1;     {erstes & gelesen}
                END;
              ELSE
                BEGIN
                  IF o_loc_zeil_len>flen THEN
                    BEGIN
                      fm('Zeile bei zeile_expandieren zu lang geworden',
                          o_loc_zeil,flen);
                    END;
                  o_loc_zeil[o_loc_zeil_len]:=ch;
                  o_loc_zeil_len:=o_loc_zeil_len+1;
                END;
            END;                {CASE ch}
          END;                  {CASE aktiv OF 0}

        1:                      {nach erstem &}
          BEGIN
            aktiv:=2;           {zweites & gelesen}
          END;                  {CASE aktiv OF 1}

        2:                      {nach zweitem &}
          BEGIN
            par_ind:=0;
            aktiv:=3;           {Variable liegt vor}
            parf[par_ind]:=ch;
            par_ind:=par_ind+1;
            IF icc=i_loc_zeil_len-1 THEN trag_ein_param;
          END;                  {CASE aktiv OF 2}

        3:                      {Variable lesen}
          BEGIN
            IF ch IN ['A'..'Z','a'..'z','_','0'..'9'] THEN
              BEGIN
                parf[par_ind]:=ch;
                par_ind:=par_ind+1;
                IF icc=i_loc_zeil_len-1 THEN trag_ein_param;
              END
            ELSE
              BEGIN
                trag_ein_param;
                CASE ch OF
                  '&':
                    BEGIN
                      aktiv:=1; {erstes & gelesen}
                    END;
                  ELSE
                    BEGIN
                      aktiv:=0;     {wieder Grundmodus}
                        IF o_loc_zeil_len>flen THEN
                          BEGIN
                            fm('Zeile bei zeile_expandieren zu lang geworden',
                                o_loc_zeil,flen);
                          END;
                      o_loc_zeil[o_loc_zeil_len]:=ch;
                      o_loc_zeil_len:=o_loc_zeil_len+1;
                    END;
                END;            {CASE ch}
              END;
          END;                  {CASE aktiv OF 3}
      END;                      {CASE aktiv}
    END;                        {PROCEDURE neues_zeichen_a}

  BEGIN                         {PROCEDURE zeile_expandieren}
    aktiv:=0;                   {Grundmodus fr 'neues_zeichen_a'}
    o_loc_zeil_len:=0;

    WITH llt[mel]^ DO
      BEGIN
        IF lzz=0 THEN
          BEGIN
            IF mel=1 THEN
              BEGIN
                zstart:=0;
              END               {IF mel=1}
            ELSE
              BEGIN
                zstart:=llt[mel-1]^.me;
              END;              {ELSE mel=1}
          END                   {IF lzz=0}
        ELSE
          BEGIN
            zstart:=ze[lzz-1];
          END;                  {ELSE lzz=0}

        i_loc_zeil_len:=ze[lzz]-zstart;
        FOR i:=0 TO i_loc_zeil_len-1 DO
          BEGIN
            i_loc_zeil[i]:=ema^[zstart+i];
          END;                  {FOR i}

        END;                    {WITH llt[mel]^}

    {daps mit Variablen durch aktuelle Werte ersetzen:}
    FOR icc:=0 TO i_loc_zeil_len-1 DO
      BEGIN
        ch:=i_loc_zeil[icc];
        neues_zeichen_a;
      END;
    ozi:=0;                     {Operandenzahl rcksetzen}
    aktiv:=-1;                  {vor Label}
    hka:=false;
    apa:=false;
    caa:=false;
    FOR i:=0 TO al DO           {Lngen rcksetzen}
      BEGIN
        len[i]:=0;
      END;
    FOR i:=0 TO o_loc_zeil_len-1 DO
      BEGIN
        ch:=o_loc_zeil[i];
        neues_zeichen;
      END;
  END;                          {PROCEDURE zeile_expandieren}

PROCEDURE insert_name(VAR nfloc:gnr; VAR sfeld:sftyp;
                      VAR cl,uoz,unt,uw:longint);
  VAR
    i:                          longint;
    findex,iindex:              longint;
    nf_sel1, nf_ind1:           word;   {Namensfeld selector, -index}
    nf_sel2, nf_ind2:           word;   {Namensfeld selector, -index}

  BEGIN                         {PROCEDURE insert_name}
    suche_name(nfloc,sfeld,cl,findex,iindex);

    WITH nfloc DO
      BEGIN
        IF findex=-1 THEN       {name nicht gefunden bei findex=-1}
          BEGIN
            nf_sel1:=(azn AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind1:=azn AND max_gtnf;
            {
            Falls nf_ind1=0 gilt, mu ggf. ein neues Teil Namensfeld an-
            gelegt werden, weil 'azn' gerade in diesem Moment bereits
            auf das erste Element des (nchsten) Teil Namensfeldes
            zeigt. 'ggf.' heit eigentlich 'immer', solange das Namensfeld
            nicht zwischenzeitlich geschrumpft ist. Normalerweise
            lassen wir es ja nur wachsen. Sollten wir uns aber ent-
            schlieen, etwa das Problem der SET-Variablen durch Lschen
            aus dem Namensfeld zu lsen, dann kann es sehrwohl passieren,
            da nf_ind1=0 ist, das Teil Namensfeld aber schon angelegt
            ist. D.h. wir sollten es nur anlegen, wenn nf[nf_sel1]
            NIL ist.
            Auerdem wird geprft, ob nf_sel1 nicht schon zu gro ist.
            }
            IF nf_ind1=0 THEN
              BEGIN
                IF nf_sel1 > max_nf_sel THEN
                  BEGIN
                    fm('max_nf_sel zu klein (zu viele Namen wurden definiert))',
                       zlboc[0],len[0]);
                  END;          {IF nf_sel1...}
                IF nf[nf_sel1]=NIL THEN
                  BEGIN
                    IF MaxAvail<SizeOf(nf[nf_sel1]^) THEN
                      BEGIN
                        fm('Zu wenig Speicher (01)', zlboc[0],len[0]);
                      END;
                    new(nf[nf_sel1]);
                  END;          {IF nf[nf_sel1]...}
              END;              {IF nf_ind1=0}

            {
            Wir mssen den Speichercheck bereits hier machen, weil
            schreibe_alle_nam sonst einen Bldsinn ausgibt. sel und
            ind sind brigens beide 0, weil sowieso alle Pointer
            auf die gleichen Records zeigen. Zustzlich zum Platz
            fr den 'Namens-record' fordern wir gleich noch den
            Platz fr einen 'cross referenz record' an, weil wir
            den beim erstmaligen Anlegen eines 'Namens-records'
            sowieso auch brauchen.
            }
            IF MaxAvail<(SizeOf(nf[0]^[0]^) + SizeOf(crr)) THEN
              BEGIN
                fm('Zu wenig Speicher (02)', zlboc[0],len[0]);
              END;

            FOR i:=cl TO anznh DO
              BEGIN
                enh[i]:=enh[i]+1; {Ab iindex Ende der Namenshaufen inkr.}
              END;
            FOR i:=azn DOWNTO iindex+1 DO
              BEGIN
                {Pointer auf nr ab iindex um 1 weiterschieben:}
                nf_sel1:=(i AND (NOT max_gtnf)) SHR mgtnfb;
                nf_ind1:=i AND max_gtnf;
                nf_sel2:=((i-1) AND (NOT max_gtnf)) SHR mgtnfb;
                nf_ind2:=(i-1) AND max_gtnf;
                nf[nf_sel1]^[nf_ind1]:=nf[nf_sel2]^[nf_ind2];
              END;
            azn:=azn+1;
            nf_sel1:=(iindex AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind1:=iindex AND max_gtnf;
            new(nf[nf_sel1]^[nf_ind1]);
            WITH nf[nf_sel1]^[nf_ind1]^ DO
              BEGIN
                FOR i:=0 TO cl-1 DO
                  BEGIN
                    name[i]:=sfeld[i];
                  END;
                {
                Der Rest wird im wesentlichen wegen der sthetik
                mit Space gefllt. Spter beim Ausgeben von Syboltabellen
                und dergleichen brauchen wir uns dann auch keine
                Gedanken um die Charakterlnge mehr zu machen.
                }
                FOR i:=cl TO max_cl DO
                  BEGIN
                    name[i]:=' ';
                  END;
                ozs:=uoz;
                nt:=unt;
                wert:=uw;
                new(zcrr);
                WITH zcrr^ DO
                  BEGIN
                    glob_zeile:=zeile;
                    zcrr:=NIL;
                  END;          {WITH zcrr^}
              END;              {WITH nf[nf_sel1]^[nf_ind1]^}
          END                   {IF findex=-1}
        ELSE
          BEGIN
            nf_sel1:=(findex AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind1:=findex AND max_gtnf;
            WITH nf[nf_sel1]^[nf_ind1]^ DO
              BEGIN
                IF nt<>unt THEN
                  BEGIN
                    {
                    Normalerweise gibt es einen Fehler, wenn innerhalb
                    einer Namensgruppe Namensgleichheit auftaucht. Fr
                    den Fall der (verbotenen) SET-Variablen (Typ 9)
                    mssen wir aber erlauben, da der Namenstyp 9 vom
                    Typ 5 berschrieben wird.
                    }
                    IF ((nt=9) AND (unt=5)) THEN
                      BEGIN
                        nt:=5;
                        wert:=uw;
                        update_crr(zcrr, zeile);
                      END       {IF ((nt...}
                    ELSE
                      BEGIN
                        fm('Name existiert schon unter anderem Namens-typ',
                           sfeld,cl);
                      END;      {ELSE ((nt...}
                  END
                ELSE
                  BEGIN
                    CASE unt OF
                      0..4,8:   {Pmacro; pseudo-op; Macro; Var. mit PEQUATE;}
                        BEGIN   {Label, Var. mit EQU; Funktion}
                          fm('Name existiert schon unter gleichem Namens-typ',
                             sfeld,cl);
                        END;
                      5:        {Var. mit SET}
                        BEGIN
                          wert:=uw;
                          update_crr(zcrr, zeile);
                        END;
                    END;        {CASE unt}
                  END;          {ELSE nt<>unt}
              END;              {WITH nf[nf_sel1]^[nf_ind1]^}
          END;                  {ELSE findex=-1}
      END;                      {WITH nfloc}
  END;                          {PROCEDURE insert_name}

PROCEDURE insert_vmp(typ,wert,oz:longint);
  {
  insert var, mac, pseudo
  }
  BEGIN                         {PROCEDURE insert_vmp}
    CASE typ OF
      0,1,2:                    {Befehlsgruppe}
        BEGIN
          insert_name(nfb,zlboc[1],len[1],oz,typ,wert);
        END;                    {CASE 0,1,2 OF typ}

      3,4,5,8:                  {Labelgruppe}
        BEGIN
          insert_name(nfl,zlboc[1],len[1],oz,typ,wert);
        END;                    {CASE 3,4,5,8 OF typ}

      ELSE
        BEGIN
          fm('Unerwarteter CASE-Error in "insert_vmp"',
             zlboc[0],len[0]);
        END;                    {CASE ELSE OF typ}
    END;                        {CASE typ}
  END;                          {PROCEDURE insert_vmp}

PROCEDURE initialisierung;
  VAR
    lsfeld:                     sftyp;
    lcl:                        longint;
  PROCEDURE init_nf(VAR nfloc: gnr);
    VAR
      i:                        longint;
    BEGIN                       {PROCEDURE init_nf}
      WITH nfloc DO             {nf local}
        BEGIN
          FOR i:=0 TO max_nf_sel DO
            BEGIN
              nf[i]:=NIL;       {alle Zeiger auf Teil Namensfeld rcksetzen}
            END;
          FOR i:=0 TO anznh DO
            BEGIN
              enh[i]:=0;        {Ende der Namenshaufen rcksetzen}
            END;
          azn:=0;               {aktuelle Zahl von Namen}
        END;                    {WITH nfloc}
    END;                        {PROCEDURE init_nf}

  PROCEDURE init_fkt;
    VAR
      i,k,oz,typ,wert:          longint;
    BEGIN                       {PROCEDURE init_fkt}
      oz:=0;
      typ:=8;
      FOR i:=0 TO ftblen DO
        BEGIN
          lcl:=fcla[i];
          FOR k:=0 TO lcl-1 DO lsfeld[k]:=fara[i,k];

          wert:=i;

          insert_name(nfl,lsfeld,lcl,oz,typ,wert);
        END;
    END;                        {PROCEDURE init_fkt}

  PROCEDURE init_pseudo;
    {
    Die Pseudobefehle werden nun (01.11.95) bis auf 'PINCLUDE' und
    'PEQUATE' ber den Programmtext eingegeben. Aus historischen Grnden
    behalten wir fr 'PINCLUDE' den Wert 30 und fr 'PEQUATE' 28 bei,
    damit wir nicht den Programmcode, d.h. die Reihenfolge in den CASE-
    Anweisungen ndern mssen.
    }
    VAR
      typ,oz,wert:              longint;
    BEGIN                       {PROCEDURE init_pseudo}
      typ:=1;

      str_zu_sftyp('PEQUATE', lsfeld, lcl);
      oz:=-1;
      wert:=28;
      insert_name(nfb,lsfeld,lcl,oz,typ,wert);

      str_zu_sftyp('PINCLUDE', lsfeld, lcl);
      oz:=1;
      wert:=30;
      insert_name(nfb,lsfeld,lcl,oz,typ,wert);
    END;                        {PROCEDURE init_pseudo}

  PROCEDURE init_macro;
    VAR
      i:                        longint;
    BEGIN                       {PROCEDURE init_macro}
      mce:=0;                   {macro count bei expand}
      mcr:=0;                   {macro count bei read}
      zzmr:=0;                  {Zeilen-zhler bei macro read}
      {
      Hinweis: frher wurde hier 'ma' mit 'new' angelegt.
      Dies wird nun (30.03.96) dynamisch beim Lesen von Macrotext
      gemacht. Dafr setzen wir wenigstens der Ordnung halber die
      Zeiger auf die Teil Macro arrays zurck.
      }
      FOR i:=0 TO max_maca_sel DO
        BEGIN
          ma[i]:=NIL;           {alle Zeiger auf Teil Macro array rcksetzen}
        END;
      ima:=0;                   {(aktueller) Index des Macro array}
      IF MaxAvail<SizeOf(mzs^) THEN
        BEGIN
          fm('Zu wenig Speicher (03)', zlboc[0],len[0]);
        END;
      new(mzs);                 {neu: macro-Zeilen-start}
      FOR i:=0 TO mzlma DO mzs^[i]:=0;
      FOR i:=0 TO mzm DO mif[i]:=0;
      IF MaxAvail<SizeOf(ema^) THEN
        BEGIN
          fm('Zu wenig Speicher (04)', zlboc[0],len[0]);
        END;
      new(ema);
      FOR i:=1 TO max_mel DO llt[i]:=NIL;
    END;                        {PROCEDURE init_macro}

  PROCEDURE init_misc;
    VAR
      i:                        longint;
    BEGIN                       {PROCEDURE init_misc}
      zeile:=0;
      FOR i:=0 TO max_cl DO aa_leer[i]:=' ';
      tmpw_open:=false;
      tmpr_open:=false;
      tmpr.bfrbf:=0;
      tmpr.bfrbp:=0;
      lst_open:=false;
      obj_open:=false;
      warn_cnt:=0;
      will_quervw:=true;
      will_symtab:=true;
    END;                        {PROCEDURE init_misc}

  PROCEDURE init_scr;
    VAR
      i:                        longint;
    BEGIN                       {PROCEDURE init_scr}
      page;
      writeln('(Z)u(s)ammen(s)etzer ',vers_dat,' / R. Schubert');
      writeln(mail_und_http);
      writeln;
      write('Aufruf: zss<vers> [<filename>[.u] {[');
      FOR i:=0 TO clpc-1 DO
        BEGIN
          IF i>0 THEN write(' | ');
          write(clp[i]);
        END;                    {FOR i}
      writeln(']}]');
      writeln;
      writeln('Die Parameter bedeuten: ', clp[0]:4, ': ', cld[0]);
      FOR i:=1 TO clpc-1 DO
        BEGIN
          writeln('                        ', clp[i]:4, ': ', cld[i]);
        END;                    {FOR i}
      writeln;
    END;                        {PROCEDURE init_scr}

  BEGIN                         {PROCEDURE initialisierung}
    init_nf(nfb);               {Befehle initialisieren}
    init_nf(nfl);               {Labels initialisieren}
    init_fkt;
    init_pseudo;
    init_macro;
    init_misc;
    init_scr;
  END;                          {PROCEDURE initialisierung}

PROCEDURE ist_file_name_gut(VAR fname_usp,fname_bas: string_255;
                            VAR gut: boolean );
  VAR
    i:                          longint;
    period_pos:                 longint;
    period_cnt:                 longint;
    lusp:                       longint;
    lmpp:                       longint; {length minus period pos.}
    weiter_testen:              boolean;
  BEGIN                         {PROCEDURE ist_file_name_gut}
    gut:=true;
    period_pos:=0;
    period_cnt:=0;
    weiter_testen:=true;
    fname_bas:='';

    FOR i:=1 TO length(fname_usp) DO
      BEGIN
        IF fname_usp[i]='.' THEN
          BEGIN
            period_pos:=i;
            period_cnt:=period_cnt+1;
          END;
      END;                      {FOR i}

    IF length(fname_usp)=0 THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF length...}

    IF (weiter_testen AND (period_cnt>1)) THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF period_cnt>1}

    IF (weiter_testen AND (period_cnt=0)) THEN
      BEGIN
        IF length(fname_usp)>8 THEN
          BEGIN
            gut:=false;
          END                   {IF length...}
        ELSE
          BEGIN
            fname_bas:=fname_usp;
            fname_usp:=fname_usp+'.u';
          END;                  {ELSE length...}
        weiter_testen:=false;
      END;                      {IF weiter_testen...}

    IF (weiter_testen AND (period_pos=1)) THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF weiter_testen...}

    IF (weiter_testen AND (period_pos>9)) THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF weiter_testen...}

    lusp:=length(fname_usp);
    lmpp:=lusp-period_pos;
    {Extension soll hier genau 1 lang sein ... :}
    IF (weiter_testen AND ((lmpp<1) OR (1<lmpp))) THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF weiter_testen...}

    {... und 'U' oder 'u' heien:}
    IF (weiter_testen AND
        (NOT (fname_usp[lusp] IN ['U','u']))) THEN
      BEGIN
        gut:=false;
        weiter_testen:=false;
      END;                      {IF weiter_testen...}

    IF weiter_testen THEN
      BEGIN
        FOR i:=1 TO period_pos-1 DO
          BEGIN
            fname_bas:=fname_bas+fname_usp[i];
          END;                  {FOR i}
      END;                      {IF weiter_testen}

  END;                          {PROCEDURE ist_file_name_gut}

PROCEDURE welches_file(VAR file_name_gueltig:boolean);
  VAR
    i:                          longint;
    t_existiert:                boolean;
    l_existiert:                boolean;
    o_existiert:                boolean;
    force_assembly:             boolean;
    exist_cnt:                  word;
    fname_bas:                  string_255;
    fname_gut:                  boolean;
    fpfad:                      PathStr;
    fdir:                       DirStr;
    fnam:                       NameStr;
    fext:                       ExtStr;
    text1, text2:               string_255;
    ptindex:                    longint;        {Param.-tabellen Index}
    param_unbekannt:            boolean;

  PROCEDURE param_action(index: longint);
    BEGIN                       {PROCEDURE param_action}
      writeln('index: ', index);
      CASE index OF
        0:
          BEGIN
            force_assembly:=true;
          END;                  {CASE OF 0}
        1:
          BEGIN
            will_quervw:=false;
          END;                  {CASE OF 1}
        2:
          BEGIN
            will_symtab:=false;
          END;                  {CASE OF 2}
        ELSE
          BEGIN
            {nichts}
          END;                  {CASE ELSE}
      END;        {CASE index}
    END;                        {PROCEDURE param_action}

  PROCEDURE achtung1;
    BEGIN                       {PROCEDURE achtung1}
      beep;
      writeln;
      write('Achtung! ', text1);
      writeln(' bereits:');
      writeln;
      IF t_existiert THEN writeln('        ',fname_tmp);
      IF l_existiert THEN writeln('        ',fname_lst);
      IF o_existiert THEN writeln('        ',fname_obj);
      writeln;
      writeln('Der Zusammensetzer wird ', text2, ' berschreiben!');
      IF ob_weitermachen THEN file_name_gueltig:=true
      ELSE file_name_gueltig:=false;
    END;                        {PROCEDURE achtung1}

  BEGIN                         {PROCEDURE welches_file}
    IF ParamCount=0 THEN
      BEGIN
        writeln('Welches File soll zusammengesetzt (assembliert) werden ?');
        writeln;
        writeln('File zusammensetzen: <filename>[.u] <RETURN>');
        writeln;
        writeln('Abbruch durch: <RETURN>');
        writeln;
        readln(fpfad);
      END                       {IF ParamCount...}
    ELSE
      BEGIN
        fpfad:=ParamStr(1);
      END;                      {ELSE ParamCount...}

    IF fpfad='' THEN
      BEGIN
        fname_gut:=false;
      END                       {IF fpfad...}
    ELSE
      BEGIN
        FSplit(fpfad,fdir,fnam,fext);
        fname_usp:='';
        FOR i:=length(fdir)+1 TO length(fpfad) DO
          BEGIN
            fname_usp:=fname_usp+fpfad[i];
          END;                  {FOR i...}
        ist_file_name_gut(fname_usp,fname_bas,fname_gut);
        {
        writeln('Pfad:   ',fpfad);
        writeln('Dir:    ',fdir);
        writeln('Nam:    ',fnam);
        writeln('Ext:    ',fext);
        writeln('Usp:    ',fname_usp);
        }
        IF (NOT fname_gut) THEN
          BEGIN
            beep;
            writeln;
            writeln('Abbruch, weil uns der Filename nicht gefllt:');
            writeln;
            writeln(fdir+fname_usp);
          END;                  {IF (NOT fname_gut)}
      END;                      {ELSE fpfad...}

    IF fname_gut THEN
      BEGIN
        {
        Voreinstellung: Zusammensetzung nicht erzwingen, kann im
        Bedarfsfall nur durch Kommandozeilenparameter erfolgen.
        }
        force_assembly:=false;
        fname_usp:=fdir+fname_usp;
        IF file_existiert(fname_usp) THEN
          BEGIN
            fname_tmp:=fdir+fname_bas+'.t';
            fname_lst:=fdir+fname_bas+'.l';
            fname_obj:=fdir+fname_bas+'.o';

            {
            Alle Parameter abgrasen, falls mehr als einer da ist.
            Falls nicht, ist dieser (nicht  vorhandene) auch nicht
            unbekannt:
            }
            IF ParamCount>1 THEN
              BEGIN
                i:=1;
                REPEAT
                  param_unbekannt:=true;
                  i:=i+1;
                  ptindex:=0;
                  REPEAT
                    IF (ParamStr(i)=clp[ptindex]) THEN
                      BEGIN
                        param_unbekannt:=false;
                        param_action(ptindex);
                      END;      {IF (ParamStr(i)=clp[ptindex])}
                    ptindex:=ptindex+1;
                  UNTIL ((ptindex=clpc) OR (NOT param_unbekannt));
                UNTIL ((i=ParamCount) OR param_unbekannt);
              END               {ELSE ParamCount>1}
            ELSE
              BEGIN
                param_unbekannt:=false;
              END;              {ELSE ParamCount>1}

            {
            Nur wenn kein unbekannter Parameter dabei war,
            fahren wir fort:
            }
            IF param_unbekannt THEN
              BEGIN
                file_name_gueltig:=false;
                beep;
                writeln;
                writeln('Fehler: ungltiger Kommandozeilenparameter ',
                        ParamStr(i));
              END               {IF param_unbekannt}
            ELSE
              BEGIN
                IF NOT force_assembly THEN
                  BEGIN
                    exist_cnt:=0;
                    t_existiert:=file_existiert(fname_tmp);
                    IF t_existiert THEN exist_cnt:=exist_cnt+1;
                    l_existiert:=file_existiert(fname_lst);
                    IF l_existiert THEN exist_cnt:=exist_cnt+1;
                    o_existiert:=file_existiert(fname_obj);
                    IF o_existiert THEN exist_cnt:=exist_cnt+1;
                    CASE exist_cnt OF
                      0:
                        BEGIN
                          file_name_gueltig:=true;
                        END;    {CASE OF 0}
                      1:
                        BEGIN
                          text1:='Folgendes File existiert';
                          text2:='es';
                          achtung1;
                        END;    {CASE OF 1}
                      2,3:
                        BEGIN
                          text1:='Folgende Files existieren';
                          text2:='sie';
                          achtung1;
                        END;    {CASE OF 2,3}
                    END;        {CASE exist_cnt}
                  END           {IF NOT force_assembly}
                ELSE
                  BEGIN
                    file_name_gueltig:=true;
                  END;          {ELSE NOT force_assembly}
              END;              {ELSE param_unbekannt}


          END                   {IF file_existiert...}
        ELSE
          BEGIN
            file_name_gueltig:=false;
            beep;
            writeln;
            writeln('Fehler: gewnschtes File ',fname_usp,
                    ' konnte nicht geffnet werden');
          END;                  {ELSE file_existiert...}
      END                       {IF fname_gut}
    ELSE file_name_gueltig:=false;
  END;                          {PROCEDURE welches_file}

PROCEDURE zl_IF_true;
  BEGIN                         {PROCEDURE zl_IF_true}
    CASE list_state OF
      0:    zl:='n';            {NOLIST}
      1:    IF ((mel=0) AND (fil=0)) THEN zl:='j'
            ELSE zl:='n';       {LIST}
      2:    zl:='j';            {EXPAND}
    END;                        {CASE list_state}
  END;                          {PROCEDURE zl_IF_true}

PROCEDURE zl_IF_false;
  BEGIN                         {PROCEDURE zl_IF_false}
    CASE list_state OF
      0,1:  zl:='n';            {NOLIST, LIST}
      2:    zl:='j';            {EXPAND}
    END;                        {CASE list_state}
  END;                          {PROCEDURE zl_IF_false}

PROCEDURE zl_IF_true_skip_title;
  BEGIN                         {PROCEDURE zl_IF_true_skip_title}
    CASE list_state OF
      0:    zl:='N';            {NOLIST}
      1:    IF ((mel=0) AND (fil=0)) THEN zl:='F'
            ELSE zl:='N';       {LIST}
      2:    zl:='F';            {EXPAND}
    END;                        {CASE list_state}
  END;                          {PROCEDURE zl_IF_true_skip_title}

PROCEDURE zl_IF_false_skip_title;
  BEGIN                         {PROCEDURE zl_IF_false_skip_title}
    CASE list_state OF
      0,1:  zl:='N';            {NOLIST, LIST}
      2:    zl:='L';            {EXPAND}
    END;                        {CASE list_state}
  END;                          {PROCEDURE zl_IF_false_skip_title}

PROCEDURE zl_IF_true_pmacro;
  BEGIN                         {PROCEDURE zl_IF_true_pmacro}
    CASE list_state OF
      0:    zl:='q';            {NOLIST}
      1:    IF ((mel=0) AND (fil=0)) THEN zl:='p'
            ELSE zl:='q';       {LIST}
      2:    zl:='p';            {EXPAND}
    END;                        {CASE list_state}
  END;                          {PROCEDURE zl_IF_true_pmacro}

PROCEDURE setze_anzeige(wert,dig:longint);
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE setze_anzeige}
    FOR i:=0 TO dig-1 DO
      BEGIN
        aa[i]:=h[wert AND $F];
        wert:=binlsr(wert,4);
      END;
  END;                          {PROCEDURE setze_anzeige}

PROCEDURE suche_befehl(VAR gwert,pcn,lzz:longint; von_wo: longint);
  VAR
    gozs, gnt:                  longint;
    typlbl,wertlbl,ozslbl:      longint;
    findex,iindex:              longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}

  PROCEDURE coil;               {'check oz and insert lbl'}
    VAR
      nr:                       longint;        {Nummer}
      mlf:                      boolean;        {macro label found}

    BEGIN                       {PROCEDURE coil}
      IF gozs<>-1 THEN          {wenn Operandenzahl nicht unbestimmt,}
        BEGIN                   {dann mu sein: ozi=gozs}
          IF ozi=gozs THEN
            BEGIN
              {alles in Ordnung}
            END
          ELSE
            BEGIN
              IF ozi>gozs THEN
                BEGIN
                  fm('Operandenzahl fr diesen Befehl zu gro',
                     zlboc[0],len[0]);
                END
              ELSE
                BEGIN
                  fm('Operandenzahl fr diesen Befehl zu klein',
                     zlboc[0],len[0]);
                END;
            END;                {ELSE ozi=gozs}
        END;                    {IF gozs<>-1}

      IF len[1]>0 THEN
        BEGIN
          CASE typlbl OF
            0,                  {Pmacro-name}
            1,                  {Pseudoop}
            2,                  {Macro-name}
            3,                  {vordef. Var.}
            4,                  {Label. oder mit EQU}
            5:                  {mit SET}
              BEGIN
                insert_vmp(typlbl,wertlbl,ozslbl);
              END;              {CASE typlbl OF 0..5}
            6:                  {es liegt .NOP, .IF, .GOTO vor}
              BEGIN
                {keine Aktion, da diese Labels macro-lokal sind,}
                {schon in die llt eingetragen wurden aber keinen}
                {durch .SET zugewiesenen Wert erhalten}
              END;              {CASE typlbl OF 6}
            7:                  {es liegt .SET vor}
              BEGIN
                WITH llt[mel]^ DO
                  BEGIN
                    suche_label(mel,zlboc[1],len[1],nr,mlf);
                    wert_ml[nr]:=wertlbl;
                    gueltig_ml[nr]:=true;
                  END;          {WITH llt[mel]^}
              END;              {CASE typlbl OF 7}
          END;                  {CASE typlbl}
        END;                    {IF len[1]>0}
    END;                        {PROCEDURE coil}

  PROCEDURE sb_pseudo;
    VAR
      i,anz1:                   longint;
      begrenzer:                char;
      mlf:                      boolean;        {macro label found}

    BEGIN                       {PROCEDURE sb_pseudo}
      {
      Falls .NOP, .IF, .GOTO, oder .SET in 'include_file' auftauchen,
      gibts eine Fehlermeldung. von_wo=0: Aufruf von 'include_file'
      aus, von_wo=1: Aufruf von 'expand_macro' aus.
      }
      IF von_wo=0 THEN
        BEGIN
          CASE gwert OF
            14..17:             {es liegt .NOP, .IF, .GOTO, .SET vor}
              BEGIN
                fm('Dieser Opcode ist nur innerhalb eines Macros erlaubt',
                   zlboc[0],len[0]);
              END;              {CASE gwert OF 14..17}
            ELSE
              BEGIN
                {nichts}
              END;
          END;                  {CASE gwert}
        END;                    {IF von_wo=0}

      CASE gwert OF
        0:                      {ORG}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                check_len(3);
                wertlbl:=wandle(zlboc[3],len[3]) AND $ffffff;
                setze_anzeige(wertlbl,4);
                pcn:=wertlbl;
                pcs:=pcn;
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 0}
        1:                      {EQU}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                check_len(1);
                check_len(3);
                wertlbl:=wandle(zlboc[3],len[3]);
                setze_anzeige(wertlbl,8);
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 1}
        2:                      {SET/DEFL}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                check_len(1);
                check_len(3);
                wertlbl:=wandle(zlboc[3],len[3]);
                setze_anzeige(wertlbl,8);
                typlbl:=5;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 2}
        3:                      {DB}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                FOR i:=3 TO ozi+2 DO
                  BEGIN
                    IF len[i]>0 THEN
                      BEGIN
                        str_od_expr(zlboc[i],len[i],anz1,begrenzer);
                        pcn:=pcn+anz1;
                      END;      {IF len[i]>0}
                  END;          {FOR i}
                pcs:=pcn;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 3}
        4:                      {DS}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                check_len(3);
                pcn:=pcn + wandle(zlboc[3],len[3]);
                pcs:=pcn;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 4}
        5:                      {DW}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                FOR i:=3 TO ozi+2 DO
                  BEGIN
                    IF len[i]>0 THEN
                      BEGIN
                        pcn:=pcn+2;
                      END;      {IF len[i]>0}
                  END;          {FOR i}
                pcs:=pcn;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 5}
        6:                      {MACRO}
          BEGIN
            ier:=3;
            zb:='n';
            IF is[isp] THEN
              BEGIN
                zl_IF_true;
                IF mel>0 THEN fm('Geschachtelte Macro-definition',
                                 zlboc[0],len[0]);
                IF mcr=mzm THEN fm('mzm zu klein (Zu viele Macros)',
                                   zlboc[0],len[0]);
                mcr:=mcr+1;
                wertlbl:=mcr;
                setze_anzeige(wertlbl,2);
                typlbl:=2;
                ozslbl:=-1;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 6}
        7:                      {SKIP}
          BEGIN
            zb:='n';
            IF is[isp] THEN
              BEGIN
                zl_IF_true_skip_title;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zl_IF_false_skip_title;
              END;              {ELSE is[isp]}
          END;                  {CASE 7}
        8:                      {INCLUDE}
          BEGIN
            IF is[isp] THEN
              BEGIN
                ier:=1;
                zb:='j';
                zl_IF_true;
                fil:=fil+1;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                check_len(3);
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 8}
        9:                      {IF}
          BEGIN
            IF isp=islen THEN fm('islen zu klein (IF-stack-overflow)',
                                 zlboc[0],len[0]);
            isp:=isp+1;
            IF is[isp-1] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                check_len(3);
                IF wandle(zlboc[3],len[3])<>0 THEN is[isp]:=true
                ELSE is[isp]:=false;
              END               {IF is[isp-1]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
                is[isp]:=false;
              END;              {ELSE is[isp-1]}
          END;                  {CASE 9}
        10:                     {ELSE}
          BEGIN
            IF isp=0 THEN fm('ELSE ohne vohergehendes IF',
                             zlboc[0],len[0]);
            IF is[isp-1] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                is[isp]:=NOT is[isp];
              END               {IF is[isp-1]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp-1]}
          END;                  {CASE 10}
        11,12:                  {IFEND, ENDIF}
          BEGIN
            IF isp=0 THEN fm('IFEND oder ENDIF ohne vohergehendes IF',
                             zlboc[0],len[0]);
            isp:=isp-1;
            IF is[isp+1] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 11,12}
        13:                     {MEND}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                IF mel=0 THEN fm('MEND ohne vorhergehendes MACRO/PMACRO',
                                 zlboc[0],len[0]);
                mend_da:=true;
                IF len[1]>0 THEN
                  BEGIN
                    wm('Label bei "MEND" wird ignoriert',
                       zlboc[0],len[0]);
                    IF (NOT ob_weitermachen) THEN anhalten;
                  END;          {IF len[1]>0}
              END;              {IF is[isp]}
          END;                  {CASE 13}
        14:                     {.NOP}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                wertlbl:=pc;
                typlbl:=6;
                coil;
              END;              {IF is[isp]}
          END;                  {CASE 14}
        15:                     {.IF}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                wertlbl:=pc;
                typlbl:=6;
                coil;
                check_len(3);
                check_len(4);
                IF wandle(zlboc[3],len[3])<>0 THEN
                  BEGIN
                    IF len[4]>max_cl+1 THEN fm('Macro-Label zu lang',zlboc[4],len[4]);
                    suche_label(mel,zlboc[4],len[4],i,mlf);
                    IF NOT mlf THEN fm('Macro-label nicht gefunden',
                                       zlboc[4],len[4]);
                    IF llt[mel]^.oft_ml[i] THEN
                      BEGIN
                        fm('Sprung nicht mglich (multiple Macro-Label)',
                           zlboc[4],len[4]);
                      END;
                    lzz:=llt[mel]^.zeil_nr_ml[i];
                  END;          {IF wandle ..}
              END;              {IF is[isp]}
          END;                  {CASE 15}
        16:                     {.GOTO}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                wertlbl:=pc;
                typlbl:=6;
                coil;
                check_len(3);
                IF len[3]>max_cl+1 THEN fm('Macro-Label zu lang',zlboc[3],len[3]);
                suche_label(mel,zlboc[3],len[3],i,mlf);
                IF NOT mlf THEN fm('Macro-label nicht gefunden',
                                   zlboc[3],len[3]);
                IF llt[mel]^.oft_ml[i] THEN
                  BEGIN
                    fm('Sprung nicht mglich (multiple Macro-Label)',
                           zlboc[3],len[3]);
                  END;
                lzz:=llt[mel]^.zeil_nr_ml[i];
              END;              {IF is[isp]}
          END;                  {CASE 16}
        17:                     {.SET}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                typlbl:=7;
                check_len(1);
                check_len(3);
                wertlbl:=wandle(zlboc[3],len[3]);
                coil;
              END;              {IF is[isp]}
          END;                  {CASE 17}
        18:                     {TITLE}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true_skip_title;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false_skip_title;
              END;              {ELSE is[isp]}
          END;                  {CASE 18}
        19:                     {NOLIST}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                list_state:=0;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 19}
        20:                     {LIST}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                list_state:=1;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 20}
        21:                     {EXPAND}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                list_state:=2;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 21}
        22,23,24,25,26:         {COMN, NAME, PROG, DATA, END}
          BEGIN
            zb:='n';
            IF is[isp] THEN
              BEGIN
                zl_IF_true;
                wertlbl:=pc;
                typlbl:=4;
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 22..26}
        27:                     {PMACRO}
          BEGIN
            ier:=5;
            zb:='n';
            IF is[isp] THEN
              BEGIN
                zl_IF_true;
                IF mel>0 THEN fm('Geschachtelte Macro-definition',
                                 zlboc[0],len[0]);
                IF mcr=mzm THEN fm('mzm zu klein (Zu viele Macros)',
                                   zlboc[0],len[0]);
                mcr:=mcr+1;
                wertlbl:=mcr;
                setze_anzeige(wertlbl,2);
                typlbl:=0;
                ozslbl:=wandle(zlboc[3],len[3]);
                coil;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 27}
        28:                     {PEQUATE}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                check_len(1);
                check_len(3);
                check_len(4);
                wertlbl:=wandle(zlboc[3],len[3]);
                typlbl:=wandle(zlboc[4],len[4]);
                IF typlbl=1 THEN
                  BEGIN
                    check_len(5);
                    ozslbl:=wandle(zlboc[5],len[5]);
                  END;          {IF typlbl=1}
                coil;
              END;              {IF is[isp]}
          END;                  {CASE 28}
        29:                     {PMEND}
          BEGIN
            zb:='n';
            zl:='n';
            IF is[isp] THEN
              BEGIN
                IF mel=0 THEN fm('PMEND ohne vorhergehendes MACRO/PMACRO',
                                 zlboc[0],len[0]);
                mend_da:=true;
                IF len[1]>0 THEN
                  BEGIN
                    wm('Label bei "MEND" wird ignoriert',
                       zlboc[0],len[0]);
                    IF (NOT ob_weitermachen) THEN anhalten;
                  END;          {IF len[1]>0}
              END;              {IF is[isp]}
          END;                  {CASE 29}
        30:                     {PINCLUDE}
          BEGIN
            IF is[isp] THEN
              BEGIN
                ier:=1;
                zb:='j';
                zl_IF_true;
                fil:=fil+1;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                check_len(3);
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 30}
        31:                     {DP}
          BEGIN
            IF is[isp] THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                wertlbl:=pc;
                setze_anzeige(wertlbl,4);
                typlbl:=4;
                coil;
                FOR i:=3 TO ozi+2 DO
                  BEGIN
                    IF len[i]>0 THEN
                      BEGIN
                        pcn:=pcn+3;
                      END;      {IF len[i]>0}
                  END;          {FOR i}
                pcs:=pcn;
              END               {IF is[isp]}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE is[isp]}
          END;                  {CASE 31}

      END;                      {CASE gwert}
    END;                        {PROCEDURE sb_pseudo}

  PROCEDURE sb_macro;
    BEGIN                       {PROCEDURE sb_macro}
      zb:='n';
      IF is[isp] THEN
        BEGIN
          ier:=2;
          zl_IF_true;
          mce:=mce+1;
          IF mel=max_mel THEN
            BEGIN
              fm('mel zu klein (Macros zu tief geschachtelt)',
                                 zlboc[0],len[0])
            END                 {IF mel=max_mel}
          ELSE mel:=mel+1;
          IF spitze_mel<mel THEN
            BEGIN
              spitze_mel:=mel;
              IF MaxAvail<SizeOf(llt[mel]^) THEN
                BEGIN
                  fm('Zu wenig Speicher (05)', zlboc[0],len[0]);
                END;
              new(llt[mel]);
            END;
          llt[mel]^.anz_ml:=0;
          wertlbl:=pc;
          setze_anzeige(wertlbl,4);
          typlbl:=4;
          coil;
        END                     {IF is[isp]}
      ELSE
        BEGIN
          zl_IF_false;
        END;                    {ELSE is[isp]}
    END;                        {PROCEDURE sb_macro}

  PROCEDURE sb_pmacro;
    BEGIN                       {PROCEDURE sb_pmacro}
      zb:='n';
      IF is[isp] THEN
        BEGIN
          ier:=4;
          zl_IF_true_pmacro;
          IF mel=max_mel THEN
            BEGIN
              fm('mel zu klein (Macros zu tief geschachtelt)',
                                 zlboc[0],len[0])
            END                 {IF mel=max_mel}
          ELSE mel:=mel+1;
          IF spitze_mel<mel THEN
            BEGIN
              spitze_mel:=mel;
              IF MaxAvail<SizeOf(llt[mel]^) THEN
                BEGIN
                  fm('Zu wenig Speicher (06)', zlboc[0],len[0]);
                END;
              new(llt[mel]);
            END;
          llt[mel]^.anz_ml:=0;
          wertlbl:=pc;
          setze_anzeige(wertlbl,4);
          typlbl:=4;
          coil;
        END                     {IF is[isp]}
      ELSE
        BEGIN
          zl_IF_false;
        END;                    {ELSE is[isp]}
    END;                        {PROCEDURE sb_pmacro}

  BEGIN                         {PROCEDURE suche_befehl}
    suche_name(nfb,zlboc[2],len[2],findex,iindex);
    IF findex=-1 THEN           {name nicht gefunden bei findex=-1}
      BEGIN
        IF is[isp] THEN fm('Befehlsname nicht gefunden',zlboc[2],len[2]);
      END
    ELSE
      BEGIN
        nf_sel:=(findex AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind:=findex AND max_gtnf;
        WITH nfb.nf[nf_sel]^[nf_ind]^ DO
          BEGIN
            gozs:=ozs;
            gwert:=wert;
            gnt:=nt;
            {
            Immer, wenn neue Namen in die Namensfelder eingetragen werden,
            mu auch ein Operandenzahlsollwert zugewiesen werden. Als Vor-
            einstellung nehmen wir die 0. Werden andere Werte bentigt,
            so wird dies individuell geregelt.
            }
            ozslbl:=0;

            CASE gnt OF
              0:        sb_pmacro;      {suche Pmacro_befehl}
              1:        sb_pseudo;      {suche Pseudo-befehl}
              2:
                BEGIN
                  {
                  Fr Macros pflegen wir die Querverweistabelle:
                  }
                  update_crr(zcrr, zeile);
                  sb_macro;     {suche Macro-befehl}
                END;            {CASE 2 OF gnt}
              ELSE
                BEGIN
                  fm('Unerwarteter CASE-Error in "suche_befehl"',
                     zlboc[0],len[0]);
                END;
            END;                {CASE gnt}
          END;                  {WITH nfb.nf[nf_sel]^[nf_ind]^}
      END;                      {ELSE findex=-1}
  END;                          {PROCEDURE suche_befehl}

PROCEDURE suche_pm_befehl(VAR gwert,pcn,typlbl,wertlbl,lzz:longint);
  VAR
    i:                          longint;
    mlf:                        boolean;        {macro label found}
    switch:                     longint;
    findex,iindex:              longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}

  BEGIN                         {PROCEDURE suche_pm_befehl}
    CASE zlboc[2,0] OF

      'b':
        BEGIN
          zb:='j';
          zl:='d';
          wertlbl:=pc;
          typlbl:=6;
          FOR i:=3 TO ozi+2 DO
            BEGIN
              IF len[i]>0 THEN
                BEGIN
                  pcn:=pcn+1;
                END;            {IF len[i]>0}
            END;                {FOR i}
        END;                    {CASE 'b'}

      'B':
        BEGIN
          mend_da:=true;
          zb:='j';
          zl:='e';
          wertlbl:=pc;
          typlbl:=6;
          FOR i:=3 TO ozi+2 DO
            BEGIN
              IF len[i]>0 THEN
                BEGIN
                  pcn:=pcn+1;
                END;            {IF len[i]>0}
            END;                {FOR i}
        END;                    {CASE 'B'}

      'w':
        BEGIN
          zb:='j';
          zl:='d';
          wertlbl:=pc;
          typlbl:=6;
          FOR i:=3 TO ozi+2 DO
            BEGIN
              IF len[i]>0 THEN
                BEGIN
                  pcn:=pcn+2;
                END;            {IF len[i]>0}
            END;                {FOR i}
        END;                    {CASE 'w'}

      'W':
        BEGIN
          mend_da:=true;
          zb:='j';
          zl:='e';
          wertlbl:=pc;
          typlbl:=6;
          FOR i:=3 TO ozi+2 DO
            BEGIN
              IF len[i]>0 THEN
                BEGIN
                  pcn:=pcn+2;
                END;            {IF len[i]>0}
            END;                {FOR i}
        END;                    {CASE 'W'}

      'n':
        BEGIN
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
        END;                    {CASE 'n'}

      'N':
        BEGIN
          mend_da:=true;
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
        END;                    {CASE 'N'}

      'i': 
        BEGIN
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
          check_len(3);
          check_len(4);
          IF wandle(zlboc[3],len[3])<>0 THEN
            BEGIN
              IF len[4]>max_cl+1 THEN mlf:=FALSE
              ELSE suche_label(mel,zlboc[4],len[4],i,mlf);
              IF NOT mlf THEN fm('PMacro-label nicht da/Befehlssyntax falsch(i)',
                                 zlboc[4],len[4]);
              IF llt[mel]^.oft_ml[i] THEN
                BEGIN
                  fm('Sprung nicht mglich (multiple PMacro-Label)',
                     zlboc[4],len[4]);
                END;
              lzz:=llt[mel]^.zeil_nr_ml[i];
            END;                {IF wandle ..}
        END;                    {CASE 'i'}

      'g': 
        BEGIN
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
          check_len(3);
          IF len[3]>max_cl+1 THEN mlf:=FALSE
          ELSE suche_label(mel,zlboc[3],len[3],i,mlf);
          {
          Falls das erste Ziel zu keinem gltigen Label fhrt, wird der
          default probiert:
          }
          IF NOT mlf THEN
            BEGIN
              check_len(4);
              IF len[4]>max_cl+1 THEN mlf:=FALSE
              ELSE suche_label(mel,zlboc[4],len[4],i,mlf);
              IF NOT mlf THEN fm('PMacro-label nicht da/Befehlssyntax falsch(g)',
                                 zlboc[0],len[0]);
              IF llt[mel]^.oft_ml[i] THEN
                BEGIN
                  fm('Sprung nicht mglich (multiple PMacro-Label)',
                     zlboc[4],len[4]);
                END;
            END                 {IF NOT mlf}
          ELSE
            BEGIN
              IF llt[mel]^.oft_ml[i] THEN
                BEGIN
                  fm('Sprung nicht mglich (multiple PMacro-Label)',
                     zlboc[3],len[3]);
                END;
            END;                {ELSE NOT mlf}
          lzz:=llt[mel]^.zeil_nr_ml[i];
        END;                    {CASE 'g'}

      's':
        BEGIN
          zb:='n';
          zl:='n';
          typlbl:=7;
          check_len(1);
          check_len(3);
          wertlbl:=wandle(zlboc[3],len[3]);
        END;                    {CASE 's'}

      'c':
        BEGIN
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
          check_len(3);
          switch:=wandle(zlboc[3],len[3]);
          IF ((switch<0) OR (switch>(ozi-3))) THEN
            BEGIN
              fm('Switch in CASE-Anweisung im Pmacro out of range',
                 zlboc[0],len[0]);
            END;                {IF ((switch..}

          check_len(switch+5);
          IF len[5]>max_cl+1 THEN mlf:=FALSE
          ELSE suche_label(mel,zlboc[switch+5],len[switch+5],i,mlf);

          {
          Falls der switch zu keinem gltigen Label fhrt, wird der
          default probiert:
          }
          IF NOT mlf THEN
            BEGIN
              check_len(4);
              IF len[4]>max_cl+1 THEN mlf:=FALSE
              ELSE suche_label(mel,zlboc[4],len[4],i,mlf);
              IF NOT mlf THEN fm('PMacro-label nicht da/Befehlssyntax falsch(c)',
                                 zlboc[0],len[0]);
              IF llt[mel]^.oft_ml[i] THEN
                BEGIN
                  fm('Sprung nicht mglich (multiple PMacro-Label)',
                     zlboc[4],len[4]);
                END;
            END                 {IF NOT mlf}
          ELSE
            BEGIN
              IF llt[mel]^.oft_ml[i] THEN
                BEGIN
                  fm('Sprung nicht mglich (multiple PMacro-Label)',
                     zlboc[switch+5],len[switch+5]);
                END;
            END;                {ELSE NOT mlf}
          lzz:=llt[mel]^.zeil_nr_ml[i];
        END;                    {CASE 'c'}

      'a':
        BEGIN
          zb:='n';
          zl:='n';
          typlbl:=7;
          check_len(1);
          check_len(3);
          wertlbl:=ausdr_typ(zlboc[3],len[3]);
        END;                    {CASE 'a'}

      'f':
        BEGIN
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
          fm1(zlboc[3],len[3]);
        END;                    {CASE 'f'}

      '_':                      {PMACRO}
        {
        Damit wir speziell bei Z180 'LD' eine bessere Performance bekommen,
        mssen wir die Mglichkeit haben, innerhalb eines Pmacros weitere
        Pmacros aufrufen zu knnen. Wir lassen diese 'Sub-Pmacros' mit '_'
        beginnen. Weil wir aber auch den Wert brauchen, mssen wir
        'suche_name' doch aufrufen.
        }
        BEGIN
          suche_name(nfb,zlboc[2],len[2],findex,iindex);
          IF findex=-1 THEN     {name nicht gefunden bei findex=-1}
            BEGIN
              IF is[isp] THEN fm('Befehlsname nicht gefunden',zlboc[2],len[2]);
            END
          ELSE
            BEGIN
              nf_sel:=(findex AND (NOT max_gtnf)) SHR mgtnfb;
              nf_ind:=findex AND max_gtnf;
              WITH nfb.nf[nf_sel]^[nf_ind]^ DO
                BEGIN
                  gwert:=wert;
                END;            {WITH nfb.nf[nf_sel]^[nf_ind]^}
            END;                {ELSE findex=-1}
          zb:='n';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
          ier:=4;
          IF mel=max_mel THEN
            BEGIN
              fm('mel zu klein (Macros zu tief geschachtelt)',
                                 zlboc[0],len[0])
            END                 {IF mel=max_mel}
          ELSE mel:=mel+1;
          IF spitze_mel<mel THEN
            BEGIN
              spitze_mel:=mel;
              IF MaxAvail<SizeOf(llt[mel]^) THEN
                BEGIN
                  fm('Zu wenig Speicher (07)', zlboc[0],len[0]);
                END;
              new(llt[mel]);
            END;
          llt[mel]^.anz_ml:=0;
        END;                    {CASE '_' (PMACRO)}

      'p':
        BEGIN
          zb:='j';
          zl:='n';
          wertlbl:=pc;
          typlbl:=6;
        END;                    {CASE 'p'}

      ELSE
        BEGIN
          fm('Unbekannter Pmacro-befehl',
             zlboc[2],len[2]);
        END;                    {CASE ELSE}

    END;                        {CASE zlboc[2,0]}
  END;                          {PROCEDURE suche_pm_befehl}

PROCEDURE erster_lauf;
  VAR
    din:                        bfrr;
    znrs:                       krznt;          {Zeilen-nummer-string}
    znrdum:                     krznt;          {Zeilen-nummer dummy}
    zeiltmp:                    longint;        {temporre Zeilen-nr}
    zdiva:                      longint;        {Zeile DIV alt}

  PROCEDURE fixiere_loc_var;
    VAR
      i,j:                      longint;
      ffeld:                    sftyp;          {"fixiertes" Feld}
      fflen:                    longint;        {Lnge von ffeld}
      loc_var_gef:              boolean;        {loc. Var. gefunden}
    BEGIN                       {PROCEDURE fixiere_loc_var}
      loc_var_gef:=false;
      fflen:=0;

      FOR i:=1 TO 2 DO          {erst mal Label und Befehl bernehmen}
        BEGIN
          FOR j:=0 TO len[i]-1 DO
            BEGIN
              ffeld[fflen]:=zlboc[i,j];
              fflen:=fflen+1;
            END;
          IF fflen>flen THEN
            BEGIN
              fm('Zeile bei fixiere_loc_var zu lang geworden',ffeld,flen);
            END;
          ffeld[fflen]:=' ';
          fflen:=fflen+1;
        END;                    {FOR i}

      FOR i:=3 TO ozi+2 DO      {dann die restlichen Operanden}
        BEGIN
          suche_loc_var(zlboc[i],len[i],ffeld,fflen,loc_var_gef);
          IF (i<(ozi+2)) THEN   {Komma nur schreiben, wenn kein Operand}
            BEGIN               {mehr folgt}
              IF fflen>flen THEN
                BEGIN
                  fm('Zeile bei fixiere_loc_var zu lang geworden',ffeld,flen);
                END;
              ffeld[fflen]:=',';
              fflen:=fflen+1;
            END;                {IF i}
        END;                    {FOR i}

      IF loc_var_gef THEN
        BEGIN
          zlboc[0]:=ffeld;
          len[0]:=fflen;
        END;
    END;                        {PROCEDURE fixiere_loc_var}

  PROCEDURE ersetze_parameter(VAR mne,lmce:longint;
                              VAR llen:tlen;VAR lzlboc:tzlboc);
    VAR
      mces:                     krznt;          {mce-string}
      i_loc_zeil,o_loc_zeil:    sftyp;
      i_loc_zeil_len:           longint;
      o_loc_zeil_len:           longint;
      izc,ozc,icc:              longint;        {input/output/Zeilen/}
                                                {character-count}
      ind1:                     longint;
      maca_sel, maca_ind:       word;           {Macro array selector, -index}
      lcc:                      longint;        {label character count}
      i:                        longint;
      parf:                     sftyp;          {Parameter-feld}
      lblf:                     sftyp;          {Label-feld}
      par_ind:                  longint;        {Parameter-index}
      aktiv:                    longint;        {0:Grundmodus, 1:nach erstem}
                                                {&, 2:nach zweitem &, 3:nach}
                                                {drittem &, 4:Konstante les.}
      ch:                       char;
      nr:                       longint;        {Nummer}
      mlf:                      boolean;        {macro label found}
      zstart:                   longint;        {Zeilenstart}

    PROCEDURE neues_zeichen;
      VAR
        i:                      longint;

      PROCEDURE trag_ein_param;
        VAR
          par_nr,i:             longint;
        BEGIN
          par_nr:=wandle(parf,par_ind);
          IF ((par_nr<1) OR (par_nr>(al-3))) THEN
            BEGIN
              fm('Parameter-nummer out of range',i_loc_zeil,i_loc_zeil_len);
            END;
          IF llen[par_nr+2]=0 THEN
            BEGIN
              IF o_loc_zeil_len>flen THEN
                BEGIN
                  fm('Zeile bei ersetze_parameter zu lang geworden',
                      o_loc_zeil,flen);
                END;
              o_loc_zeil[o_loc_zeil_len]:=chr(39);      {2 mal Hochkomma,}
              o_loc_zeil_len:=o_loc_zeil_len+1;         {wenn bergebener}
              IF o_loc_zeil_len>flen THEN               {Parameter Lnge}
                BEGIN                                   {0 hat}
                  fm('Zeile bei ersetze_parameter zu lang geworden',
                      o_loc_zeil,flen);
                END;
              o_loc_zeil[o_loc_zeil_len]:=chr(39);
              o_loc_zeil_len:=o_loc_zeil_len+1;
            END
          ELSE
            BEGIN
              FOR i:=0 TO llen[par_nr+2]-1 DO
                BEGIN
                  IF o_loc_zeil_len>flen THEN
                    BEGIN
                      fm('Zeile bei ersetze_parameter zu lang geworden',
                          o_loc_zeil,flen);
                    END;
                  o_loc_zeil[o_loc_zeil_len]:=lzlboc[par_nr+2,i];
                  o_loc_zeil_len:=o_loc_zeil_len+1;
                END;
            END;
        END;                    {PROCEDURE trag_ein_param}

      BEGIN                     {PROCEDURE neues_zeichen}
        CASE aktiv OF
          0:                    {Grundmodus}
            BEGIN
              CASE ch OF
                '&':
                  BEGIN
                    aktiv:=1;   {erstes & gelesen}
                  END;
                ELSE
                  BEGIN
                    IF o_loc_zeil_len>flen THEN
                      BEGIN
                        fm('Zeile bei ersetze_parameter zu lang geworden',
                            o_loc_zeil,flen);
                      END;
                    o_loc_zeil[o_loc_zeil_len]:=ch;
                    o_loc_zeil_len:=o_loc_zeil_len+1;
                  END;
              END;              {CASE ch}
            END;                {CASE aktiv OF 0}

          1:                    {nach erstem &}
            BEGIN
              aktiv:=2;         {zweites & gelesen}
            END;                {CASE aktiv OF 1}

          2:                    {nach zweitem &}
            BEGIN
              CASE ch OF
                '&':
                  BEGIN
                    aktiv:=3;   {drittes & gelesen}
                  END;

                'A'..'Z':       {Variable liegt vor}
                  BEGIN
                    aktiv:=0;   {hier wird Variable bergangen}
                    IF o_loc_zeil_len>flen THEN
                      BEGIN
                        fm('Zeile bei ersetze_parameter zu lang geworden',
                            o_loc_zeil,flen);
                      END;
                    o_loc_zeil[o_loc_zeil_len]:='&';    {2 mal &}
                    o_loc_zeil_len:=o_loc_zeil_len+1;   {nach-}
                    IF o_loc_zeil_len>flen THEN
                      BEGIN
                        fm('Zeile bei ersetze_parameter zu lang geworden',
                            o_loc_zeil,flen);
                      END;
                    o_loc_zeil[o_loc_zeil_len]:='&';    {tra-}
                    o_loc_zeil_len:=o_loc_zeil_len+1;   {gen}
                    IF o_loc_zeil_len>flen THEN
                      BEGIN
                        fm('Zeile bei ersetze_parameter zu lang geworden',
                            o_loc_zeil,flen);
                      END;
                    o_loc_zeil[o_loc_zeil_len]:=ch;
                    o_loc_zeil_len:=o_loc_zeil_len+1;
                  END;

                '0'..'9':       {Konstante liegt vor}
                  BEGIN
                    par_ind:=0;
                    aktiv:=4;   {Konstante lesen}
                    parf[par_ind]:=ch;
                    par_ind:=par_ind+1;
                    IF icc=i_loc_zeil_len-1 THEN trag_ein_param;
                  END;

                ELSE
                  BEGIN
                    fm('Ungltiger Index-parameter',
                       i_loc_zeil,i_loc_zeil_len);
                  END;
              END;              {CASE ch}
            END;                {CASE aktiv OF 2}

          3:                    {nach drittem &}
            BEGIN
              aktiv:=0;         {wieder Grundmodus, viertes & gelesen}
              FOR i:=3 DOWNTO 0 DO
                BEGIN
                  IF o_loc_zeil_len>flen THEN
                    BEGIN
                      fm('Zeile bei ersetze_parameter zu lang geworden',
                          o_loc_zeil,flen);
                    END;
                  o_loc_zeil[o_loc_zeil_len]:=mces[i];
                  o_loc_zeil_len:=o_loc_zeil_len+1;
                END;
            END;                {CASE aktiv OF 3}

          4:                    {Konstante lesen}
            BEGIN
              IF ch IN ['0'..'9'] THEN
                BEGIN
                  parf[par_ind]:=ch;
                  par_ind:=par_ind+1;
                  IF icc=i_loc_zeil_len-1 THEN trag_ein_param;
                END
              ELSE
                BEGIN
                  trag_ein_param;
                  CASE ch OF
                    '&':
                      BEGIN
                        aktiv:=1;       {erstes & gelesen}
                      END;
                    ELSE
                      BEGIN
                        aktiv:=0;       {wieder Grundmodus}
                        IF o_loc_zeil_len>flen THEN
                          BEGIN
                            fm('Zeile bei ersetze_parameter zu lang geworden',
                                o_loc_zeil,flen);
                          END;
                        o_loc_zeil[o_loc_zeil_len]:=ch;
                        o_loc_zeil_len:=o_loc_zeil_len+1;
                      END;
                  END;          {CASE ch}
                END;
            END;                {CASE aktiv OF 4}
        END;                    {CASE aktiv}
      END;                      {PROCEDURE neues_zeichen}

    BEGIN                       {PROCEDURE ersetze_parameter}
      WITH llt[mel]^ DO
        BEGIN
          oft_ml[0]:=false;     {vorbes.: Label nicht mehrfach da}
          FOR i:=0 TO 3 DO      {string-const. fr qap bestimmen}
            BEGIN
              mces[i]:=h[lmce MOD 10];
              lmce:=lmce DIV 10;
            END;
          ozc:=0;
          {Schleife fr alle Zeilen des gelesenen Macros:}
          IF (mif[mne]-mif[mne-1]-2)>mzlema THEN
            BEGIN
              fm('mzlema zu klein (Zeilenzahl des Macros zu gro)',
                 zlboc[0],len[0]);
            END;
          FOR izc:=mif[mne-1]+1 TO mif[mne]-1 DO
            BEGIN

              i_loc_zeil_len:=mzs^[izc+1]-mzs^[izc];
              ind1:=mzs^[izc];
              FOR i:=0 TO i_loc_zeil_len-1 DO
                BEGIN
                  maca_sel:=((ind1+i) AND (NOT max_gtma)) SHR mgtmab;
                  maca_ind:= (ind1+i) AND max_gtma;
                  i_loc_zeil[i]:=ma[maca_sel]^[maca_ind];
                END;            {FOR i}

              aktiv:=0;         {Grundmodus}
              o_loc_zeil_len:=0;
              {qap und dap mit Konstanten ersetzen, dap mit Variablen}
              {belassen:}
              FOR icc:=0 TO i_loc_zeil_len-1 DO
                BEGIN
                  ch:=i_loc_zeil[icc];
                  neues_zeichen;
                END;
              {Falls Label da, wird es in die llt eingetragen:}
              IF o_loc_zeil_len>0 THEN
                BEGIN
                  IF o_loc_zeil[0] IN ['A'..'Z','_'] THEN
                    BEGIN
                      lblf[0]:=o_loc_zeil[0];
                      lcc:=1;
                      WHILE ((lcc<o_loc_zeil_len) AND
                             (o_loc_zeil[lcc] IN ['A'..'Z','a'..'z',
                                                  '_','0'..'9','[',']',
                                                  chr(39)])) DO
                        BEGIN
                          IF lcc>max_cl THEN
                            BEGIN
                              fm('Label zu lang',o_loc_zeil,o_loc_zeil_len);
                            END;
                          lblf[lcc]:=o_loc_zeil[lcc];
                          lcc:=lcc+1;
                        END;
                      {Wenn Lesevorgang fr Label beendet, wird erstmal}
                      {nachgesehen, ob's schon in der llt eingetragen ist,}
                      {wenn ja, wird oft_ml true gesetzt. Es erfogt nur}
                      {Eintrag, wenn Label noch nicht da war. Labels, die}
                      {noch & besitzen, werden hier grundstzlich nicht}
                      {bercksichtigt}
                      IF o_loc_zeil[lcc]<>'&' THEN
                        BEGIN
                          suche_label(mel,lblf,lcc,nr,mlf);
                          IF mlf THEN oft_ml[nr]:=true
                          ELSE
                            BEGIN
                              zeil_nr_ml[anz_ml]:=ozc;
                              FOR i:=0 TO lcc-1 DO
                                BEGIN
                                  name_ml[anz_ml,i]:=lblf[i];
                                END;
                              name_len_ml[anz_ml]:=lcc;
                              {gueltig_ml vorbesetzt: Label besitzt keinen}
                              {zugewiesenen Wert. Nur .SET kann Wert}
                              {zuweisen:}
                              gueltig_ml[anz_ml]:=false;
                              anz_ml:=anz_ml+1;
                              oft_ml[anz_ml]:=false;
                            END;  {ELSE mlf}
                        END;    {IF o_loc_zeil[lcc]<>'&'}
                    END;        {IF o_loc_zeil[0] IN}
                END;            {IF o_loc_zeil_len>0}

              IF ozc=0 THEN
                BEGIN
                  IF mel=1 THEN
                    BEGIN
                      zstart:=0;
                    END         {IF mel=1}
                  ELSE
                    BEGIN
                      zstart:=llt[mel-1]^.me;
                    END;        {ELSE mel=1}
                END             {IF ozc=0}
              ELSE
                BEGIN
                  zstart:=ze[ozc-1];
                END;            {ELSE ozc=0}

              IF ((zstart+o_loc_zeil_len-1) > mclema) THEN
                BEGIN
                  fm('mclema zu klein (Gesamt-endmacro-text zu gro)',
                     zlboc[0],len[0]);
                END;            {IF ((zstart...}

              ze[ozc]:=zstart+o_loc_zeil_len;
              FOR i:=0 TO o_loc_zeil_len-1 DO
                BEGIN
                  ema^[zstart+i]:=o_loc_zeil[i];
                END;            {FOR i}

              ozc:=ozc+1;
            END;                {FOR izc}
          me:=ze[ozc-1];
        END;                    {WITH llt[mel]^}
    END;                        {PROCEDURE ersetze_parameter}

  PROCEDURE include_file(VAR di:bfrr;fnu:string_255);
    forward;

  PROCEDURE expand_pmacro(mne,lmce:longint; llen:tlen; lzlboc:tzlboc);
    VAR
      i,pcn,typlbl,wertlbl:     longint;
      lzz:                      longint;        {lokaler Zeilenzhler}
      mnen:                     longint;        {Macro-nummer bei expand(neu)}
      nr:                       longint;        {Nummer}
      mlf:                      boolean;        {macro label found}
      wert:                     longint;

    BEGIN                       {PROCEDURE expand_pmacro}
      ersetze_parameter(mne,lmce,llen,lzlboc);
      mend_da:=false;
      lzz:=0;
      REPEAT
        zeile_expandieren(ozi,len,zlboc,llen,lzlboc,lzz,0);
        lzz:=lzz+1;

        aa:=aa_leer;            {Adreanzeige lschen}
        IF len[2]>0 THEN
          BEGIN
            pcn:=pc;
            suche_pm_befehl(wert,pcn,typlbl,wertlbl,lzz);
            IF len[1]>0 THEN
              BEGIN
                CASE typlbl OF
                  6:            {es liegt b,B,w,W,n,N,i,g,c,f,_,p vor}
                    BEGIN
                      {keine Aktion, da diese Labels macro-lokal sind,}
                      {schon in die llt eingetragen wurden aber keinen}
                      {durch s oder a zugewiesenen Wert erhalten}
                    END;        {CASE typlbl OF 6}
                  7:            {es liegt s, bzw a vor.}
                    BEGIN
                      WITH llt[mel]^ DO
                        BEGIN
                          suche_label(mel,zlboc[1],len[1],nr,mlf);
                          wert_ml[nr]:=wertlbl;
                          gueltig_ml[nr]:=true;
                        END;    {WITH llt[mel]^}
                    END;        {CASE typlbl OF 7}
                END;            {CASE typlbl}
              END;              {IF len[1]>0}
            pc:=pcn;
          END;                  {IF len[2]>0}

        IF ((zb='j') OR (zl IN ['j','p','d','e','q','L','F'])) THEN
          BEGIN
            FOR i:=7 DOWNTO 0 DO write(tmpw,aa[i]);
            write(tmpw,zb,zl);
            FOR i:=4 DOWNTO 0 DO write(tmpw,znrdum[i]);
            IF zb='j' THEN fixiere_loc_var;
            {
            zeige_zlboc(0,al);
            }
            schreibe_zlboc(tmpw,0,0);
            writeln(tmpw);
          END;

        CASE ier OF
          0:
            BEGIN
              {keine Aktion}
            END;                {CASE ier OF 0}

          4:                    {expand_pmacro}
            BEGIN
              ier:=0;
              mnen:=wert;
              expand_pmacro(mnen,mce,len,zlboc);
              mend_da:=false;
              mel:=mel-1;
              pcs:=pc;
            END;                {CASE ier OF 4}
        END;                    {CASE ier}
      UNTIL mend_da;
    END;                        {PROCEDURE expand_pmacro}

  PROCEDURE expand_macro(mne,lmce:longint;
                         llen:tlen; VAR lzlboc:tzlboc);
    CONST
      max_jump_back_cnt=1117;   {warum sollten wir nicht eine schne
                                 Primzahl nehmen?}
    VAR
      fname:                    string_255;
      i,pcn:                    longint;
      dincl:                    bfrr;
      lzz:                      longint;        {lokaler Zeilenzhler}
      lzz_alt:                  longint;        {alter lzz}
      jump_back_cnt:            longint;
      mnen:                     longint;        {Macro-nummer bei expand(neu)}
      wert:                     longint;
      iso:                      boolean;        {IF state old}
      lzzlboc:                  tzzlboc;        {lokaler Zeiger auf zlboc}

    BEGIN                       {PROCEDURE expand_macro}
      IF MaxAvail<SizeOf(lzzlboc^) THEN
        BEGIN
          fm('Zu wenig Speicher (08)', zlboc[0],len[0]);
        END;
      new(lzzlboc);
      lzzlboc^:=lzlboc;

      ersetze_parameter(mne,lmce,llen,lzzlboc^);
      mend_da:=false;
      lzz:=0;
      jump_back_cnt:=0;
      REPEAT
        iso:=is[isp];
        zeile_expandieren(ozi,len,zlboc,llen,lzzlboc^,lzz,1);
        lzz:=lzz+1;

        IF zdiva<>zeile DIV zdiva_div THEN
          BEGIN
            zdiva:=zeile DIV zdiva_div;
            report_status;
          END;

        aa:=aa_leer;            {Adreanzeige lschen}
        IF len[2]>0 THEN
          BEGIN
            pcn:=pc;
            lzz_alt:=lzz;
            suche_befehl(wert,pcn,lzz,1);
            IF lzz<lzz_alt THEN
              BEGIN
                jump_back_cnt:=jump_back_cnt+1;
                IF jump_back_cnt>=max_jump_back_cnt THEN
                  BEGIN
                    wm('Vielleicht Endlosschleife im Macro?',
                       zlboc[0],len[0]);
                    IF ob_weitermachen THEN jump_back_cnt:=0
                    ELSE anhalten;
                  END;          {IF jump_back_cnt...}
              END;              {IF lzz<=lzz_alt}
            IF iso THEN
              BEGIN
                pc:=pcn;
              END;              {IF iso}
          END                   {IF len[2]>0}
        ELSE
          BEGIN
            IF iso THEN
              BEGIN
                zb:='j';
                zl_IF_true;
                IF len[1]>0 THEN
                  BEGIN
                    insert_vmp(4,pc,0);
                    setze_anzeige(pc,4);
                  END;
              END               {IF iso}
            ELSE
              BEGIN
                zb:='n';
                zl_IF_false;
              END;              {ELSE iso}
          END;                  {ELSE len[2]>0}

        IF ((zb='j') OR (zl IN ['j','p','d','e','q','L','F'])) THEN
          BEGIN
            FOR i:=7 DOWNTO 0 DO write(tmpw,aa[i]);
            write(tmpw,zb,zl);
            FOR i:=4 DOWNTO 0 DO write(tmpw,znrdum[i]);
            IF ((zb='j') AND (ier<>1)) THEN fixiere_loc_var;
            {
            zeige_zlboc(0,al);
            }
            schreibe_zlboc(tmpw,0,0);
            writeln(tmpw);
          END;

        CASE ier OF
          0:
            BEGIN
              {keine Aktion}
            END;                {CASE ier OF 0}

          1:                    {include_file}
            BEGIN
              ier:=0;
              fname:='';
              FOR i:=0 TO len[3]-1 DO fname:=fname+zlboc[3,i];
              page;
              writeln;
              writeln;
              writeln('********        Erster Lauf        *******');
              writeln;
              writeln('File:           ',fname);
              writeln;
              report_status;
              include_file(dincl,fname);
              fil:=fil-1;
            END;                {CASE ier OF 1}

          2:                    {expand_macro}
            BEGIN
              ier:=0;
              mnen:=wert;
              expand_macro(mnen,mce,len,zlboc);
              mend_da:=false;
              mel:=mel-1;
            END;                {CASE ier OF 2}

          4:                    {expand_pmacro}
            BEGIN
              ier:=0;
              mnen:=wert;
              {
              Als wichtigste Aktion wird der Pmacro-Aufruf fr eine ggf.
              spter auszugebende Fehlermeldung global abgespeichert.
              }
              pm_len:=len[0];
              pm_zeile:=zlboc[0];
              expand_pmacro(mnen,mce,len,zlboc);
              mend_da:=false;
              mel:=mel-1;
              pcs:=pc;
            END;                {CASE ier OF 4}
        END;                    {CASE ier}
      UNTIL mend_da;
      dispose(lzzlboc);
    END;                        {PROCEDURE expand_macro}

  PROCEDURE include_file;
    VAR
      fname:                    string_255;
      i,pcn:                    longint;
      dincl:                    bfrr;
      lzz:                      longint;        {lokaler Zeilenzhler}
                                                {hier als dummy}
      mnen:                     longint;        {Macro-nummer bei expand(neu)}
      wert:                     longint;
      iso:                      boolean;        {IF state old}

    PROCEDURE lies_macro(mpd:longint);
      {mpd:     Macro-parameter-displacement}
      VAR
        lozi:                   longint;
        llen:                   tlen;
        lzlboc:                 tzlboc;
        mend_gefunden:          boolean;
        macro_gefunden:         boolean;
        minfo:                  sftyp;          {Macro-info}
        minfo_len:              longint;        {minfo-lnge}
        parf:                   sftyp;          {parameter-feld}
        par_ind:                longint;        {Parameter-index}
        daz:                    sftyp;          {double-ampersand-zeile}
        daz_len:                longint;        {daz-lnge}
        ind1:                   longint;        {Index 1}
        ind2:                   longint;        {Index 2}
        maca_sel, maca_ind:     word;           {Macro array selector, -index}
        aktiv:                  longint;        {0:Grundmodus, 1:nach erstem}
                                                {&, 2:nach zweitem &, 3:nach}
                                                {drittem &, 4:Parameter les.}
        ch:                     char;
        i:                      longint;

      PROCEDURE neues_zeichen;
        PROCEDURE suche_param;
          VAR
            i,par_nr:           longint;
            par_gefunden:       boolean;
          BEGIN
            par_nr:=3+mpd;
            par_gefunden:=false;
            WHILE ((par_nr<=ozi+2) AND (NOT par_gefunden)) DO
              BEGIN
                IF ((len[par_nr]-1)<>par_ind) THEN par_nr:=par_nr+1
                ELSE
                  BEGIN
                    par_gefunden:=true;
                    i:=0;
                    REPEAT
                      IF zlboc[par_nr,i+1]<>parf[i] THEN
                        BEGIN
                          par_gefunden:=false;
                          par_nr:=par_nr+1;
                        END
                      ELSE i:=i+1;
                    UNTIL ((NOT par_gefunden) OR (i=par_ind));
                  END;
              END;              {WHILE}
            IF par_gefunden THEN
              BEGIN
                IF daz_len>flen THEN
                  BEGIN
                    fm('Zeile bei lies_macro zu lang geworden',
                        daz,flen);
                  END;
                par_nr:=par_nr-2-mpd;
                daz[daz_len]:=h[par_nr DIV 10];
                daz_len:=daz_len+1;
                IF daz_len>flen THEN
                  BEGIN
                    fm('Zeile bei lies_macro zu lang geworden',
                        daz,flen);
                  END;
                daz[daz_len]:=h[par_nr MOD 10];
                daz_len:=daz_len+1;
              END
            ELSE fm('Macro-parameter nicht im header gefunden',
                    lzlboc[0],llen[0]);
          END;                  {PROCEDURE suche_param}

        BEGIN                   {PROCEDURE neues_zeichen}
          CASE aktiv OF
            0:                  {Grundmodus}
              BEGIN
                CASE ch OF
                  '&':
                    BEGIN
                      aktiv:=1; {erstes & gelesen}
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                      IF ind1=llen[0]-1 THEN fm('Zeile endet mit &',
                                                lzlboc[0],llen[0]);
                    END;
                  ELSE
                    BEGIN
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                    END;
                END;            {CASE ch}
              END;              {CASE aktiv OF 0}

            1:                  {nach erstem &}
              BEGIN
                CASE ch OF
                  '&':
                    BEGIN
                      aktiv:=2; {zweites & gelesen}
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                      IF ind1=llen[0]-1 THEN fm('Zeile endet mit &&',
                                                lzlboc[0],llen[0]);
                    END;
                  ELSE
                    BEGIN
                      par_ind:=0;
                      aktiv:=4; {Parameter lesen}
                      IF ch IN ['A'..'Z'] THEN
                        BEGIN
                          IF daz_len>flen THEN
                            BEGIN
                              fm('Zeile bei lies_macro zu lang geworden',
                                  daz,flen);
                            END;
                          daz[daz_len]:='&';    {weiteres & fr dap mit}
                          daz_len:=daz_len+1;   {Konstante schreiben}
                          parf[par_ind]:=ch;
                          par_ind:=par_ind+1;
                          IF ind1=llen[0]-1 THEN suche_param;
                        END
                      ELSE
                        BEGIN
                          fm('Nach ''&'' nur ''A''..''Z'' im Macro erlaubt',
                             lzlboc[0],llen[0]);
                        END;
                    END;        {ELSE}
                END;            {CASE ch}
              END;              {CASE aktiv OF 1}

            2:                  {nach zweitem &}
              BEGIN
                CASE ch OF
                  '&':
                    BEGIN
                      aktiv:=3; {drittes & gelesen}
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                      IF ind1=llen[0]-1 THEN fm('Zeile endet mit &&&',
                                                lzlboc[0],llen[0]);
                    END;
                  ELSE
                    BEGIN
                      aktiv:=0; {Grundmodus}
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                    END;
                END;            {CASE ch}
              END;              {CASE aktiv OF 2}

            3:                  {nach drittem &}
              BEGIN
                CASE ch OF
                  '&':
                    BEGIN
                      aktiv:=0; {wieder Grundmodus}
                      IF daz_len>flen THEN
                        BEGIN
                          fm('Zeile bei lies_macro zu lang geworden',
                              daz,flen);
                        END;
                      daz[daz_len]:=ch;
                      daz_len:=daz_len+1;
                    END;
                  ELSE
                    BEGIN
                      fm('Wir sagen: x&&&y nicht erlaubt',
                         lzlboc[0],llen[0]);
                    END;
                END;            {CASE ch}
              END;              {CASE aktiv OF 3}

            4:                  {Parameter lesen}
              BEGIN
                IF ch IN ['A'..'Z','a'..'z','_','0'..'9'] THEN
                  BEGIN
                    parf[par_ind]:=ch;
                    par_ind:=par_ind+1;
                    IF ind1=llen[0]-1 THEN suche_param;
                  END
                ELSE
                  BEGIN
                    suche_param;
                    CASE ch OF
                      '&':
                        BEGIN
                          aktiv:=1;     {erstes & gelesen}
                          IF daz_len>flen THEN
                            BEGIN
                              fm('Zeile bei lies_macro zu lang geworden',
                                  daz,flen);
                            END;
                          daz[daz_len]:=ch;
                          daz_len:=daz_len+1;
                          IF ind1=llen[0]-1 THEN fm('Zeile endet mit &',
                                                    lzlboc[0],llen[0]);
                        END;
                      ELSE
                        BEGIN
                          aktiv:=0;     {wieder Grundmodus}
                          IF daz_len>flen THEN
                            BEGIN
                              fm('Zeile bei lies_macro zu lang geworden',
                                  daz,flen);
                            END;
                          daz[daz_len]:=ch;
                          daz_len:=daz_len+1;
                        END;
                    END;        {CASE ch}
                  END;
              END;              {CASE aktiv OF 4}
          END;                  {CASE aktiv}
        END;                    {PROCEDURE neues_zeichen}

      BEGIN                     {PROCEDURE lies_macro}
        IF zzmr>mzlma THEN
          BEGIN
            fm('mzlma zu klein (Gesamtzeilenzahl aller Macros zu gro)',
               zlboc[0],len[0]);
          END;
        IF myeof(di) THEN fm('File-ende erreicht vor MEND (IF true)',
                             zlboc[0],len[0]);

        minfo[0]:=h[(mcr DIV 100) MOD 10];
        minfo[1]:=h[(mcr DIV 10) MOD 10];
        minfo[2]:=h[(mcr DIV 1) MOD 10];
        minfo[3]:=' ';
        minfo[4]:=':';
        minfo[5]:=' ';
        minfo[6]:=' ';
        minfo[7]:=' ';
        IF (len[0]+7)>flen THEN
          BEGIN
            fm('Zeile bei Macro-header-schreiben zu lang geworden',
                zlboc[0],len[0]);
          END;
        FOR i:=0 TO len[0]-1 DO minfo[i+8]:=zlboc[0,i];

        minfo_len:=len[0]+8;
        ima:=ima+minfo_len;     {Index Macro array aktualisieren}
        IF zzmr<mzlma THEN
          BEGIN                 {Nchster Macro-zeilen-start}
            mzs^[zzmr+1]:=ima;
          END;

{mcr + Macro-kopf fr Info-zwecke notieren:}

        ind2:=mzs^[zzmr];
        FOR i:=0 TO minfo_len-1 DO
          BEGIN
            maca_sel:=((ind2+i) AND (NOT max_gtma)) SHR mgtmab;
            maca_ind:= (ind2+i) AND max_gtma;
            {
            Falls maca_ind=0 gilt, mu ein neues Teil Macro array an-
            gelegt werden. Weil offenbar mindestens ein Byte Macrotext
            gelesen wird, brauchen wir uns nicht darum kmmern, da
            wir hier evtl. mehrfach vorbeikommen und fr den gleichen
            Selektor mehrfach ein Teil Macro array anlegen. Allerdings
            prfen wir, ob maca_sel nicht schon zu gro ist.
            }
            IF maca_ind=0 THEN
              BEGIN
                IF maca_sel > max_maca_sel THEN
                  BEGIN
                    fm('max_maca_sel zu klein (Gesamttext aller Macros zu gro)',
                       zlboc[0],len[0]);
                  END;          {IF maca_sel...}
                IF MaxAvail<SizeOf(ma[maca_sel]^) THEN
                  BEGIN
                    fm('Zu wenig Speicher (09)', zlboc[0],len[0]);
                  END;
                new(ma[maca_sel]);
              END;              {IF maca_ind=0}
            ma[maca_sel]^[maca_ind]:=minfo[i];
          END;                  {FOR i}

        zzmr:=zzmr+1;

        REPEAT
          IF fil=0 THEN
            BEGIN
              zeile:=zeile+1;
              zeiltmp:=zeile;
              FOR i:=0 TO 4 DO
                BEGIN
                  znrs[i]:=h[zeiltmp MOD 10];
                  zeiltmp:=zeiltmp DIV 10;
                END;
            END
          ELSE znrs:=znrdum;

          IF myeof(di) THEN fm('File-ende erreicht vor MEND (IF true)',
                               lzlboc[0],llen[0]);
          zeile_abgrasen(di,lozi,llen,lzlboc);

          IF zzmr>mzlma THEN
            BEGIN
              fm('mzlma zu klein (Gesamtzeilenzahl aller Macros zu gro)',
                 lzlboc[0],llen[0]);
            END;

          zb:='n';
          zl_IF_true;

          IF ((zb='j') OR (zl IN ['j','p','d','e','q','L','F'])) THEN
            BEGIN
              FOR i:=7 DOWNTO 0 DO write(tmpw,aa[i]);
              write(tmpw,zb,zl);
              FOR i:=4 DOWNTO 0 DO write(tmpw,znrs[i]);
              FOR i:=0 TO llen[0]-1 DO write(tmpw,lzlboc[0,i]);
              writeln(tmpw);
            END;
          {Sofort beim Lesen werden Macro-parameter mit einem & (sap=}
          {single ampersand parameter) in Macro-parameter mit zwei &}
          {(dap=double ampersand parameter) umgewandelt:}

          daz_len:=0;
          aktiv:=0;             {Grundmodus}
          FOR ind1:=0 TO llen[0]-1 DO
            BEGIN
              ch:=lzlboc[0,ind1];
              neues_zeichen;
            END;

          ima:=ima+daz_len;
          IF zzmr<mzlma THEN
            BEGIN               {Nchster Macro-zeilen-start}
              mzs^[zzmr+1]:=ima;
            END;

          ind2:=mzs^[zzmr];
          FOR i:=0 TO daz_len-1 DO
            BEGIN
              maca_sel:=((ind2+i) AND (NOT max_gtma)) SHR mgtmab;
              maca_ind:= (ind2+i) AND max_gtma;
              {
              Falls maca_ind=0 gilt, mu ein neues Teil Macro array an-
              gelegt werden. Weil offenbar mindestens ein Byte Macrotext
              gelesen wird, brauchen wir uns nicht darum kmmern, da
              wir hier evtl. mehrfach vorbeikommen und fr den gleichen
              Selektor mehrfach ein Teil Macro array anlegen. Allerdings
              prfen wir, ob maca_sel nicht schon zu gro ist.
              }
              IF maca_ind=0 THEN
                BEGIN
                  IF maca_sel > max_maca_sel THEN
                    BEGIN
                      fm('max_maca_sel zu klein (Gesamttext aller Macros zu gro)',
                         zlboc[0],len[0]);
                    END;        {IF maca_sel...}
                  IF MaxAvail<SizeOf(ma[maca_sel]^) THEN
                    BEGIN
                      fm('Zu wenig Speicher (10)', zlboc[0],len[0]);
                    END;
                  new(ma[maca_sel]);
                END;            {IF maca_ind=0}
              ma[maca_sel]^[maca_ind]:=daz[i];
            END;                {FOR i}

          zzmr:=zzmr+1;

          CASE mpd OF
            0:                  {MACRO liegt vor}
              BEGIN
                mend_gefunden:=((llen[2]=4) AND (lzlboc[2,0]='M') AND
                                (lzlboc[2,1]='E') AND (lzlboc[2,2]='N') AND
                                (lzlboc[2,3]='D'));
                macro_gefunden:=((llen[2]=5) AND (lzlboc[2,0]='M') AND
                                 (lzlboc[2,1]='A') AND (lzlboc[2,2]='C') AND
                                 (lzlboc[2,3]='R') AND (lzlboc[2,4]='O'));
                IF macro_gefunden THEN fm('Geschachtelte Macro-definition',
                                                    lzlboc[0],llen[0]);
              END;              {CASE 0}
            1:                  {PMACRO liegt vor}
              BEGIN
                mend_gefunden:=((llen[2]=5) AND (lzlboc[2,0]='P') AND
                                (lzlboc[2,1]='M') AND (lzlboc[2,2]='E') AND
                                (lzlboc[2,3]='N') AND (lzlboc[2,4]='D'));
              END;              {CASE 1}
          END;                  {CASE mpd}

        UNTIL mend_gefunden;
        mif[mcr]:=zzmr;         {Beginn nchsten Macro in mif eintragen}
      END;                      {PROCEDURE lies_macro}

    PROCEDURE skip_macro(mpd:longint);
      VAR
        i:                      longint;
        lozi:                   longint;
        llen:                   tlen;
        lzlboc:                 tzlboc;
        mend_gefunden:          boolean;
        macro_gefunden:         boolean;
      BEGIN
        IF myeof(di) THEN fm('File-ende erreicht vor MEND (IF false)',
                             zlboc[0],len[0]);
        REPEAT
          IF fil=0 THEN
            BEGIN
              zeile:=zeile+1;
              zeiltmp:=zeile;
              FOR i:=0 TO 4 DO
                BEGIN
                  znrs[i]:=h[zeiltmp MOD 10];
                  zeiltmp:=zeiltmp DIV 10;
                END;
            END
          ELSE znrs:=znrdum;

          IF myeof(di) THEN fm('File-ende erreicht vor MEND (IF false)',
                               lzlboc[0],llen[0]);

          zeile_abgrasen(di,lozi,llen,lzlboc);

          zb:='n';
          zl_IF_false;

          IF ((zb='j') OR (zl IN ['j','p','d','e','q','L','F'])) THEN
            BEGIN
              FOR i:=7 DOWNTO 0 DO write(tmpw,aa[i]);
              write(tmpw,zb,zl);
              FOR i:=4 DOWNTO 0 DO write(tmpw,znrs[i]);
              FOR i:=0 TO llen[0]-1 DO write(tmpw,lzlboc[0,i]);
              writeln(tmpw);
            END;

          CASE mpd OF
            0:                  {MACRO liegt vor}
              BEGIN
                mend_gefunden:=((llen[2]=4) AND (lzlboc[2,0]='M') AND
                                (lzlboc[2,1]='E') AND (lzlboc[2,2]='N') AND
                                (lzlboc[2,3]='D'));
                macro_gefunden:=((llen[2]=5) AND (lzlboc[2,0]='M') AND
                                 (lzlboc[2,1]='A') AND (lzlboc[2,2]='C') AND
                                 (lzlboc[2,3]='R') AND (lzlboc[2,4]='O'));
                IF macro_gefunden THEN fm('Geschachtelte Macro-definition',
                                                    lzlboc[0],llen[0]);
              END;              {CASE 0}
            1:                  {PMACRO liegt vor}
              BEGIN
                mend_gefunden:=((llen[2]=5) AND (lzlboc[2,0]='P') AND
                                (lzlboc[2,1]='M') AND (lzlboc[2,2]='E') AND
                                (lzlboc[2,3]='N') AND (lzlboc[2,4]='D'));
              END;              {CASE 1}
          END;                  {CASE mpd}
        UNTIL mend_gefunden;
      END;                      {PROCEDURE skip_macro}

    BEGIN                       {PROCEDURE include_file}
      IF NOT file_existiert(fnu) THEN
        BEGIN
          fm('Gewnschtes File kann nicht geffnet werden',
             zlboc[0],len[0]);
        END;                    {IF NOT ...}
      assign(di.bfr,fnu);
      myreset(di);

      WHILE NOT myeof(di) DO
        BEGIN
          iso:=is[isp];

          IF ((fil=0) AND (mel=0)) THEN zeile:=zeile+1;
          IF fil=0 THEN
            BEGIN
              zeiltmp:=zeile;
              FOR i:=0 TO 4 DO
                BEGIN
                  znrs[i]:=h[zeiltmp MOD 10];
                  zeiltmp:=zeiltmp DIV 10;
                END;
            END
          ELSE znrs:=znrdum;

          zeile_abgrasen(di,ozi,len,zlboc);
          IF zdiva<>zeile DIV zdiva_div THEN
            BEGIN
              zdiva:=zeile DIV zdiva_div;
              report_status;
            END;

          aa:=aa_leer;                  {Adreanzeige lschen}
          IF len[2]>0 THEN
            BEGIN
              pcn:=pc;
              suche_befehl(wert,pcn,lzz,0);
                {lzz hier dummy}

              IF iso THEN
                BEGIN
                  pc:=pcn;
                END;            {IF iso}
            END                 {IF len[2]>0}
          ELSE
            BEGIN
              IF iso THEN
                BEGIN
                  zb:='j';
                  zl_IF_true;
                  IF len[1]>0 THEN
                    BEGIN
                      insert_vmp(4,pc,0);
                      setze_anzeige(pc,4);
                    END;
                END             {IF iso}
              ELSE
                BEGIN
                  zb:='n';
                  zl_IF_false;
                END;            {ELSE iso}
            END;                {ELSE len[2]>0}

          IF ((zb='j') OR (zl IN ['j','p','d','e','q','L','F'])) THEN
            BEGIN
              FOR i:=7 DOWNTO 0 DO write(tmpw,aa[i]);
              write(tmpw,zb,zl);
              FOR i:=4 DOWNTO 0 DO write(tmpw,znrs[i]);
              IF ((mel>0) AND (zb='j') AND (ier<>1)) THEN fixiere_loc_var;
              {
              zeige_zlboc(0,al);
              }
              schreibe_zlboc(tmpw,0,0);
              writeln(tmpw);
            END;

          CASE ier OF
            0:
              BEGIN
                {keine Aktion}
              END;              {CASE ier OF 0}

            1:                  {include_file}
              BEGIN
                ier:=0;

                fname:='';
                FOR i:=0 TO len[3]-1 DO fname:=fname+zlboc[3,i];
                page;
                writeln;
                writeln;
                writeln('********        Erster Lauf        *******');
                writeln;
                writeln('File:           ',fname);
                writeln;
                report_status;
                include_file(dincl,fname);
                fil:=fil-1;
                page;
                writeln;
                writeln;
                writeln('********        Erster Lauf        *******');
                writeln;
                writeln('File:           ',fnu);
                writeln;
                report_status;
              END;              {CASE ier OF 1}

            2:                  {expand_macro}
              BEGIN
                ier:=0;
                mnen:=wert;
                expand_macro(mnen,mce,len,zlboc);
                mend_da:=false;
                mel:=mel-1;
              END;              {CASE ier OF 2}

            3:                  {lies/skip_macro fr MACRO}
              BEGIN
                ier:=0;
                IF is[isp] THEN
                  BEGIN
                    check_len(1);
                    lies_macro(0);
                  END
                ELSE skip_macro(0);
              END;              {CASE ier OF 3}

            4:                  {expand_pmacro}
              BEGIN
                ier:=0;
                mnen:=wert;
                {
                Als wichtigste Aktion wird der Pmacro-Aufruf fr eine ggf.
                spter auszugebende Fehlermeldung global abgespeichert.
                }
                pm_len:=len[0];
                pm_zeile:=zlboc[0];
                expand_pmacro(mnen,mce,len,zlboc);
                mend_da:=false;
                mel:=mel-1;
                pcs:=pc;
              END;              {CASE ier OF 4}

            5:                  {lies/skip_macro fr PMACRO}
              BEGIN
                ier:=0;
                IF is[isp] THEN
                  BEGIN
                    check_len(1);
                    lies_macro(1);
                  END
                ELSE skip_macro(1);
              END;              {CASE ier OF 5}

          END;                  {CASE ier}
        END;                    {WHILE NOT myeof(di)}
      close(di.bfr);
    END;                        {PROCEDURE include_file}

  BEGIN                         {PROCEDURE erster_lauf}
    pc:=0;                      {program counter}
    pcs:=0;                     {program counter 'step'}
    isp:=0;                     {IF stack pointer}
    is[isp]:=true;
    mel:=0;                     {macro expand level}
    spitze_mel:=0;              {grtes aufgetretenes mel}
    fil:=0;                     {file include level}
    ier:=0;                     {include/expand/(macro-)read(-flag)}
    list_state:=1;
    znrdum[0]:='+';
    znrdum[1]:=' ';
    znrdum[2]:=' ';
    znrdum[3]:=' ';
    znrdum[4]:=' ';
    zdiva:=0;                   {zeile DIV alt rcksetzen}
    assign(tmpw,fname_tmp);
    rewrite(tmpw);
    tmpw_open:=true;
    page;
    writeln;
    writeln;
    writeln('********        Erster Lauf        *******');
    writeln;
    writeln('File:           ',fname_usp);
    writeln;
    report_status;
    include_file(din,fname_usp);

    writeln(tmpw,'        nn    +');
    write(tmpw,'        nn    +;  spitze_mel: ');
    writeln(tmpw,spitze_mel:6);
    write(tmpw,'        nn    +;         ima: ');
    writeln(tmpw,ima:6);

    close(tmpw);
    tmpw_open:=false;
    IF isp>0 THEN fm('mehr IFs als ENDIF bzw IFEND',zlboc[0],len[0]);
  END;                          {PROCEDURE erster_lauf}

END.                            {UNIT zss3u1}

